#Region
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#EndRegion
Opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)
Opt("MouseCoordMode", 2)
Opt("PixelCoordMode", 0)
Opt("WinTitleMatchMode", 3)
#RequireAdmin
#NoTrayIcon

Func _singleton($soccurencename, $iflag = 0)
	Local Const $error_already_exists = 183
	Local Const $security_descriptor_revision = 1
	Local $psecurityattributes = 0
	Local Const $tagsecurity_attributes = "dword Length;ptr Descriptor;bool InheritHandle"
	If BitAND($iflag, 2) Then
		Local $tsecuritydescriptor = DllStructCreate("dword[5]")
		Local $psecuritydescriptor = DllStructGetPtr($tsecuritydescriptor)
		Local $aret = DllCall("advapi32.dll", "bool", "InitializeSecurityDescriptor", "ptr", $psecuritydescriptor, "dword", $security_descriptor_revision)
		If @error Then Return SetError(@error, @extended, 0)
		If $aret[0] Then
			$aret = DllCall("advapi32.dll", "bool", "SetSecurityDescriptorDacl", "ptr", $psecuritydescriptor, "bool", 1, "ptr", 0, "bool", 0)
			If @error Then Return SetError(@error, @extended, 0)
			If $aret[0] Then
				Local $structsecurityattributes = DllStructCreate($tagsecurity_attributes)
				DllStructSetData($structsecurityattributes, 1, DllStructGetSize($structsecurityattributes))
				DllStructSetData($structsecurityattributes, 2, $psecuritydescriptor)
				DllStructSetData($structsecurityattributes, 3, 0)
				$psecurityattributes = DllStructGetPtr($structsecurityattributes)
			EndIf
		EndIf
	EndIf
	Local $handle = DllCall("kernel32.dll", "handle", "CreateMutexW", "ptr", $psecurityattributes, "bool", 1, "wstr", $soccurencename)
	If @error Then Return SetError(@error, @extended, 0)
	Local $lasterror = DllCall("kernel32.dll", "dword", "GetLastError")
	If @error Then Return SetError(@error, @extended, 0)
	If $lasterror[0] = $error_already_exists Then
		If BitAND($iflag, 1) Then
			Return SetError($lasterror[0], $lasterror[0], 0)
		Else
			Exit  - 1
		EndIf
	EndIf
	Return $handle[0]
EndFunc

Func get_client_window_handle()
	Local $windowlist
	Local $window_selected = False
	$windowlist = WinList("AION Client")
	If $windowlist[0][0] = 0 Then
		MsgBox(48, "Error", "The game client is not running, or its window was not found.")
		Exit
	EndIf
	If $windowlist[0][0] = 1 Then
		Return $windowlist[1][1]
		If _singleton(@ScriptName, 1) = 0 Then
			MsgBox(48, "", "The program is already running and you have only 1 game client open. Using multiple instances of this software with a single game client is a bad idea!")
			Exit
		EndIf
	EndIf
	If $windowlist[0][0] > 1 Then
		For $i = 1 To $windowlist[0][0]
			WinActivate($windowlist[$i][1])
			$window_selected = client_window_selection($windowlist[$i][1])
			If $window_selected Then
				Return $windowlist[$i][1]
			EndIf
		Next
	EndIf
	MsgBox(48, "", "You didnt select any client window, the program will now exit.")
	Exit
EndFunc

Func client_window_not_found()
	Local $exit_question
	Local $yes = 6
	Local $no = 7
	Local $window_name
	Local $windowlist
	$exit_question = MsgBox(52, "Error", "The client is not running, or its window was not found." & @CRLF & @CRLF & "Press Yes to exit, or No to set the window name.")
	If $exit_question = $yes Then Exit
	If $exit_question = $no Then
		$window_name = InputBox("Client name", "Please enter the client window name you want to use:", "", "", 300, 130)
		If $window_name = "" Then
			Exit
		Else
			$windowlist = WinList($window_name)
			If $windowlist[0][0] = 0 Then
				MsgBox(48, "", "The game client window was still not found, exiting.")
				Exit
			Else
				Return $windowlist
			EndIf
		EndIf
	EndIf
EndFunc

Func client_window_selection($window_hndl)
	Local $windowpos
	Local $frm_form
	Local $lbl_lbl
	Local $btn_yes
	Local $btn_no
	Local $nmsg
	Local $result
	$windowpos = WinGetPos($window_hndl)
	$frm_form = GUICreate("", 200, 70, $windowpos[0] + $windowpos[2] / 2 + 100, $windowpos[1] + $windowpos[3] / 2 + 35)
	$lbl_lbl = GUICtrlCreateLabel("Is this the window you want to use?", 10, 10, 180, 15, 1)
	$btn_yes = GUICtrlCreateButton("Yes", 20, 35, 70, 25)
	$btn_no = GUICtrlCreateButton("No", 110, 35, 70, 25)
	GUISetState(@SW_SHOW, $frm_form)
	Sleep(100)
	WinActivate($frm_form)
	Opt("GUIOnEventMode", 0)
	While True
		$nmsg = GUIGetMsg()
		If $nmsg = $btn_yes Then
			$result = True
			ExitLoop
		EndIf
		If $nmsg = $btn_no Then
			$result = False
			ExitLoop
		EndIf
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($frm_form)
	Return $result
EndFunc

Global $_common_kernel32dll = DllOpen("kernel32.dll")

Func _processgetmodulebaseaddress($vprocessid, $smodulename, $blist32bitmods = False, $bgetwow64instance = False)
	Local $i = 0, $amodlist
	If NOT $blist32bitmods Then $i = 4
	$amodlist = _processlistmodules($vprocessid, $smodulename, $i, $blist32bitmods)
	If @error Then Return SetError(@error, @extended, -1)
	If $amodlist[0][0] = 0 Then Return SetError(-1, 0, -1)
	If $amodlist[0][0] > 1 Then
		If $blist32bitmods AND $bgetwow64instance Then Return SetExtended($amodlist[2][4], $amodlist[2][3])
		SetError(-16)
	EndIf
	Return SetError(@error, $amodlist[1][4], $amodlist[1][3])
EndFunc

Func _processlistmodules($vprocessid, $stitlefilter = 0, $ititlematchmode = 0, $blist32bitmods = False)
	If NOT __pfenforcepid($vprocessid) Then Return SetError(1, 0, "")
	Local $htlhlp, $aret, $stitle, $bmatchmade = 1, $itotal = 0, $bmatch1 = 0, $iarrsz = 40, $ineg = 0
	If $stitlefilter = "" Then $stitlefilter = 0
	If BitAND($ititlematchmode, 8) Then
		$ineg = -1
	ElseIf BitAND($ititlematchmode, 4) AND IsString($stitlefilter) Then
		$iarrsz = 1
		$bmatch1 = 1
	EndIf
	$ititlematchmode = BitAND($ititlematchmode, 3)
	Dim $amodules[$iarrsz + 1][6]
	Local $stmodentry = DllStructCreate("dword;dword;dword;dword;dword;ptr;dword;handle;wchar[256];wchar[260]"), $pmepointer = DllStructGetPtr($stmodentry)
	DllStructSetData($stmodentry, 1, DllStructGetSize($stmodentry))
	If $blist32bitmods Then
		$htlhlp = __pfcreatetoolhelp32snapshot($vprocessid, 24)
	Else
		$htlhlp = __pfcreatetoolhelp32snapshot($vprocessid, 8)
	EndIf
	If @error Then Return SetError(@error, @extended, "")
	$aret = DllCall($_common_kernel32dll, "bool", "Module32FirstW", "handle", $htlhlp, "ptr", $pmepointer)
	While 1
		If @error Then
			Local $ierr = @error
			__pfclosehandle($htlhlp)
			Return SetError(2, $ierr, "")
		EndIf
		If NOT $aret[0] Then ExitLoop
		$stitle = DllStructGetData($stmodentry, 9)
		If IsString($stitlefilter) Then
			Switch $ititlematchmode
				Case 0
					If $stitlefilter <> $stitle Then $bmatchmade = 0
				Case 1
					If StringInStr($stitle, $stitlefilter) = 0 Then $bmatchmade = 0
				Case Else
					If NOT StringRegExp($stitle, $stitlefilter) Then $bmatchmade = 0
			EndSwitch
			$bmatchmade += $ineg
		EndIf
		If $bmatchmade Then
			$itotal += 1
			If $itotal > $iarrsz Then
				$iarrsz += 10
				ReDim $amodules[$iarrsz + 1][6]
			EndIf
			$amodules[$itotal][0] = $stitle
			$amodules[$itotal][1] = DllStructGetData($stmodentry, 10)
			$amodules[$itotal][2] = DllStructGetData($stmodentry, 8)
			$amodules[$itotal][3] = DllStructGetData($stmodentry, 6)
			$amodules[$itotal][4] = DllStructGetData($stmodentry, 7)
			$amodules[$itotal][5] = DllStructGetData($stmodentry, 5)
			If $bmatch1 Then ExitLoop
		EndIf
		$bmatchmade = 1
		$aret = DllCall($_common_kernel32dll, "bool", "Module32NextW", "handle", $htlhlp, "ptr", $pmepointer)
	WEnd
	__pfclosehandle($htlhlp)
	ReDim $amodules[$itotal + 1][6]
	$amodules[0][0] = $itotal
	Return $amodules
EndFunc

Func __pfenforcepid(ByRef $vpid)
	If IsInt($vpid) Then Return True
	$vpid = ProcessExists($vpid)
	If $vpid Then Return True
	Return SetError(1, 0, False)
EndFunc

Func __pfclosehandle(ByRef $hhandle)
	If NOT IsPtr($hhandle) OR $hhandle = 0 Then Return SetError(1, 0, False)
	Local $aret = DllCall($_common_kernel32dll, "bool", "CloseHandle", "handle", $hhandle)
	If @error Then Return SetError(2, @error, False)
	If NOT $aret[0] Then Return SetError(3, @error, False)
	$hhandle = 0
	Return True
EndFunc

Func __pfcreatetoolhelp32snapshot($iprocessid, $iflags)
	Local $aret
	For $i = 1 To 10
		$aret = DllCall($_common_kernel32dll, "handle", "CreateToolhelp32Snapshot", "dword", $iflags, "dword", $iprocessid)
		If @error Then Return SetError(2, @error, -1)
		If $aret[0] = -1 Then
			If BitAND($iflags, 25) AND procfunc_winapi_getlasterror() = 24 Then ContinueLoop
			Return SetError(3, 0, -1)
		EndIf
		Sleep(0)
	Next
	If $aret[0] = -1 Then Return SetError(4, 0, -1)
	Return $aret[0]
EndFunc

Func procfunc_winapi_getlasterror($curerr = @error, $curext = @extended)
	Local $aresult = DllCall("kernel32.dll", "dword", "GetLastError")
	Return SetError($curerr, $curext, $aresult[0])
EndFunc

Func _memoryopen($iv_pid, $iv_desiredaccess = 2035711, $iv_inherithandle = 1)
	If NOT ProcessExists($iv_pid) Then
		SetError(1)
		Return 0
	EndIf
	Local $ah_handle[2] = [DllOpen("kernel32.dll")]
	If @error Then
		SetError(2)
		Return 0
	EndIf
	Local $av_openprocess = DllCall($ah_handle[0], "int", "OpenProcess", "int", $iv_desiredaccess, "int", $iv_inherithandle, "int", $iv_pid)
	If @error Then
		DllClose($ah_handle[0])
		SetError(3)
		Return 0
	EndIf
	$ah_handle[1] = $av_openprocess[0]
	Return $ah_handle
EndFunc

Func _memoryread($iv_address, $ah_handle, $sv_type = "dword")
	If NOT IsArray($ah_handle) Then
		SetError(1)
		Return 0
	EndIf
	Local $v_buffer = DllStructCreate($sv_type)
	If @error Then
		SetError(@error + 1)
		Return 0
	EndIf
	DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
	If NOT @error Then
		Local $v_value = DllStructGetData($v_buffer, 1)
		Return $v_value
	Else
		SetError(6)
		Return 0
	EndIf
EndFunc

Func _memorywrite($iv_address, $ah_handle, $v_data, $sv_type = "dword")
	If NOT IsArray($ah_handle) Then
		SetError(1)
		Return 0
	EndIf
	Local $v_buffer = DllStructCreate($sv_type)
	If @error Then
		SetError(@error + 1)
		Return 0
	Else
		DllStructSetData($v_buffer, 1, $v_data)
		If @error Then
			SetError(6)
			Return 0
		EndIf
	EndIf
	DllCall($ah_handle[0], "int", "WriteProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
	If NOT @error Then
		Return 1
	Else
		SetError(7)
		Return 0
	EndIf
EndFunc

Func _memoryclose($ah_handle)
	If NOT IsArray($ah_handle) Then
		SetError(1)
		Return 0
	EndIf
	DllCall($ah_handle[0], "int", "CloseHandle", "int", $ah_handle[1])
	If NOT @error Then
		DllClose($ah_handle[0])
		Return 1
	Else
		DllClose($ah_handle[0])
		SetError(2)
		Return 0
	EndIf
EndFunc

Func setprivilege($privilege, $benable)
	Const $_token_adjust_privileges = 32
	Const $_token_query = 8
	Const $_se_privilege_enabled = 2
	Local $htoken, $sp_auxret, $sp_ret, $hcurrprocess, $ntokens, $ntokenindex, $priv, $luid
	Local $token_privileges, $newtoken_privileges, $ret, $f
	$ntokens = 1
	$luid = DllStructCreate("dword;int")
	If IsArray($privilege) Then $ntokens = UBound($privilege)
	$token_privileges = DllStructCreate("dword;dword[" & (3 * $ntokens) & "]")
	$newtoken_privileges = DllStructCreate("dword;dword[" & (3 * $ntokens) & "]")
	$hcurrprocess = DllCall("kernel32.dll", "hwnd", "GetCurrentProcess")
	$sp_auxret = DllCall("advapi32.dll", "int", "OpenProcessToken", "hwnd", $hcurrprocess[0], "int", BitOR($_token_adjust_privileges, $_token_query), "int*", 0)
	If $sp_auxret[0] Then
		$htoken = $sp_auxret[3]
		DllStructSetData($token_privileges, 1, 1)
		$ntokenindex = 1
		While $ntokenindex <= $ntokens
			If IsArray($privilege) Then
				$priv = $privilege[$ntokenindex - 1]
			Else
				$priv = $privilege
			EndIf
			$ret = DllCall("advapi32.dll", "int", "LookupPrivilegeValue", "str", "", "str", $priv, "ptr", DllStructGetPtr($luid))
			If $ret[0] Then
				If $benable Then
					DllStructSetData($token_privileges, 2, $_se_privilege_enabled, (3 * $ntokenindex))
				Else
					DllStructSetData($token_privileges, 2, 0, (3 * $ntokenindex))
				EndIf
				DllStructSetData($token_privileges, 2, DllStructGetData($luid, 1), (3 * ($ntokenindex - 1)) + 1)
				DllStructSetData($token_privileges, 2, DllStructGetData($luid, 2), (3 * ($ntokenindex - 1)) + 2)
				DllStructSetData($luid, 1, 0)
				DllStructSetData($luid, 2, 0)
			EndIf
			$ntokenindex += 1
		WEnd
		$ret = DllCall("advapi32.dll", "int", "AdjustTokenPrivileges", "hwnd", $htoken, "int", 0, "ptr", DllStructGetPtr($token_privileges), "int", DllStructGetSize($newtoken_privileges), "ptr", DllStructGetPtr($newtoken_privileges), "int*", 0)
		$f = DllCall("kernel32.dll", "int", "GetLastError")
	EndIf
	$newtoken_privileges = 0
	$token_privileges = 0
	$luid = 0
	If $sp_auxret[0] = 0 Then Return 0
	$sp_auxret = DllCall("kernel32.dll", "int", "CloseHandle", "hwnd", $htoken)
	If NOT $ret[0] AND NOT $sp_auxret[0] Then Return 0
	Return $ret[0]
EndFunc

Func _memorypointerread($iv_address, $ah_handle, $av_offset, $sv_type = "dword")
	If IsArray($av_offset) Then
		If IsArray($ah_handle) Then
			Local $iv_pointercount = UBound($av_offset) - 1
		Else
			SetError(2)
			Return 0
		EndIf
	Else
		SetError(1)
		Return 0
	EndIf
	Local $iv_data[2], $i
	Local $v_buffer = DllStructCreate("dword")
	For $i = 0 To $iv_pointercount
		If $i = $iv_pointercount Then
			$v_buffer = DllStructCreate($sv_type)
			If @error Then
				SetError(@error + 2)
				Return 0
			EndIf
			$iv_address = "0x" & Hex($iv_data[1] + $av_offset[$i], 8)
			DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(7)
				Return 0
			EndIf
			$iv_data[1] = DllStructGetData($v_buffer, 1)
		ElseIf $i = 0 Then
			DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(7)
				Return 0
			EndIf
			$iv_data[1] = DllStructGetData($v_buffer, 1)
		Else
			$iv_address = "0x" & Hex($iv_data[1] + $av_offset[$i], 8)
			DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(7)
				Return 0
			EndIf
			$iv_data[1] = Int(DllStructGetData($v_buffer, 1))
		EndIf
	Next
	$iv_data[0] = $iv_address
	Return $iv_data
EndFunc

Func _memorypointerwrite($iv_address, $ah_handle, $av_offset, $v_data, $sv_type = "dword")
	If IsArray($av_offset) Then
		If IsArray($ah_handle) Then
			Local $iv_pointercount = UBound($av_offset) - 1
		Else
			SetError(2)
			Return 0
		EndIf
	Else
		SetError(1)
		Return 0
	EndIf
	Local $iv_structdata, $i
	Local $v_buffer = DllStructCreate("dword")
	For $i = 0 To $iv_pointercount
		If $i = $iv_pointercount Then
			$v_buffer = DllStructCreate($sv_type)
			If @error Then
				SetError(@error + 3)
				Return 0
			EndIf
			DllStructSetData($v_buffer, 1, $v_data)
			If @error Then
				SetError(8)
				Return 0
			EndIf
			$iv_address = "0x" & Hex($iv_structdata + $av_offset[$i], 8)
			DllCall($ah_handle[0], "int", "WriteProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(9)
				Return 0
			Else
				Return $iv_address
			EndIf
		ElseIf $i = 0 Then
			DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(3)
				Return 0
			EndIf
			$iv_structdata = DllStructGetData($v_buffer, 1)
		Else
			$iv_address = "0x" & Hex($iv_structdata + $av_offset[$i], 8)
			DllCall($ah_handle[0], "int", "ReadProcessMemory", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer), "int", "")
			If @error Then
				SetError(3)
				Return 0
			EndIf
			$iv_structdata = DllStructGetData($v_buffer, 1)
		EndIf
	Next
EndFunc

Func _memorygetbaseaddress($ah_handle, $ihexdec = 0)
	Local $iv_address = 1048576
	Local $v_buffer = DllStructCreate("dword;dword;dword;dword;dword;dword;dword")
	Local $vdata
	Local $vtype
	If NOT IsArray($ah_handle) Then
		SetError(1)
		Return 0
	EndIf
	DllCall($ah_handle[0], "int", "VirtualQueryEx", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer))
	If NOT @error Then
		$vdata = Hex(DllStructGetData($v_buffer, 2), 8)
		$vtype = Hex(DllStructGetData($v_buffer, 3), 8)
		While $vtype <> "00000080"
			DllCall($ah_handle[0], "int", "VirtualQueryEx", "int", $ah_handle[1], "int", $iv_address, "ptr", DllStructGetPtr($v_buffer), "int", DllStructGetSize($v_buffer))
			$vdata = Hex(DllStructGetData($v_buffer, 2), 8)
			$vtype = Hex(DllStructGetData($v_buffer, 3), 8)
			If Hex($iv_address, 8) = "01000000" Then ExitLoop
			$iv_address += 65536
		WEnd
		If $vtype = "00000080" Then
			SetError(0)
			If $ihexdec = 1 Then
				Return Dec($vdata)
			Else
				Return $vdata
			EndIf
		Else
			SetError(2)
			Return 0
		EndIf
	Else
		SetError(3)
		Return 0
	EndIf
EndFunc

#Region Memory variables
Global $ini_path = @ScriptDir & "\Config\settings.ini"
Global $client_window_hndl = get_client_window_handle()
Global $client_pid = WinGetProcess($client_window_hndl)
Global $client_memory_hndl = _memoryopen($client_pid)
Global $client_dllmodule_address = _processgetmodulebaseaddress($client_pid, "game.dll", True)
Global $game_client_version = get_client_version()
Global $pointer_targets_entity = __get_pointer_targets_entity()
Global $pointer_nodelists_info = __get_pointer_nodelists_info()
Global $pointer_nodelists = get_pointer_nodelists()
Global $nodelists_start_address = get_nodelists_start_address()
Global $nodelists_count = get_nodelists_count()
Global $entity_dictionary = ObjCreate("Scripting.Dictionary")
#EndRegion
#Region GUI
Global $frm_radar
Global $radar_x, $radar_y
Global $width, $height
Global $count[6] = [0, 0, 0, 0, 0, 0]
Global $frm_settings
Global $settings_x, $settings_y
Global $frm_config
Global $showplayer
Global $showuser_friendly, $showuser_enemy
Global $shownpc_friendly, $shownpc_neutral, $shownpc_aggresive
Global $showgather
Global $draw_player_heading
Global $playerlabel
Global $userlabels_friendly, $userlabels_enemy
Global $npclabels_friendly, $npclabels_neutral, $npclabels_aggresive
Global $gatherlabels
Global $gui_input_key
Global $inp_key
Global $edt_name_0
Global $edt_name_1
Global $edt_name_2
Global $frm_moveresize
Global $lbl_moveresize_size
Global $btn_moveresize_minus
Global $btn_moveresize_plus
Global $btn_moveresize_apply
Global $btn_moveresize_defaults
Global $btn_moveresize_close
#EndRegion
#Region GDI+ Variables
Global $gra_map
Global $backbuffer_bitmap
Global $backbuffer
Global $hbrush
Global $hformat
Global $hfamily
Global $hfont
Global $tlayout
Global $hbrush
Global $screendc, $dc, $tsize, $psize, $tsource, $psource, $tblend, $pblend, $tpoint, $ppoint, $gdibitmap
Global $alpha = 255
Global $alpha_steps = 5
Global $filter_enabled
Global $filter_partial_enabled
Global $filter_name[3]
Global $player_icon_size
Global $player_icon_offset
Global $player_string_size
Global $player_string_offset_x, $player_string_offset_y
Global $user_friendly_icon_size
Global $user_friendly_icon_offset
Global $user_friendly_string_size
Global $user_friendly_string_offset_x, $user_friendly_string_offset_y
Global $user_enemy_icon_size
Global $user_enemy_icon_offset
Global $user_enemy_string_size
Global $user_enemy_string_offset_x, $user_enemy_string_offset_y
Global $npc_friendly_icon_size
Global $npc_friendly_icon_offset
Global $npc_friendly_string_size
Global $npc_friendly_string_offset_x, $npc_friendly_string_offset_y
Global $npc_neutral_icon_size
Global $npc_neutral_icon_offset
Global $npc_neutral_string_size
Global $npc_neutral_string_offset_x, $npc_neutral_string_offset_y
Global $npc_aggresive_icon_size
Global $npc_aggresive_icon_offset
Global $npc_aggresive_string_size
Global $npc_aggresive_string_offset_x, $npc_aggresive_string_offset_y
Global $gather_icon_size
Global $gather_icon_offset
Global $gather_string_size
Global $gather_string_offset_x, $gather_string_offset_y
#EndRegion
#Region Entity variables
Global $player_position
Global $player_data[5] = ["name", 0, 0, 0, 0]
Global $entity_data[6] = ["name", 0, 0, 0, 0, 0]
Global $user_data[3] = ["", 0, 0]
Global $scale
Global $color_bg = 16777215
Global $color_bg_trans = 1342177280
Global $color_player = -4973094
Global $color_user_friendly = -14177567
Global $color_user_enemy = -3591887
Global $color_npc_friendly = -11119275
Global $color_npc_neutral = -5263441
Global $color_npc_aggresive = -8170904
Global $color_gather = -13776858
#EndRegion
#Region Misc Variables
Global $radar_paused = False
Global $pause_label
HotKeySet("{PAUSE}", "TogglePause")
#EndRegion

Func get_client_version()
	Local $__ncsoft_eu_2711_907_1018_4770 = "0x" & Hex($client_dllmodule_address + 12455928, 8)
	Local $__ncsoft_na_2712_907_104_5114 = "0x" & Hex($client_dllmodule_address + 12460056, 8)
	Local $__gameforge_eu_2712_907_110_5143 = "0x" & Hex($client_dllmodule_address + 12464152, 8)
	Local $__gameforge_eu_2712_907_222_5354 = "0x" & Hex($client_dllmodule_address + 12501528, 8)
	Local $__data_read
	Local $__game_client_version
	$__data_read = _memoryread($__ncsoft_eu_2711_907_1018_4770, $client_memory_hndl, "char[1]")
	If $__data_read = "\" Then Return "NCSoft_EU_2711_907_1018_4770"
	$__data_read = _memoryread($__ncsoft_na_2712_907_104_5114, $client_memory_hndl, "char[1]")
	If $__data_read = "\" Then Return "NCSoft_NA_2712_907_104_5114"
	$__data_read = _memoryread($__gameforge_eu_2712_907_110_5143, $client_memory_hndl, "char[1]")
	If $__data_read = "\" Then Return "GameForge_EU_2712_907_110_5143"
	$__data_read = _memoryread($__gameforge_eu_2712_907_222_5354, $client_memory_hndl, "char[1]")
	If $__data_read = "\" Then Return "GameForge_EU_2712_907_222_5354"
	MsgBox(48, "", "You game version is not supported.")
	Exit
EndFunc

Func __get_pointer_targets_entity()
	If $game_client_version = "NCSoft_EU_2711_907_1018_4770" Then Return "0x" & Hex($client_dllmodule_address + 8009792, 8)
	If $game_client_version = "NCSoft_NA_2712_907_104_5114" Then Return "0x" & Hex($client_dllmodule_address + 8013888, 8)
	If $game_client_version = "GameForge_EU_2712_907_110_5143" Then Return "0x" & Hex($client_dllmodule_address + 8017976, 8)
	If $game_client_version = "GameForge_EU_2712_907_222_5354" Then Return "0x" & Hex($client_dllmodule_address + 8017976, 8)
EndFunc

Func __get_pointer_nodelists_info()
	If $game_client_version = "NCSoft_EU_2711_907_1018_4770" Then Return "0x" & Hex($client_dllmodule_address + 12498912, 8)
	If $game_client_version = "NCSoft_NA_2712_907_104_5114" Then Return "0x" & Hex($client_dllmodule_address + 12503040, 8)
	If $game_client_version = "GameForge_EU_2712_907_110_5143" Then Return "0x" & Hex($client_dllmodule_address + 12507120, 8)
	If $game_client_version = "GameForge_EU_2712_907_222_5354" Then Return "0x" & Hex($client_dllmodule_address + 12544592, 8)
EndFunc

Func updatelauncher()
	Local $update_launcher = False
	$update_launcher = IniRead($ini_path, "Launcher", "Update_Launcher", "NotFound")
	If $update_launcher = "True" Then
		update()
	ElseIf $update_launcher = "NotFound" Then
		update()
	EndIf
EndFunc

Func update()
	Local $frm_update
	Local $lbl_launcherupdatetext
	Local $prgs_dl
	Local $dlhndl
	Local $dlinfo[6]
	Local $bytesread_1
	Local $bytesread_2
	$frm_update = GUICreate("Launcher Update", 330, 75)
	$lbl_launcherupdatetext = GUICtrlCreateLabel("Updating the Launcher...", 5, 10, 320, 25, 1)
	GUICtrlSetFont(-1, 14, 800, 0, "MS Reference Sans Serif")
	$prgs_dl = GUICtrlCreateProgress(25, 45, 280, 20)
	GUISetState(@SW_SHOW)
EndFunc

Global $__player_name_offset
Global $__player_class_offset
Global $__player_level_offset
Global $__player_hp_current_offset
Global $__player_hp_max_offset
Global $__player_mp_current_offset
Global $__player_mp_max_offset
Global $__player_dp_current_offset
Global $__player_dp_max_offset
Global $__player_xp_current_offset
Global $__player_xp_max_offset
Global $__player_pos_x_offset
Global $__player_pos_y_offset
Global $__player_pos_z_offset
Global $__player_pos_rotation_offset
Global $__player_playerhastarget_offset
Global $__player_castcount_offset
Global $__player_currentspell_id_offset
Global $__player_currentspell_casttime_offset
Global $__player_inventory_slots_taken_offset
Global $__player_inventory_slots_total_offset
__set_player_offsets()

Func __set_player_offsets()
	If $game_client_version = "NCSoft_EU_2711_907_1018_4770" Then
		$__player_name_offset = 12871888
		$__player_class_offset = 12879344
		$__player_level_offset = 12498136
		$__player_hp_current_offset = 12498176
		$__player_hp_max_offset = 12498172
		$__player_mp_current_offset = 12498184
		$__player_mp_max_offset = 12498180
		$__player_dp_current_offset = 12498200
		$__player_dp_max_offset = 12498188
		$__player_xp_current_offset = 12498160
		$__player_xp_max_offset = 12498144
		$__player_pos_x_offset = 12459516
		$__player_pos_y_offset = 12459520
		$__player_pos_z_offset = 12459524
		$__player_pos_rotation_offset = 12458516
		$__player_playerhastarget_offset = 8009800
		$__player_castcount_offset = 12456020
		$__player_currentspell_id_offset = 12461760
		$__player_currentspell_casttime_offset = 12461764
		$__player_inventory_slots_taken_offset = 12498264
		$__player_inventory_slots_total_offset = 12498260
	EndIf
	If $game_client_version = "NCSoft_NA_2712_907_104_5114" Then
		$__player_name_offset = 12876040
		$__player_class_offset = 12883496
		$__player_level_offset = 12502264
		$__player_hp_current_offset = 12502304
		$__player_hp_max_offset = 12502300
		$__player_mp_current_offset = 12502312
		$__player_mp_max_offset = 12502308
		$__player_dp_current_offset = 12502320
		$__player_dp_max_offset = 12502316
		$__player_xp_current_offset = 12502288
		$__player_xp_max_offset = 12502272
		$__player_pos_x_offset = 12463644
		$__player_pos_y_offset = 12463648
		$__player_pos_z_offset = 12463652
		$__player_pos_rotation_offset = 12462644
		$__player_playerhastarget_offset = 8013896
		$__player_castcount_offset = 12464244
		$__player_currentspell_id_offset = 12469968
		$__player_currentspell_casttime_offset = 12469972
		$__player_inventory_slots_taken_offset = 12506472
		$__player_inventory_slots_total_offset = 12506468
	EndIf
	If $game_client_version = "GameForge_EU_2712_907_110_5143" Then
		$__player_name_offset = 12880136
		$__player_class_offset = 12887592
		$__player_level_offset = 12506344
		$__player_hp_current_offset = 12506384
		$__player_hp_max_offset = 12506380
		$__player_mp_current_offset = 12506392
		$__player_mp_max_offset = 12506388
		$__player_dp_current_offset = 12506408
		$__player_dp_max_offset = 12506396
		$__player_xp_current_offset = 12506368
		$__player_xp_max_offset = 12506352
		$__player_pos_x_offset = 12467724
		$__player_pos_y_offset = 12467728
		$__player_pos_z_offset = 12467732
		$__player_pos_rotation_offset = 12466724
		$__player_playerhastarget_offset = 8017984
		$__player_castcount_offset = 12464244
		$__player_currentspell_id_offset = 12469968
		$__player_currentspell_casttime_offset = 12469972
		$__player_inventory_slots_taken_offset = 12506472
		$__player_inventory_slots_total_offset = 12506468
	EndIf
	If $game_client_version = "GameForge_EU_2712_907_222_5354" Then
		$__player_name_offset = 12917608
		$__player_class_offset = 12887592
		$__player_level_offset = 12543816
		$__player_hp_current_offset = 12543856
		$__player_hp_max_offset = 12543852
		$__player_mp_current_offset = 12543864
		$__player_mp_max_offset = 12543860
		$__player_dp_current_offset = 12506408
		$__player_dp_max_offset = 12543868
		$__player_xp_current_offset = 12543840
		$__player_xp_max_offset = 12543824
		$__player_pos_x_offset = 12505196
		$__player_pos_y_offset = 12505200
		$__player_pos_z_offset = 12505204
		$__player_pos_rotation_offset = 12504196
		$__player_playerhastarget_offset = 8055400
		$__player_castcount_offset = 12464244
		$__player_currentspell_id_offset = 12469968
		$__player_currentspell_casttime_offset = 12469972
		$__player_inventory_slots_taken_offset = 12506472
		$__player_inventory_slots_total_offset = 12506468
	EndIf
EndFunc

Func player_get_name()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_name_offset, 8)
	Local $data_type = "wchar[24]"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_class()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_class_offset, 8)
	Local $data_type = "wchar[24]"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_level()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_level_offset, 8)
	Local $data_type = "byte"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_hp_current()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_hp_current_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_hp_max()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_hp_max_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_mp_current()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_mp_current_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_mp_max()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_mp_max_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_dp_current()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_dp_current_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_dp_max()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_dp_max_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_xp_current()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_xp_current_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_xp_max()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_xp_max_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_pos_x()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_pos_x_offset, 8)
	Local $data_type = "float"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return Round($data_read, 1)
EndFunc

Func player_get_pos_y()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_pos_y_offset, 8)
	Local $data_type = "float"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return Round($data_read, 1)
EndFunc

Func player_get_pos_z()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_pos_z_offset, 8)
	Local $data_type = "float"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return Round($data_read, 1)
EndFunc

Func player_get_pos_rotation()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_pos_rotation_offset, 8)
	Local $data_type = "float"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return Round($data_read, 1)
EndFunc

Func player_get_playerhastarget()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_playerhastarget_offset, 8)
	Local $data_type = "byte"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_castcount()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_castcount_offset, 8)
	Local $data_type = "byte"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_currentspell_id()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_currentspell_id_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_currentspell_casttime()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_currentspell_casttime_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_inventory_slots_taken()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_inventory_slots_taken_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func player_get_inventory_slots_total()
	Local $data_address = "0x" & Hex($client_dllmodule_address + $__player_inventory_slots_total_offset, 8)
	Local $data_type = "int"
	Local $data_read
	$data_read = _memoryread($data_address, $client_memory_hndl, $data_type)
	Return $data_read
EndFunc

Func target_get_type()
	Local $offsets[2] = ["", 224]
	Local $data_type = "char[24]"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_name()
	Local $offsets[3] = ["", 468, 58]
	Local $data_type = "wchar[24]"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_legion()
	Local $offsets[3] = ["", 468, 252]
	Local $data_type = "wchar[24]"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_level()
	Local $offsets[3] = ["", 468, 54]
	Local $data_type = "byte"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_hp_percentage()
	Local $offsets[3] = ["", 468, 56]
	Local $data_type = "byte"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_hp_current()
	Local $offsets[3] = ["", 468, 4320]
	Local $data_type = "int"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_hp_max()
	Local $offsets[3] = ["", 468, 4316]
	Local $data_type = "int"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return $data_read[1]
EndFunc

Func target_get_pos_x()
	Local $offsets[2] = ["", 888]
	Local $data_type = "float"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return Round($data_read[1], 1)
EndFunc

Func target_get_pos_y()
	Local $offsets[2] = ["", 892]
	Local $data_type = "float"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return Round($data_read[1], 1)
EndFunc

Func target_get_pos_z()
	Local $offsets[2] = ["", 896]
	Local $data_type = "float"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return Round($data_read[1], 1)
EndFunc

Func target_get_pos_rotation()
	Local $offsets[3] = ["", 468, 1928]
	Local $data_type = "float"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return Round($data_read[1], 1)
EndFunc

Func target_get_state()
	Local $offsets[3] = ["", 468, 44]
	Local $data_type = "int"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Switch $data_read[1]
		Case 0
			Return "unknown"
		Case 1
			Return "Idle"
		Case 2
			Return "Occupied"
		Case 3
			Return "Flying"
		Case 5
			Return "Resting"
		Case 7
			Return "Dead"
		Case 33
			Return "Fighting"
		Case 44
			Return "Looting"
		Case 65
			Return "Idle"
	EndSwitch
EndFunc

Func target_get_guid()
	Local $offsets[3] = ["", 468, 36]
	Local $data_type = "uint"
	Local $data_read
	$data_read = _memorypointerread($pointer_targets_entity, $client_memory_hndl, $offsets, $data_type)
	Return Hex($data_read[1], 8)
EndFunc

Func get_pointer_nodelists()
	Local $result
	$result = "0x" & Hex(_memoryread($pointer_nodelists_info, $client_memory_hndl, "uint") + 72, 8)
	Return $result
EndFunc

Func get_nodelists_start_address()
	Local $result
	$result = "0x" & Hex(_memoryread($pointer_nodelists, $client_memory_hndl, "uint"), 8)
	Return $result
EndFunc

Func get_nodelists_count()
	Local $result
	$result = _memoryread("0x" & Hex(Int($pointer_nodelists) + 16, 8), $client_memory_hndl, "uint")
	Return $result
EndFunc

Func entity_get_type($param1)
	Local $result
	$result = _memoryread("0x" & Hex(Int($param1) + 224, 8), $client_memory_hndl, "char[24]")
	Return $result
EndFunc

Func entity_get_name($param1)
	Local $pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($param1) + 468, 8), $client_memory_hndl, "uint"), 8)
	Local $result
	$result = _memoryread("0x" & Hex(Int($pointer) + 58, 8), $client_memory_hndl, "wchar[24]")
	Return $result
EndFunc

Func entity_get_attitude($param1)
	Local $pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($param1) + 468, 8), $client_memory_hndl, "uint"), 8)
	Local $result
	$result = _memoryread("0x" & Hex(Int($pointer) + 28, 8), $client_memory_hndl, "uint")
	Return $result
EndFunc

Func entity_get_guid($param1)
	Local $pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($param1) + 468, 8), $client_memory_hndl, "uint"), 8)
	Local $result
	$result = Hex(_memoryread("0x" & Hex(Int($pointer) + 36, 8), $client_memory_hndl, "uint"), 8)
	Return $result
EndFunc

Func entity_get_level($param1)
	Local $pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($param1) + 468, 8), $client_memory_hndl, "uint"), 8)
	Local $result
	$result = _memoryread("0x" & Hex(Int($pointer) + 54, 8), $client_memory_hndl, "byte")
	Return $result
EndFunc

Func entity_get_hppercent($param1)
	Local $pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($param1) + 468, 8), $client_memory_hndl, "uint"), 8)
	Local $result
	$result = _memoryread("0x" & Hex(Int($pointer) + 56, 8), $client_memory_hndl, "byte")
	Return $result
EndFunc

Func entity_get_pos_x($param1)
	Local $result
	$result = _memoryread("0x" & Hex(Int($param1) + 888, 8), $client_memory_hndl, "float")
	Return $result
EndFunc

Func entity_get_pos_y($param1)
	Local $result
	$result = _memoryread("0x" & Hex(Int($param1) + 892, 8), $client_memory_hndl, "float")
	Return $result
EndFunc

Func entity_get_pos_z($param1)
	Local $result
	$result = _memoryread("0x" & Hex(Int($param1) + 896, 8), $client_memory_hndl, "float")
	Return $result
EndFunc

Global Const $gdip_dashcapflat = 0
Global Const $gdip_dashcapround = 2
Global Const $gdip_dashcaptriangle = 3
Global Const $gdip_dashstylesolid = 0
Global Const $gdip_dashstyledash = 1
Global Const $gdip_dashstyledot = 2
Global Const $gdip_dashstyledashdot = 3
Global Const $gdip_dashstyledashdotdot = 4
Global Const $gdip_dashstylecustom = 5
Global Const $gdip_epgchrominancetable = "{F2E455DC-09B3-4316-8260-676ADA32481C}"
Global Const $gdip_epgcolordepth = "{66087055-AD66-4C7C-9A18-38A2310B8337}"
Global Const $gdip_epgcompression = "{E09D739D-CCD4-44EE-8EBA-3FBF8BE4FC58}"
Global Const $gdip_epgluminancetable = "{EDB33BCE-0266-4A77-B904-27216099E717}"
Global Const $gdip_epgquality = "{1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB}"
Global Const $gdip_epgrendermethod = "{6D42C53A-229A-4825-8BB7-5C99E2B9A8B8}"
Global Const $gdip_epgsaveflag = "{292266FC-AC40-47BF-8CFC-A85B89A655DE}"
Global Const $gdip_epgscanmethod = "{3A4E2661-3109-4E56-8536-42C156E7DCFA}"
Global Const $gdip_epgtransformation = "{8D0EB2D1-A58E-4EA8-AA14-108074B7B6F9}"
Global Const $gdip_epgversion = "{24D18C76-814A-41A4-BF53-1C219CCCF797}"
Global Const $gdip_eptbyte = 1
Global Const $gdip_eptascii = 2
Global Const $gdip_eptshort = 3
Global Const $gdip_eptlong = 4
Global Const $gdip_eptrational = 5
Global Const $gdip_eptlongrange = 6
Global Const $gdip_eptundefined = 7
Global Const $gdip_eptrationalrange = 8
Global Const $gdip_errok = 0
Global Const $gdip_errgenericerror = 1
Global Const $gdip_errinvalidparameter = 2
Global Const $gdip_erroutofmemory = 3
Global Const $gdip_errobjectbusy = 4
Global Const $gdip_errinsufficientbuffer = 5
Global Const $gdip_errnotimplemented = 6
Global Const $gdip_errwin32error = 7
Global Const $gdip_errwrongstate = 8
Global Const $gdip_erraborted = 9
Global Const $gdip_errfilenotfound = 10
Global Const $gdip_errvalueoverflow = 11
Global Const $gdip_erraccessdenied = 12
Global Const $gdip_errunknownimageformat = 13
Global Const $gdip_errfontfamilynotfound = 14
Global Const $gdip_errfontstylenotfound = 15
Global Const $gdip_errnottruetypefont = 16
Global Const $gdip_errunsupportedgdiversion = 17
Global Const $gdip_errgdiplusnotinitialized = 18
Global Const $gdip_errpropertynotfound = 19
Global Const $gdip_errpropertynotsupported = 20
Global Const $gdip_evtcompressionlzw = 2
Global Const $gdip_evtcompressionccitt3 = 3
Global Const $gdip_evtcompressionccitt4 = 4
Global Const $gdip_evtcompressionrle = 5
Global Const $gdip_evtcompressionnone = 6
Global Const $gdip_evttransformrotate90 = 13
Global Const $gdip_evttransformrotate180 = 14
Global Const $gdip_evttransformrotate270 = 15
Global Const $gdip_evttransformfliphorizontal = 16
Global Const $gdip_evttransformflipvertical = 17
Global Const $gdip_evtmultiframe = 18
Global Const $gdip_evtlastframe = 19
Global Const $gdip_evtflush = 20
Global Const $gdip_evtframedimensionpage = 23
Global Const $gdip_icfencoder = 1
Global Const $gdip_icfdecoder = 2
Global Const $gdip_icfsupportbitmap = 4
Global Const $gdip_icfsupportvector = 8
Global Const $gdip_icfseekableencode = 16
Global Const $gdip_icfblockingdecode = 32
Global Const $gdip_icfbuiltin = 65536
Global Const $gdip_icfsystem = 131072
Global Const $gdip_icfuser = 262144
Global Const $gdip_ilmread = 1
Global Const $gdip_ilmwrite = 2
Global Const $gdip_ilmuserinputbuf = 4
Global Const $gdip_linecapflat = 0
Global Const $gdip_linecapsquare = 1
Global Const $gdip_linecapround = 2
Global Const $gdip_linecaptriangle = 3
Global Const $gdip_linecapnoanchor = 16
Global Const $gdip_linecapsquareanchor = 17
Global Const $gdip_linecaproundanchor = 18
Global Const $gdip_linecapdiamondanchor = 19
Global Const $gdip_linecaparrowanchor = 20
Global Const $gdip_linecapcustom = 255
Global Const $gdip_pxf01indexed = 196865
Global Const $gdip_pxf04indexed = 197634
Global Const $gdip_pxf08indexed = 198659
Global Const $gdip_pxf16grayscale = 1052676
Global Const $gdip_pxf16rgb555 = 135173
Global Const $gdip_pxf16rgb565 = 135174
Global Const $gdip_pxf16argb1555 = 397319
Global Const $gdip_pxf24rgb = 137224
Global Const $gdip_pxf32rgb = 139273
Global Const $gdip_pxf32argb = 2498570
Global Const $gdip_pxf32pargb = 860171
Global Const $gdip_pxf48rgb = 1060876
Global Const $gdip_pxf64argb = 3424269
Global Const $gdip_pxf64pargb = 1851406
Global Const $gdip_imageformat_undefined = "{B96B3CA9-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_memorybmp = "{B96B3CAA-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_bmp = "{B96B3CAB-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_emf = "{B96B3CAC-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_wmf = "{B96B3CAD-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_jpeg = "{B96B3CAE-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_png = "{B96B3CAF-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_gif = "{B96B3CB0-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_tiff = "{B96B3CB1-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_exif = "{B96B3CB2-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imageformat_icon = "{B96B3CB5-0728-11D3-9D7B-0000F81EF32E}"
Global Const $gdip_imagetype_unknown = 0
Global Const $gdip_imagetype_bitmap = 1
Global Const $gdip_imagetype_metafile = 2
Global Const $gdip_imageflags_none = 0
Global Const $gdip_imageflags_scalable = 1
Global Const $gdip_imageflags_hasalpha = 2
Global Const $gdip_imageflags_hastranslucent = 4
Global Const $gdip_imageflags_partiallyscalable = 8
Global Const $gdip_imageflags_colorspace_rgb = 16
Global Const $gdip_imageflags_colorspace_cmyk = 32
Global Const $gdip_imageflags_colorspace_gray = 64
Global Const $gdip_imageflags_colorspace_ycbcr = 128
Global Const $gdip_imageflags_colorspace_ycck = 256
Global Const $gdip_imageflags_hasrealdpi = 4096
Global Const $gdip_imageflags_hasrealpixelsize = 8192
Global Const $gdip_imageflags_readonly = 65536
Global Const $gdip_imageflags_caching = 131072
Global Const $tagpoint = "struct;long X;long Y;endstruct"
Global Const $tagrect = "struct;long Left;long Top;long Right;long Bottom;endstruct"
Global Const $tagsize = "struct;long X;long Y;endstruct"
Global Const $tagmargins = "int cxLeftWidth;int cxRightWidth;int cyTopHeight;int cyBottomHeight"
Global Const $tagfiletime = "struct;dword Lo;dword Hi;endstruct"
Global Const $tagsystemtime = "struct;word Year;word Month;word Dow;word Day;word Hour;word Minute;word Second;word MSeconds;endstruct"
Global Const $tagtime_zone_information = "struct;long Bias;wchar StdName[32];word StdDate[8];long StdBias;wchar DayName[32];word DayDate[8];long DayBias;endstruct"
Global Const $tagnmhdr = "struct;hwnd hWndFrom;uint_ptr IDFrom;INT Code;endstruct"
Global Const $tagcomboboxexitem = "uint Mask;int_ptr Item;ptr Text;int TextMax;int Image;int SelectedImage;int OverlayImage;" & "int Indent;lparam Param"
Global Const $tagnmcbedragbegin = $tagnmhdr & ";int ItemID;wchar szText[260]"
Global Const $tagnmcbeendedit = $tagnmhdr & ";bool fChanged;int NewSelection;wchar szText[260];int Why"
Global Const $tagnmcomboboxex = $tagnmhdr & ";uint Mask;int_ptr Item;ptr Text;int TextMax;int Image;" & "int SelectedImage;int OverlayImage;int Indent;lparam Param"
Global Const $tagdtprange = "word MinYear;word MinMonth;word MinDOW;word MinDay;word MinHour;word MinMinute;" & "word MinSecond;word MinMSecond;word MaxYear;word MaxMonth;word MaxDOW;word MaxDay;word MaxHour;" & "word MaxMinute;word MaxSecond;word MaxMSecond;bool MinValid;bool MaxValid"
Global Const $tagnmdatetimechange = $tagnmhdr & ";dword Flag;" & $tagsystemtime
Global Const $tagnmdatetimeformat = $tagnmhdr & ";ptr Format;" & $tagsystemtime & ";ptr pDisplay;wchar Display[64]"
Global Const $tagnmdatetimeformatquery = $tagnmhdr & ";ptr Format;struct;long SizeX;long SizeY;endstruct"
Global Const $tagnmdatetimekeydown = $tagnmhdr & ";int VirtKey;ptr Format;" & $tagsystemtime
Global Const $tagnmdatetimestring = $tagnmhdr & ";ptr UserString;" & $tagsystemtime & ";dword Flags"
Global Const $tageventlogrecord = "dword Length;dword Reserved;dword RecordNumber;dword TimeGenerated;dword TimeWritten;dword EventID;" & "word EventType;word NumStrings;word EventCategory;word ReservedFlags;dword ClosingRecordNumber;dword StringOffset;" & "dword UserSidLength;dword UserSidOffset;dword DataLength;dword DataOffset"
Global Const $taggdipbitmapdata = "uint Width;uint Height;int Stride;int Format;ptr Scan0;uint_ptr Reserved"
Global Const $taggdipencoderparam = "byte GUID[16];ulong Count;ulong Type;ptr Values"
Global Const $taggdipencoderparams = "uint Count;byte Params[1]"
Global Const $taggdiprectf = "float X;float Y;float Width;float Height"
Global Const $taggdipstartupinput = "uint Version;ptr Callback;bool NoThread;bool NoCodecs"
Global Const $taggdipstartupoutput = "ptr HookProc;ptr UnhookProc"
Global Const $taggdipimagecodecinfo = "byte CLSID[16];byte FormatID[16];ptr CodecName;ptr DllName;ptr FormatDesc;ptr FileExt;" & "ptr MimeType;dword Flags;dword Version;dword SigCount;dword SigSize;ptr SigPattern;ptr SigMask"
Global Const $taggdippencoderparams = "uint Count;byte Params[1]"
Global Const $taghditem = "uint Mask;int XY;ptr Text;handle hBMP;int TextMax;int Fmt;lparam Param;int Image;int Order;uint Type;ptr pFilter;uint State"
Global Const $tagnmhddispinfo = $tagnmhdr & ";int Item;uint Mask;ptr Text;int TextMax;int Image;lparam lParam"
Global Const $tagnmhdfilterbtnclick = $tagnmhdr & ";int Item;" & $tagrect
Global Const $tagnmheader = $tagnmhdr & ";int Item;int Button;ptr pItem"
Global Const $taggetipaddress = "byte Field4;byte Field3;byte Field2;byte Field1"
Global Const $tagnmipaddress = $tagnmhdr & ";int Field;int Value"
Global Const $taglvfindinfo = "struct;uint Flags;ptr Text;lparam Param;" & $tagpoint & ";uint Direction;endstruct"
Global Const $taglvhittestinfo = $tagpoint & ";uint Flags;int Item;int SubItem;int iGroup"
Global Const $taglvitem = "struct;uint Mask;int Item;int SubItem;uint State;uint StateMask;ptr Text;int TextMax;int Image;lparam Param;" & "int Indent;int GroupID;uint Columns;ptr pColumns;ptr piColFmt;int iGroup;endstruct"
Global Const $tagnmlistview = $tagnmhdr & ";int Item;int SubItem;uint NewState;uint OldState;uint Changed;" & "struct;long ActionX;long ActionY;endstruct;lparam Param"
Global Const $tagnmlvcustomdraw = "struct;" & $tagnmhdr & ";dword dwDrawStage;handle hdc;" & $tagrect & ";dword_ptr dwItemSpec;uint uItemState;lparam lItemlParam;endstruct" & ";dword clrText;dword clrTextBk;int iSubItem;dword dwItemType;dword clrFace;int iIconEffect;" & "int iIconPhase;int iPartId;int iStateId;struct;long TextLeft;long TextTop;long TextRight;long TextBottom;endstruct;uint uAlign"
Global Const $tagnmlvdispinfo = $tagnmhdr & ";" & $taglvitem
Global Const $tagnmlvfinditem = $tagnmhdr & ";int Start;" & $taglvfindinfo
Global Const $tagnmlvgetinfotip = $tagnmhdr & ";dword Flags;ptr Text;int TextMax;int Item;int SubItem;lparam lParam"
Global Const $tagnmitemactivate = $tagnmhdr & ";int Index;int SubItem;uint NewState;uint OldState;uint Changed;" & $tagpoint & ";lparam lParam;uint KeyFlags"
Global Const $tagnmlvkeydown = "align 1;" & $tagnmhdr & ";word VKey;uint Flags"
Global Const $tagnmlvscroll = $tagnmhdr & ";int DX;int DY"
Global Const $tagmchittestinfo = "uint Size;" & $tagpoint & ";uint Hit;" & $tagsystemtime & ";" & $tagrect & ";int iOffset;int iRow;int iCol"
Global Const $tagmcmonthrange = "word MinYear;word MinMonth;word MinDOW;word MinDay;word MinHour;word MinMinute;word MinSecond;" & "word MinMSeconds;word MaxYear;word MaxMonth;word MaxDOW;word MaxDay;word MaxHour;word MaxMinute;word MaxSecond;" & "word MaxMSeconds;short Span"
Global Const $tagmcrange = "word MinYear;word MinMonth;word MinDOW;word MinDay;word MinHour;word MinMinute;word MinSecond;" & "word MinMSeconds;word MaxYear;word MaxMonth;word MaxDOW;word MaxDay;word MaxHour;word MaxMinute;word MaxSecond;" & "word MaxMSeconds;short MinSet;short MaxSet"
Global Const $tagmcselrange = "word MinYear;word MinMonth;word MinDOW;word MinDay;word MinHour;word MinMinute;word MinSecond;" & "word MinMSeconds;word MaxYear;word MaxMonth;word MaxDOW;word MaxDay;word MaxHour;word MaxMinute;word MaxSecond;" & "word MaxMSeconds"
Global Const $tagnmdaystate = $tagnmhdr & ";" & $tagsystemtime & ";int DayState;ptr pDayState"
Global Const $tagnmselchange = $tagnmhdr & ";struct;word BegYear;word BegMonth;word BegDOW;word BegDay;word BegHour;word BegMinute;word BegSecond;word BegMSeconds;endstruct;" & "struct;word EndYear;word EndMonth;word EndDOW;word EndDay;word EndHour;word EndMinute;word EndSecond;word EndMSeconds;endstruct"
Global Const $tagnmobjectnotify = $tagnmhdr & ";int Item;ptr piid;ptr pObject;long Result;dword dwFlags"
Global Const $tagnmtckeydown = "align 1;" & $tagnmhdr & ";word VKey;uint Flags"
Global Const $tagtvitem = "struct;uint Mask;handle hItem;uint State;uint StateMask;ptr Text;int TextMax;int Image;int SelectedImage;" & "int Children;lparam Param;endstruct"
Global Const $tagtvitemex = "struct;" & $tagtvitem & ";int Integral;uint uStateEx;hwnd hwnd;int iExpandedImage;int iReserved;endstruct"
Global Const $tagnmtreeview = $tagnmhdr & ";uint Action;" & "struct;uint OldMask;handle OldhItem;uint OldState;uint OldStateMask;" & "ptr OldText;int OldTextMax;int OldImage;int OldSelectedImage;int OldChildren;lparam OldParam;endstruct;" & "struct;uint NewMask;handle NewhItem;uint NewState;uint NewStateMask;" & "ptr NewText;int NewTextMax;int NewImage;int NewSelectedImage;int NewChildren;lparam NewParam;endstruct;" & "struct;long PointX;long PointY;endstruct"
Global Const $tagnmtvcustomdraw = "struct;" & $tagnmhdr & ";dword DrawStage;handle HDC;" & $tagrect & ";dword_ptr ItemSpec;uint ItemState;lparam ItemParam;endstruct" & ";dword ClrText;dword ClrTextBk;int Level"
Global Const $tagnmtvdispinfo = $tagnmhdr & ";" & $tagtvitem
Global Const $tagnmtvgetinfotip = $tagnmhdr & ";ptr Text;int TextMax;handle hItem;lparam lParam"
Global Const $tagtvhittestinfo = $tagpoint & ";uint Flags;handle Item"
Global Const $tagnmtvkeydown = "align 1;" & $tagnmhdr & ";word VKey;uint Flags"
Global Const $tagnmmouse = $tagnmhdr & ";dword_ptr ItemSpec;dword_ptr ItemData;" & $tagpoint & ";lparam HitInfo"
Global Const $tagtoken_privileges = "dword Count;align 4;int64 LUID;dword Attributes"
Global Const $tagimageinfo = "handle hBitmap;handle hMask;int Unused1;int Unused2;" & $tagrect
Global Const $tagmenuinfo = "dword Size;INT Mask;dword Style;uint YMax;handle hBack;dword ContextHelpID;ulong_ptr MenuData"
Global Const $tagmenuiteminfo = "uint Size;uint Mask;uint Type;uint State;uint ID;handle SubMenu;handle BmpChecked;handle BmpUnchecked;" & "ulong_ptr ItemData;ptr TypeData;uint CCH;handle BmpItem"
Global Const $tagrebarbandinfo = "uint cbSize;uint fMask;uint fStyle;dword clrFore;dword clrBack;ptr lpText;uint cch;" & "int iImage;hwnd hwndChild;uint cxMinChild;uint cyMinChild;uint cx;handle hbmBack;uint wID;uint cyChild;uint cyMaxChild;" & "uint cyIntegral;uint cxIdeal;lparam lParam;uint cxHeader;" & $tagrect & ";uint uChevronState"
Global Const $tagnmrebarautobreak = $tagnmhdr & ";uint uBand;uint wID;lparam lParam;uint uMsg;uint fStyleCurrent;bool fAutoBreak"
Global Const $tagnmrbautosize = $tagnmhdr & ";bool fChanged;" & "struct;long TargetLeft;long TargetTop;long TargetRight;long TargetBottom;endstruct;" & "struct;long ActualLeft;long ActualTop;long ActualRight;long ActualBottom;endstruct"
Global Const $tagnmrebar = $tagnmhdr & ";dword dwMask;uint uBand;uint fStyle;uint wID;lparam lParam"
Global Const $tagnmrebarchevron = $tagnmhdr & ";uint uBand;uint wID;lparam lParam;" & $tagrect & ";lparam lParamNM"
Global Const $tagnmrebarchildsize = $tagnmhdr & ";uint uBand;uint wID;" & "struct;long CLeft;long CTop;long CRight;long CBottom;endstruct;" & "struct;long BLeft;long BTop;long BRight;long BBottom;endstruct"
Global Const $tagcolorscheme = "dword Size;dword BtnHighlight;dword BtnShadow"
Global Const $tagnmtoolbar = $tagnmhdr & ";int iItem;" & "struct;int iBitmap;int idCommand;byte fsState;byte fsStyle;dword_ptr dwData;int_ptr iString;endstruct" & ";int cchText;ptr pszText;" & $tagrect
Global Const $tagnmtbhotitem = $tagnmhdr & ";int idOld;int idNew;dword dwFlags"
Global Const $tagtbbutton = "int Bitmap;int Command;byte State;byte Style;align;dword_ptr Param;int_ptr String"
Global Const $tagtbbuttoninfo = "uint Size;dword Mask;int Command;int Image;byte State;byte Style;word CX;dword_ptr Param;ptr Text;int TextMax"
Global Const $tagnetresource = "dword Scope;dword Type;dword DisplayType;dword Usage;ptr LocalName;ptr RemoteName;ptr Comment;ptr Provider"
Global Const $tagoverlapped = "ulong_ptr Internal;ulong_ptr InternalHigh;struct;dword Offset;dword OffsetHigh;endstruct;handle hEvent"
Global Const $tagopenfilename = "dword StructSize;hwnd hwndOwner;handle hInstance;ptr lpstrFilter;ptr lpstrCustomFilter;" & "dword nMaxCustFilter;dword nFilterIndex;ptr lpstrFile;dword nMaxFile;ptr lpstrFileTitle;dword nMaxFileTitle;" & "ptr lpstrInitialDir;ptr lpstrTitle;dword Flags;word nFileOffset;word nFileExtension;ptr lpstrDefExt;lparam lCustData;" & "ptr lpfnHook;ptr lpTemplateName;ptr pvReserved;dword dwReserved;dword FlagsEx"
Global Const $tagbitmapinfo = "struct;dword Size;long Width;long Height;word Planes;word BitCount;dword Compression;dword SizeImage;" & "long XPelsPerMeter;long YPelsPerMeter;dword ClrUsed;dword ClrImportant;endstruct;dword RGBQuad"
Global Const $tagblendfunction = "byte Op;byte Flags;byte Alpha;byte Format"
Global Const $tagguid = "ulong Data1;ushort Data2;ushort Data3;byte Data4[8]"
Global Const $tagwindowplacement = "uint length;uint flags;uint showCmd;long ptMinPosition[2];long ptMaxPosition[2];long rcNormalPosition[4]"
Global Const $tagwindowpos = "hwnd hWnd;hwnd InsertAfter;int X;int Y;int CX;int CY;uint Flags"
Global Const $tagscrollinfo = "uint cbSize;uint fMask;int nMin;int nMax;uint nPage;int nPos;int nTrackPos"
Global Const $tagscrollbarinfo = "dword cbSize;" & $tagrect & ";int dxyLineButton;int xyThumbTop;" & "int xyThumbBottom;int reserved;dword rgstate[6]"
Global Const $taglogfont = "long Height;long Width;long Escapement;long Orientation;long Weight;byte Italic;byte Underline;" & "byte Strikeout;byte CharSet;byte OutPrecision;byte ClipPrecision;byte Quality;byte PitchAndFamily;wchar FaceName[32]"
Global Const $tagkbdllhookstruct = "dword vkCode;dword scanCode;dword flags;dword time;ulong_ptr dwExtraInfo"
Global Const $tagprocess_information = "handle hProcess;handle hThread;dword ProcessID;dword ThreadID"
Global Const $tagstartupinfo = "dword Size;ptr Reserved1;ptr Desktop;ptr Title;dword X;dword Y;dword XSize;dword YSize;dword XCountChars;" & "dword YCountChars;dword FillAttribute;dword Flags;word ShowWindow;word Reserved2;ptr Reserved3;handle StdInput;" & "handle StdOutput;handle StdError"
Global Const $tagsecurity_attributes = "dword Length;ptr Descriptor;bool InheritHandle"
Global Const $tagwin32_find_data = "dword dwFileAttributes;dword ftCreationTime[2];dword ftLastAccessTime[2];dword ftLastWriteTime[2];dword nFileSizeHigh;dword nFileSizeLow;dword dwReserved0;dword dwReserved1;wchar cFileName[260];wchar cAlternateFileName[14]"
Global Const $tagtextmetric = "long tmHeight;long tmAscent;long tmDescent;long tmInternalLeading;long tmExternalLeading;" & "long tmAveCharWidth;long tmMaxCharWidth;long tmWeight;long tmOverhang;long tmDigitizedAspectX;long tmDigitizedAspectY;" & "wchar tmFirstChar;wchar tmLastChar;wchar tmDefaultChar;wchar tmBreakChar;byte tmItalic;byte tmUnderlined;byte tmStruckOut;" & "byte tmPitchAndFamily;byte tmCharSet"
Global Const $fc_nooverwrite = 0
Global Const $fc_overwrite = 1
Global Const $ft_modified = 0
Global Const $ft_created = 1
Global Const $ft_accessed = 2
Global Const $fo_read = 0
Global Const $fo_append = 1
Global Const $fo_overwrite = 2
Global Const $fo_binary = 16
Global Const $fo_unicode = 32
Global Const $fo_utf16_le = 32
Global Const $fo_utf16_be = 64
Global Const $fo_utf8 = 128
Global Const $fo_utf8_nobom = 256
Global Const $eof = -1
Global Const $fd_filemustexist = 1
Global Const $fd_pathmustexist = 2
Global Const $fd_multiselect = 4
Global Const $fd_promptcreatenew = 8
Global Const $fd_promptoverwrite = 16
Global Const $create_new = 1
Global Const $create_always = 2
Global Const $open_existing = 3
Global Const $open_always = 4
Global Const $truncate_existing = 5
Global Const $invalid_set_file_pointer = -1
Global Const $file_begin = 0
Global Const $file_current = 1
Global Const $file_end = 2
Global Const $file_attribute_readonly = 1
Global Const $file_attribute_hidden = 2
Global Const $file_attribute_system = 4
Global Const $file_attribute_directory = 16
Global Const $file_attribute_archive = 32
Global Const $file_attribute_device = 64
Global Const $file_attribute_normal = 128
Global Const $file_attribute_temporary = 256
Global Const $file_attribute_sparse_file = 512
Global Const $file_attribute_reparse_point = 1024
Global Const $file_attribute_compressed = 2048
Global Const $file_attribute_offline = 4096
Global Const $file_attribute_not_content_indexed = 8192
Global Const $file_attribute_encrypted = 16384
Global Const $file_share_read = 1
Global Const $file_share_write = 2
Global Const $file_share_delete = 4
Global Const $generic_all = 268435456
Global Const $generic_execute = 536870912
Global Const $generic_write = 1073741824
Global Const $generic_read = -2147483648
Global Const $error_no_token = 1008
Global Const $se_assignprimarytoken_name = "SeAssignPrimaryTokenPrivilege"
Global Const $se_audit_name = "SeAuditPrivilege"
Global Const $se_backup_name = "SeBackupPrivilege"
Global Const $se_change_notify_name = "SeChangeNotifyPrivilege"
Global Const $se_create_global_name = "SeCreateGlobalPrivilege"
Global Const $se_create_pagefile_name = "SeCreatePagefilePrivilege"
Global Const $se_create_permanent_name = "SeCreatePermanentPrivilege"
Global Const $se_create_token_name = "SeCreateTokenPrivilege"
Global Const $se_debug_name = "SeDebugPrivilege"
Global Const $se_enable_delegation_name = "SeEnableDelegationPrivilege"
Global Const $se_impersonate_name = "SeImpersonatePrivilege"
Global Const $se_inc_base_priority_name = "SeIncreaseBasePriorityPrivilege"
Global Const $se_increase_quota_name = "SeIncreaseQuotaPrivilege"
Global Const $se_load_driver_name = "SeLoadDriverPrivilege"
Global Const $se_lock_memory_name = "SeLockMemoryPrivilege"
Global Const $se_machine_account_name = "SeMachineAccountPrivilege"
Global Const $se_manage_volume_name = "SeManageVolumePrivilege"
Global Const $se_prof_single_process_name = "SeProfileSingleProcessPrivilege"
Global Const $se_remote_shutdown_name = "SeRemoteShutdownPrivilege"
Global Const $se_restore_name = "SeRestorePrivilege"
Global Const $se_security_name = "SeSecurityPrivilege"
Global Const $se_shutdown_name = "SeShutdownPrivilege"
Global Const $se_sync_agent_name = "SeSyncAgentPrivilege"
Global Const $se_system_environment_name = "SeSystemEnvironmentPrivilege"
Global Const $se_system_profile_name = "SeSystemProfilePrivilege"
Global Const $se_systemtime_name = "SeSystemtimePrivilege"
Global Const $se_take_ownership_name = "SeTakeOwnershipPrivilege"
Global Const $se_tcb_name = "SeTcbPrivilege"
Global Const $se_unsolicited_input_name = "SeUnsolicitedInputPrivilege"
Global Const $se_undock_name = "SeUndockPrivilege"
Global Const $se_privilege_enabled_by_default = 1
Global Const $se_privilege_enabled = 2
Global Const $se_privilege_removed = 4
Global Const $se_privilege_used_for_access = -2147483648
Global Const $se_group_mandatory = 1
Global Const $se_group_enabled_by_default = 2
Global Const $se_group_enabled = 4
Global Const $se_group_owner = 8
Global Const $se_group_use_for_deny_only = 16
Global Const $se_group_integrity = 32
Global Const $se_group_integrity_enabled = 64
Global Const $se_group_resource = 536870912
Global Const $se_group_logon_id = -1073741824
Global Enum $tokenprimary = 1, $tokenimpersonation
Global Enum $securityanonymous = 0, $securityidentification, $securityimpersonation, $securitydelegation
Global Enum $tokenuser = 1, $tokengroups, $tokenprivileges, $tokenowner, $tokenprimarygroup, $tokendefaultdacl, $tokensource, $tokentype, $tokenimpersonationlevel, $tokenstatistics, $tokenrestrictedsids, $tokensessionid, $tokengroupsandprivileges, $tokensessionreference, $tokensandboxinert, $tokenauditpolicy, $tokenorigin, $tokenelevationtype, $tokenlinkedtoken, $tokenelevation, $tokenhasrestrictions, $tokenaccessinformation, $tokenvirtualizationallowed, $tokenvirtualizationenabled, $tokenintegritylevel, $tokenuiaccess, $tokenmandatorypolicy, $tokenlogonsid
Global Const $token_assign_primary = 1
Global Const $token_duplicate = 2
Global Const $token_impersonate = 4
Global Const $token_query = 8
Global Const $token_query_source = 16
Global Const $token_adjust_privileges = 32
Global Const $token_adjust_groups = 64
Global Const $token_adjust_default = 128
Global Const $token_adjust_sessionid = 256
Global Const $token_all_access = 983551
Global Const $token_read = 131080
Global Const $token_write = 131296
Global Const $token_execute = 131072
Global Const $token_has_traverse_privilege = 1
Global Const $token_has_backup_privilege = 2
Global Const $token_has_restore_privilege = 4
Global Const $token_has_admin_group = 8
Global Const $token_is_restricted = 16
Global Const $token_session_not_referenced = 32
Global Const $token_sandbox_inert = 64
Global Const $token_has_impersonate_privilege = 128
Global Const $rights_delete = 65536
Global Const $read_control = 131072
Global Const $write_dac = 262144
Global Const $write_owner = 524288
Global Const $synchronize = 1048576
Global Const $standard_rights_required = 983040
Global Const $standard_rights_read = $read_control
Global Const $standard_rights_write = $read_control
Global Const $standard_rights_execute = $read_control
Global Const $standard_rights_all = 2031616
Global Const $specific_rights_all = 65535
Global Enum $not_used_access = 0, $grant_access, $set_access, $deny_access, $revoke_access, $set_audit_success, $set_audit_failure
Global Enum $trustee_is_unknown = 0, $trustee_is_user, $trustee_is_group, $trustee_is_domain, $trustee_is_alias, $trustee_is_well_known_group, $trustee_is_deleted, $trustee_is_invalid, $trustee_is_computer
Global Const $logon_with_profile = 1
Global Const $logon_netcredentials_only = 2
Global Enum $sidtypeuser = 1, $sidtypegroup, $sidtypedomain, $sidtypealias, $sidtypewellknowngroup, $sidtypedeletedaccount, $sidtypeinvalid, $sidtypeunknown, $sidtypecomputer, $sidtypelabel
Global Const $sid_administrators = "S-1-5-32-544"
Global Const $sid_users = "S-1-5-32-545"
Global Const $sid_guests = "S-1-5-32-546"
Global Const $sid_account_operators = "S-1-5-32-548"
Global Const $sid_server_operators = "S-1-5-32-549"
Global Const $sid_print_operators = "S-1-5-32-550"
Global Const $sid_backup_operators = "S-1-5-32-551"
Global Const $sid_replicator = "S-1-5-32-552"
Global Const $sid_owner = "S-1-3-0"
Global Const $sid_everyone = "S-1-1-0"
Global Const $sid_network = "S-1-5-2"
Global Const $sid_interactive = "S-1-5-4"
Global Const $sid_system = "S-1-5-18"
Global Const $sid_authenticated_users = "S-1-5-11"
Global Const $sid_schannel_authentication = "S-1-5-64-14"
Global Const $sid_digest_authentication = "S-1-5-64-21"
Global Const $sid_nt_service = "S-1-5-80"
Global Const $sid_untrusted_mandatory_level = "S-1-16-0"
Global Const $sid_low_mandatory_level = "S-1-16-4096"
Global Const $sid_medium_mandatory_level = "S-1-16-8192"
Global Const $sid_medium_plus_mandatory_level = "S-1-16-8448"
Global Const $sid_high_mandatory_level = "S-1-16-12288"
Global Const $sid_system_mandatory_level = "S-1-16-16384"
Global Const $sid_protected_process_mandatory_level = "S-1-16-20480"
Global Const $sid_secure_process_mandatory_level = "S-1-16-28672"
Global Const $sid_all_services = "S-1-5-80-0"

Func _winapi_getlasterror($curerr = @error, $curext = @extended)
	Local $aresult = DllCall("kernel32.dll", "dword", "GetLastError")
	Return SetError($curerr, $curext, $aresult[0])
EndFunc

Func _winapi_setlasterror($ierrcode, $curerr = @error, $curext = @extended)
	DllCall("kernel32.dll", "none", "SetLastError", "dword", $ierrcode)
	Return SetError($curerr, $curext)
EndFunc

Func _security__adjusttokenprivileges($htoken, $fdisableall, $pnewstate, $ibufferlen, $pprevstate = 0, $prequired = 0)
	Local $acall = DllCall("advapi32.dll", "bool", "AdjustTokenPrivileges", "handle", $htoken, "bool", $fdisableall, "struct*", $pnewstate, "dword", $ibufferlen, "struct*", $pprevstate, "struct*", $prequired)
	If @error Then Return SetError(1, @extended, False)
	Return NOT ($acall[0] = 0)
EndFunc

Func _security__createprocesswithtoken($htoken, $ilogonflags, $scommandline, $icreationflags, $scurdir, $tstartupinfo, $tprocess_information)
	Local $acall = DllCall("advapi32.dll", "bool", "CreateProcessWithTokenW", "handle", $htoken, "dword", $ilogonflags, "ptr", 0, "wstr", $scommandline, "dword", $icreationflags, "struct*", 0, "wstr", $scurdir, "struct*", $tstartupinfo, "struct*", $tprocess_information)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, False)
	Return True
EndFunc

Func _security__duplicatetokenex($hexistingtoken, $idesiredaccess, $iimpersonationlevel, $itokentype)
	Local $acall = DllCall("advapi32.dll", "bool", "DuplicateTokenEx", "handle", $hexistingtoken, "dword", $idesiredaccess, "struct*", 0, "int", $iimpersonationlevel, "int", $itokentype, "handle*", 0)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Return $acall[6]
EndFunc

Func _security__getaccountsid($saccount, $ssystem = "")
	Local $aacct = _security__lookupaccountname($saccount, $ssystem)
	If @error Then Return SetError(@error, @extended, 0)
	If IsArray($aacct) Then Return _security__stringsidtosid($aacct[0])
	Return ""
EndFunc

Func _security__getlengthsid($psid)
	If NOT _security__isvalidsid($psid) Then Return SetError(1, @extended, 0)
	Local $acall = DllCall("advapi32.dll", "dword", "GetLengthSid", "struct*", $psid)
	If @error Then Return SetError(2, @extended, 0)
	Return $acall[0]
EndFunc

Func _security__gettokeninformation($htoken, $iclass)
	Local $acall = DllCall("advapi32.dll", "bool", "GetTokenInformation", "handle", $htoken, "int", $iclass, "struct*", 0, "dword", 0, "dword*", 0)
	If @error OR NOT $acall[5] Then Return SetError(1, @extended, 0)
	Local $ilen = $acall[5]
	Local $tbuffer = DllStructCreate("byte[" & $ilen & "]")
	$acall = DllCall("advapi32.dll", "bool", "GetTokenInformation", "handle", $htoken, "int", $iclass, "struct*", $tbuffer, "dword", DllStructGetSize($tbuffer), "dword*", 0)
	If @error OR NOT $acall[0] Then Return SetError(2, @extended, 0)
	Return $tbuffer
EndFunc

Func _security__impersonateself($ilevel = $securityimpersonation)
	Local $acall = DllCall("advapi32.dll", "bool", "ImpersonateSelf", "int", $ilevel)
	If @error Then Return SetError(1, @extended, False)
	Return NOT ($acall[0] = 0)
EndFunc

Func _security__isvalidsid($psid)
	Local $acall = DllCall("advapi32.dll", "bool", "IsValidSid", "struct*", $psid)
	If @error Then Return SetError(1, @extended, False)
	Return NOT ($acall[0] = 0)
EndFunc

Func _security__lookupaccountname($saccount, $ssystem = "")
	Local $tdata = DllStructCreate("byte SID[256]")
	Local $acall = DllCall("advapi32.dll", "bool", "LookupAccountNameW", "wstr", $ssystem, "wstr", $saccount, "struct*", $tdata, "dword*", DllStructGetSize($tdata), "wstr", "", "dword*", DllStructGetSize($tdata), "int*", 0)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Local $aacct[3]
	$aacct[0] = _security__sidtostringsid(DllStructGetPtr($tdata, "SID"))
	$aacct[1] = $acall[5]
	$aacct[2] = $acall[7]
	Return $aacct
EndFunc

Func _security__lookupaccountsid($vsid, $ssystem = "")
	Local $psid, $aacct[3]
	If IsString($vsid) Then
		$psid = _security__stringsidtosid($vsid)
	Else
		$psid = $vsid
	EndIf
	If NOT _security__isvalidsid($psid) Then Return SetError(1, @extended, 0)
	Local $typesystem = "ptr"
	If $ssystem Then $typesystem = "wstr"
	Local $acall = DllCall("advapi32.dll", "bool", "LookupAccountSidW", $typesystem, $ssystem, "struct*", $psid, "wstr", "", "dword*", 65536, "wstr", "", "dword*", 65536, "int*", 0)
	If @error OR NOT $acall[0] Then Return SetError(2, @extended, 0)
	Local $aacct[3]
	$aacct[0] = $acall[3]
	$aacct[1] = $acall[5]
	$aacct[2] = $acall[7]
	Return $aacct
EndFunc

Func _security__lookupprivilegevalue($ssystem, $sname)
	Local $acall = DllCall("advapi32.dll", "bool", "LookupPrivilegeValueW", "wstr", $ssystem, "wstr", $sname, "int64*", 0)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Return $acall[3]
EndFunc

Func _security__openprocesstoken($hprocess, $iaccess)
	Local $acall = DllCall("advapi32.dll", "bool", "OpenProcessToken", "handle", $hprocess, "dword", $iaccess, "handle*", 0)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Return $acall[3]
EndFunc

Func _security__openthreadtoken($iaccess, $hthread = 0, $fopenasself = False)
	If $hthread = 0 Then $hthread = _winapi_getcurrentthread()
	If @error Then Return SetError(1, @extended, 0)
	Local $acall = DllCall("advapi32.dll", "bool", "OpenThreadToken", "handle", $hthread, "dword", $iaccess, "bool", $fopenasself, "handle*", 0)
	If @error OR NOT $acall[0] Then Return SetError(2, @extended, 0)
	Return $acall[4]
EndFunc

Func _security__openthreadtokenex($iaccess, $hthread = 0, $fopenasself = False)
	Local $htoken = _security__openthreadtoken($iaccess, $hthread, $fopenasself)
	If $htoken = 0 Then
		If _winapi_getlasterror() <> $error_no_token Then Return SetError(3, _winapi_getlasterror(), 0)
		If NOT _security__impersonateself() Then Return SetError(1, _winapi_getlasterror(), 0)
		$htoken = _security__openthreadtoken($iaccess, $hthread, $fopenasself)
		If $htoken = 0 Then Return SetError(2, _winapi_getlasterror(), 0)
	EndIf
	Return $htoken
EndFunc

Func _security__setprivilege($htoken, $sprivilege, $fenable)
	Local $iluid = _security__lookupprivilegevalue("", $sprivilege)
	If $iluid = 0 Then Return SetError(1, @extended, False)
	Local $tcurrstate = DllStructCreate($tagtoken_privileges)
	Local $icurrstate = DllStructGetSize($tcurrstate)
	Local $tprevstate = DllStructCreate($tagtoken_privileges)
	Local $iprevstate = DllStructGetSize($tprevstate)
	Local $trequired = DllStructCreate("int Data")
	DllStructSetData($tcurrstate, "Count", 1)
	DllStructSetData($tcurrstate, "LUID", $iluid)
	If NOT _security__adjusttokenprivileges($htoken, False, $tcurrstate, $icurrstate, $tprevstate, $trequired) Then Return SetError(2, @error, False)
	DllStructSetData($tprevstate, "Count", 1)
	DllStructSetData($tprevstate, "LUID", $iluid)
	Local $iattributes = DllStructGetData($tprevstate, "Attributes")
	If $fenable Then
		$iattributes = BitOR($iattributes, $se_privilege_enabled)
	Else
		$iattributes = BitAND($iattributes, BitNOT($se_privilege_enabled))
	EndIf
	DllStructSetData($tprevstate, "Attributes", $iattributes)
	If NOT _security__adjusttokenprivileges($htoken, False, $tprevstate, $iprevstate, $tcurrstate, $trequired) Then Return SetError(3, @error, False)
	Return True
EndFunc

Func _security__settokeninformation($htoken, $itokeninformation, $vtokeninformation, $itokeninformationlength)
	Local $acall = DllCall("advapi32.dll", "bool", "SetTokenInformation", "handle", $htoken, "int", $itokeninformation, "struct*", $vtokeninformation, "dword", $itokeninformationlength)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, False)
	Return True
EndFunc

Func _security__sidtostringsid($psid)
	If NOT _security__isvalidsid($psid) Then Return SetError(1, 0, "")
	Local $acall = DllCall("advapi32.dll", "bool", "ConvertSidToStringSidW", "struct*", $psid, "ptr*", 0)
	If @error OR NOT $acall[0] Then Return SetError(2, @extended, "")
	Local $pstringsid = $acall[2]
	Local $ssid = DllStructGetData(DllStructCreate("wchar Text[" & _winapi_stringlenw($pstringsid) + 1 & "]", $pstringsid), "Text")
	_winapi_localfree($pstringsid)
	Return $ssid
EndFunc

Func _security__sidtypestr($itype)
	Switch $itype
		Case $sidtypeuser
			Return "User"
		Case $sidtypegroup
			Return "Group"
		Case $sidtypedomain
			Return "Domain"
		Case $sidtypealias
			Return "Alias"
		Case $sidtypewellknowngroup
			Return "Well Known Group"
		Case $sidtypedeletedaccount
			Return "Deleted Account"
		Case $sidtypeinvalid
			Return "Invalid"
		Case $sidtypeunknown
			Return "Unknown Type"
		Case $sidtypecomputer
			Return "Computer"
		Case $sidtypelabel
			Return "A mandatory integrity label SID"
		Case Else
			Return "Unknown SID Type"
	EndSwitch
EndFunc

Func _security__stringsidtosid($ssid)
	Local $acall = DllCall("advapi32.dll", "bool", "ConvertStringSidToSidW", "wstr", $ssid, "ptr*", 0)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Local $psid = $acall[2]
	Local $tbuffer = DllStructCreate("byte Data[" & _security__getlengthsid($psid) & "]", $psid)
	Local $tsid = DllStructCreate("byte Data[" & DllStructGetSize($tbuffer) & "]")
	DllStructSetData($tsid, "Data", DllStructGetData($tbuffer, "Data"))
	_winapi_localfree($psid)
	Return $tsid
EndFunc

Func _sendmessage($hwnd, $imsg, $wparam = 0, $lparam = 0, $ireturn = 0, $wparamtype = "wparam", $lparamtype = "lparam", $sreturntype = "lresult")
	Local $aresult = DllCall("user32.dll", $sreturntype, "SendMessageW", "hwnd", $hwnd, "uint", $imsg, $wparamtype, $wparam, $lparamtype, $lparam)
	If @error Then Return SetError(@error, @extended, "")
	If $ireturn >= 0 AND $ireturn <= 4 Then Return $aresult[$ireturn]
	Return $aresult
EndFunc

Func _sendmessagea($hwnd, $imsg, $wparam = 0, $lparam = 0, $ireturn = 0, $wparamtype = "wparam", $lparamtype = "lparam", $sreturntype = "lresult")
	Local $aresult = DllCall("user32.dll", $sreturntype, "SendMessageA", "hwnd", $hwnd, "uint", $imsg, $wparamtype, $wparam, $lparamtype, $lparam)
	If @error Then Return SetError(@error, @extended, "")
	If $ireturn >= 0 AND $ireturn <= 4 Then Return $aresult[$ireturn]
	Return $aresult
EndFunc

Global $__gainprocess_winapi[64][2] = [[0, 0]]
Global $__gawinlist_winapi[64][2] = [[0, 0]]
Global Const $__winapiconstant_wm_setfont = 48
Global Const $__winapiconstant_fw_normal = 400
Global Const $__winapiconstant_default_charset = 1
Global Const $__winapiconstant_out_default_precis = 0
Global Const $__winapiconstant_clip_default_precis = 0
Global Const $__winapiconstant_default_quality = 0
Global Const $__winapiconstant_format_message_allocate_buffer = 256
Global Const $__winapiconstant_format_message_from_system = 4096
Global Const $__winapiconstant_logpixelsx = 88
Global Const $__winapiconstant_logpixelsy = 90
Global Const $hgdi_error = Ptr(-1)
Global Const $invalid_handle_value = Ptr(-1)
Global Const $clr_invalid = -1
Global Const $__winapiconstant_flashw_caption = 1
Global Const $__winapiconstant_flashw_tray = 2
Global Const $__winapiconstant_flashw_timer = 4
Global Const $__winapiconstant_flashw_timernofg = 12
Global Const $__winapiconstant_gw_hwndnext = 2
Global Const $__winapiconstant_gw_child = 5
Global Const $__winapiconstant_di_mask = 1
Global Const $__winapiconstant_di_image = 2
Global Const $__winapiconstant_di_normal = 3
Global Const $__winapiconstant_di_compat = 4
Global Const $__winapiconstant_di_defaultsize = 8
Global Const $__winapiconstant_di_nomirror = 16
Global Const $__winapiconstant_display_device_attached_to_desktop = 1
Global Const $__winapiconstant_display_device_primary_device = 4
Global Const $__winapiconstant_display_device_mirroring_driver = 8
Global Const $__winapiconstant_display_device_vga_compatible = 16
Global Const $__winapiconstant_display_device_removable = 32
Global Const $__winapiconstant_display_device_modespruned = 134217728
Global Const $null_brush = 5
Global Const $null_pen = 8
Global Const $black_brush = 4
Global Const $dkgray_brush = 3
Global Const $dc_brush = 18
Global Const $gray_brush = 2
Global Const $hollow_brush = $null_brush
Global Const $ltgray_brush = 1
Global Const $white_brush = 0
Global Const $black_pen = 7
Global Const $dc_pen = 19
Global Const $white_pen = 6
Global Const $ansi_fixed_font = 11
Global Const $ansi_var_font = 12
Global Const $device_default_font = 14
Global Const $default_gui_font = 17
Global Const $oem_fixed_font = 10
Global Const $system_font = 13
Global Const $system_fixed_font = 16
Global Const $default_palette = 15
Global Const $mb_precomposed = 1
Global Const $mb_composite = 2
Global Const $mb_useglyphchars = 4
Global Const $ulw_alpha = 2
Global Const $ulw_colorkey = 1
Global Const $ulw_opaque = 4
Global Const $wh_callwndproc = 4
Global Const $wh_callwndprocret = 12
Global Const $wh_cbt = 5
Global Const $wh_debug = 9
Global Const $wh_foregroundidle = 11
Global Const $wh_getmessage = 3
Global Const $wh_journalplayback = 1
Global Const $wh_journalrecord = 0
Global Const $wh_keyboard = 2
Global Const $wh_keyboard_ll = 13
Global Const $wh_mouse = 7
Global Const $wh_mouse_ll = 14
Global Const $wh_msgfilter = -1
Global Const $wh_shell = 10
Global Const $wh_sysmsgfilter = 6
Global Const $wpf_asyncwindowplacement = 4
Global Const $wpf_restoretomaximized = 2
Global Const $wpf_setminposition = 1
Global Const $kf_extended = 256
Global Const $kf_altdown = 8192
Global Const $kf_up = 32768
Global Const $llkhf_extended = BitShift($kf_extended, 8)
Global Const $llkhf_injected = 16
Global Const $llkhf_altdown = BitShift($kf_altdown, 8)
Global Const $llkhf_up = BitShift($kf_up, 8)
Global Const $ofn_allowmultiselect = 512
Global Const $ofn_createprompt = 8192
Global Const $ofn_dontaddtorecent = 33554432
Global Const $ofn_enablehook = 32
Global Const $ofn_enableincludenotify = 4194304
Global Const $ofn_enablesizing = 8388608
Global Const $ofn_enabletemplate = 64
Global Const $ofn_enabletemplatehandle = 128
Global Const $ofn_explorer = 524288
Global Const $ofn_extensiondifferent = 1024
Global Const $ofn_filemustexist = 4096
Global Const $ofn_forceshowhidden = 268435456
Global Const $ofn_hidereadonly = 4
Global Const $ofn_longnames = 2097152
Global Const $ofn_nochangedir = 8
Global Const $ofn_nodereferencelinks = 1048576
Global Const $ofn_nolongnames = 262144
Global Const $ofn_nonetworkbutton = 131072
Global Const $ofn_noreadonlyreturn = 32768
Global Const $ofn_notestfilecreate = 65536
Global Const $ofn_novalidate = 256
Global Const $ofn_overwriteprompt = 2
Global Const $ofn_pathmustexist = 2048
Global Const $ofn_readonly = 1
Global Const $ofn_shareaware = 16384
Global Const $ofn_showhelp = 16
Global Const $ofn_ex_noplacesbar = 1
Global Const $tmpf_fixed_pitch = 1
Global Const $tmpf_vector = 2
Global Const $tmpf_truetype = 4
Global Const $tmpf_device = 8
Global Const $duplicate_close_source = 1
Global Const $duplicate_same_access = 2
Global Const $tagcursorinfo = "dword Size;dword Flags;handle hCursor;" & $tagpoint
Global Const $tagdisplay_device = "dword Size;wchar Name[32];wchar String[128];dword Flags;wchar ID[128];wchar Key[128]"
Global Const $tagflashwinfo = "uint Size;hwnd hWnd;dword Flags;uint Count;dword TimeOut"
Global Const $tagiconinfo = "bool Icon;dword XHotSpot;dword YHotSpot;handle hMask;handle hColor"
Global Const $tagmemorystatusex = "dword Length;dword MemoryLoad;" & "uint64 TotalPhys;uint64 AvailPhys;uint64 TotalPageFile;uint64 AvailPageFile;" & "uint64 TotalVirtual;uint64 AvailVirtual;uint64 AvailExtendedVirtual"

Func _winapi_attachconsole($iprocessid = -1)
	Local $aresult = DllCall("kernel32.dll", "bool", "AttachConsole", "dword", $iprocessid)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_attachthreadinput($iattach, $iattachto, $fattach)
	Local $aresult = DllCall("user32.dll", "bool", "AttachThreadInput", "dword", $iattach, "dword", $iattachto, "bool", $fattach)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_beep($ifreq = 500, $iduration = 1000)
	Local $aresult = DllCall("kernel32.dll", "bool", "Beep", "dword", $ifreq, "dword", $iduration)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_bitblt($hdestdc, $ixdest, $iydest, $iwidth, $iheight, $hsrcdc, $ixsrc, $iysrc, $irop)
	Local $aresult = DllCall("gdi32.dll", "bool", "BitBlt", "handle", $hdestdc, "int", $ixdest, "int", $iydest, "int", $iwidth, "int", $iheight, "handle", $hsrcdc, "int", $ixsrc, "int", $iysrc, "dword", $irop)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_callnexthookex($hhk, $icode, $wparam, $lparam)
	Local $aresult = DllCall("user32.dll", "lresult", "CallNextHookEx", "handle", $hhk, "int", $icode, "wparam", $wparam, "lparam", $lparam)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_callwindowproc($lpprevwndfunc, $hwnd, $msg, $wparam, $lparam)
	Local $aresult = DllCall("user32.dll", "lresult", "CallWindowProc", "ptr", $lpprevwndfunc, "hwnd", $hwnd, "uint", $msg, "wparam", $wparam, "lparam", $lparam)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_clienttoscreen($hwnd, ByRef $tpoint)
	DllCall("user32.dll", "bool", "ClientToScreen", "hwnd", $hwnd, "struct*", $tpoint)
	Return SetError(@error, @extended, $tpoint)
EndFunc

Func _winapi_closehandle($hobject)
	Local $aresult = DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $hobject)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_combinergn($hrgndest, $hrgnsrc1, $hrgnsrc2, $icombinemode)
	Local $aresult = DllCall("gdi32.dll", "int", "CombineRgn", "handle", $hrgndest, "handle", $hrgnsrc1, "handle", $hrgnsrc2, "int", $icombinemode)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_commdlgextendederror()
	Local Const $cderr_dialogfailure = 65535
	Local Const $cderr_findresfailure = 6
	Local Const $cderr_initialization = 2
	Local Const $cderr_loadresfailure = 7
	Local Const $cderr_loadstrfailure = 5
	Local Const $cderr_lockresfailure = 8
	Local Const $cderr_memallocfailure = 9
	Local Const $cderr_memlockfailure = 10
	Local Const $cderr_nohinstance = 4
	Local Const $cderr_nohook = 11
	Local Const $cderr_notemplate = 3
	Local Const $cderr_registermsgfail = 12
	Local Const $cderr_structsize = 1
	Local Const $fnerr_buffertoosmall = 12291
	Local Const $fnerr_invalidfilename = 12290
	Local Const $fnerr_subclassfailure = 12289
	Local $aresult = DllCall("comdlg32.dll", "dword", "CommDlgExtendedError")
	If @error Then Return SetError(@error, @extended, 0)
	Switch $aresult[0]
		Case $cderr_dialogfailure
			Return SetError($aresult[0], 0, "The dialog box could not be created." & @LF & "The common dialog box function's call to the DialogBox function failed." & @LF & "For example, this error occurs if the common dialog box call specifies an invalid window handle.")
		Case $cderr_findresfailure
			Return SetError($aresult[0], 0, "The common dialog box function failed to find a specified resource.")
		Case $cderr_initialization
			Return SetError($aresult[0], 0, "The common dialog box function failed during initialization." & @LF & "This error often occurs when sufficient memory is not available.")
		Case $cderr_loadresfailure
			Return SetError($aresult[0], 0, "The common dialog box function failed to load a specified resource.")
		Case $cderr_loadstrfailure
			Return SetError($aresult[0], 0, "The common dialog box function failed to load a specified string.")
		Case $cderr_lockresfailure
			Return SetError($aresult[0], 0, "The common dialog box function failed to lock a specified resource.")
		Case $cderr_memallocfailure
			Return SetError($aresult[0], 0, "The common dialog box function was unable to allocate memory for internal structures.")
		Case $cderr_memlockfailure
			Return SetError($aresult[0], 0, "The common dialog box function was unable to lock the memory associated with a handle.")
		Case $cderr_nohinstance
			Return SetError($aresult[0], 0, "The ENABLETEMPLATE flag was set in the Flags member of the initialization structure for the corresponding common dialog box," & @LF & "but you failed to provide a corresponding instance handle.")
		Case $cderr_nohook
			Return SetError($aresult[0], 0, "The ENABLEHOOK flag was set in the Flags member of the initialization structure for the corresponding common dialog box," & @LF & "but you failed to provide a pointer to a corresponding hook procedure.")
		Case $cderr_notemplate
			Return SetError($aresult[0], 0, "The ENABLETEMPLATE flag was set in the Flags member of the initialization structure for the corresponding common dialog box," & @LF & "but you failed to provide a corresponding template.")
		Case $cderr_registermsgfail
			Return SetError($aresult[0], 0, "The RegisterWindowMessage function returned an error code when it was called by the common dialog box function.")
		Case $cderr_structsize
			Return SetError($aresult[0], 0, "The lStructSize member of the initialization structure for the corresponding common dialog box is invalid")
		Case $fnerr_buffertoosmall
			Return SetError($aresult[0], 0, "The buffer pointed to by the lpstrFile member of the OPENFILENAME structure is too small for the file name specified by the user." & @LF & "The first two bytes of the lpstrFile buffer contain an integer value specifying the size, in TCHARs, required to receive the full name.")
		Case $fnerr_invalidfilename
			Return SetError($aresult[0], 0, "A file name is invalid.")
		Case $fnerr_subclassfailure
			Return SetError($aresult[0], 0, "An attempt to subclass a list box failed because sufficient memory was not available.")
	EndSwitch
	Return Hex($aresult[0])
EndFunc

Func _winapi_copyicon($hicon)
	Local $aresult = DllCall("user32.dll", "handle", "CopyIcon", "handle", $hicon)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createbitmap($iwidth, $iheight, $iplanes = 1, $ibitsperpel = 1, $pbits = 0)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateBitmap", "int", $iwidth, "int", $iheight, "uint", $iplanes, "uint", $ibitsperpel, "ptr", $pbits)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createcompatiblebitmap($hdc, $iwidth, $iheight)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateCompatibleBitmap", "handle", $hdc, "int", $iwidth, "int", $iheight)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createcompatibledc($hdc)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateCompatibleDC", "handle", $hdc)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createevent($pattributes = 0, $fmanualreset = True, $finitialstate = True, $sname = "")
	Local $snametype = "wstr"
	If $sname = "" Then
		$sname = 0
		$snametype = "ptr"
	EndIf
	Local $aresult = DllCall("kernel32.dll", "handle", "CreateEventW", "ptr", $pattributes, "bool", $fmanualreset, "bool", $finitialstate, $snametype, $sname)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createfile($sfilename, $icreation, $iaccess = 4, $ishare = 0, $iattributes = 0, $psecurity = 0)
	Local $ida = 0, $ism = 0, $icd = 0, $ifa = 0
	If BitAND($iaccess, 1) <> 0 Then $ida = BitOR($ida, $generic_execute)
	If BitAND($iaccess, 2) <> 0 Then $ida = BitOR($ida, $generic_read)
	If BitAND($iaccess, 4) <> 0 Then $ida = BitOR($ida, $generic_write)
	If BitAND($ishare, 1) <> 0 Then $ism = BitOR($ism, $file_share_delete)
	If BitAND($ishare, 2) <> 0 Then $ism = BitOR($ism, $file_share_read)
	If BitAND($ishare, 4) <> 0 Then $ism = BitOR($ism, $file_share_write)
	Switch $icreation
		Case 0
			$icd = $create_new
		Case 1
			$icd = $create_always
		Case 2
			$icd = $open_existing
		Case 3
			$icd = $open_always
		Case 4
			$icd = $truncate_existing
	EndSwitch
	If BitAND($iattributes, 1) <> 0 Then $ifa = BitOR($ifa, $file_attribute_archive)
	If BitAND($iattributes, 2) <> 0 Then $ifa = BitOR($ifa, $file_attribute_hidden)
	If BitAND($iattributes, 4) <> 0 Then $ifa = BitOR($ifa, $file_attribute_readonly)
	If BitAND($iattributes, 8) <> 0 Then $ifa = BitOR($ifa, $file_attribute_system)
	Local $aresult = DllCall("kernel32.dll", "handle", "CreateFileW", "wstr", $sfilename, "dword", $ida, "dword", $ism, "ptr", $psecurity, "dword", $icd, "dword", $ifa, "ptr", 0)
	If @error OR $aresult[0] = Ptr(-1) Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createfont($nheight, $nwidth, $nescape = 0, $norientn = 0, $fnweight = $__winapiconstant_fw_normal, $bitalic = False, $bunderline = False, $bstrikeout = False, $ncharset = $__winapiconstant_default_charset, $noutputprec = $__winapiconstant_out_default_precis, $nclipprec = $__winapiconstant_clip_default_precis, $nquality = $__winapiconstant_default_quality, $npitch = 0, $szface = "Arial")
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateFontW", "int", $nheight, "int", $nwidth, "int", $nescape, "int", $norientn, "int", $fnweight, "dword", $bitalic, "dword", $bunderline, "dword", $bstrikeout, "dword", $ncharset, "dword", $noutputprec, "dword", $nclipprec, "dword", $nquality, "dword", $npitch, "wstr", $szface)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createfontindirect($tlogfont)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateFontIndirectW", "struct*", $tlogfont)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createpen($ipenstyle, $iwidth, $ncolor)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreatePen", "int", $ipenstyle, "int", $iwidth, "dword", $ncolor)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createprocess($sappname, $scommand, $psecurity, $pthread, $finherit, $iflags, $penviron, $sdir, $pstartupinfo, $pprocess)
	Local $tcommand = 0
	Local $sappnametype = "wstr", $sdirtype = "wstr"
	If $sappname = "" Then
		$sappnametype = "ptr"
		$sappname = 0
	EndIf
	If $scommand <> "" Then
		$tcommand = DllStructCreate("wchar Text[" & 260 + 1 & "]")
		DllStructSetData($tcommand, "Text", $scommand)
	EndIf
	If $sdir = "" Then
		$sdirtype = "ptr"
		$sdir = 0
	EndIf
	Local $aresult = DllCall("kernel32.dll", "bool", "CreateProcessW", $sappnametype, $sappname, "struct*", $tcommand, "ptr", $psecurity, "ptr", $pthread, "bool", $finherit, "dword", $iflags, "ptr", $penviron, $sdirtype, $sdir, "ptr", $pstartupinfo, "ptr", $pprocess)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_createrectrgn($ileftrect, $itoprect, $irightrect, $ibottomrect)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateRectRgn", "int", $ileftrect, "int", $itoprect, "int", $irightrect, "int", $ibottomrect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createroundrectrgn($ileftrect, $itoprect, $irightrect, $ibottomrect, $iwidthellipse, $iheightellipse)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateRoundRectRgn", "int", $ileftrect, "int", $itoprect, "int", $irightrect, "int", $ibottomrect, "int", $iwidthellipse, "int", $iheightellipse)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createsolidbitmap($hwnd, $icolor, $iwidth, $iheight, $brgb = 1)
	Local $hdc = _winapi_getdc($hwnd)
	Local $hdestdc = _winapi_createcompatibledc($hdc)
	Local $hbitmap = _winapi_createcompatiblebitmap($hdc, $iwidth, $iheight)
	Local $hold = _winapi_selectobject($hdestdc, $hbitmap)
	Local $trect = DllStructCreate($tagrect)
	DllStructSetData($trect, 1, 0)
	DllStructSetData($trect, 2, 0)
	DllStructSetData($trect, 3, $iwidth)
	DllStructSetData($trect, 4, $iheight)
	If $brgb Then
		$icolor = BitOR(BitAND($icolor, 65280), BitShift(BitAND($icolor, 255), -16), BitShift(BitAND($icolor, 16711680), 16))
	EndIf
	Local $hbrush = _winapi_createsolidbrush($icolor)
	_winapi_fillrect($hdestdc, $trect, $hbrush)
	If @error Then
		_winapi_deleteobject($hbitmap)
		$hbitmap = 0
	EndIf
	_winapi_deleteobject($hbrush)
	_winapi_releasedc($hwnd, $hdc)
	_winapi_selectobject($hdestdc, $hold)
	_winapi_deletedc($hdestdc)
	If NOT $hbitmap Then Return SetError(1, 0, 0)
	Return $hbitmap
EndFunc

Func _winapi_createsolidbrush($ncolor)
	Local $aresult = DllCall("gdi32.dll", "handle", "CreateSolidBrush", "dword", $ncolor)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_createwindowex($iexstyle, $sclass, $sname, $istyle, $ix, $iy, $iwidth, $iheight, $hparent, $hmenu = 0, $hinstance = 0, $pparam = 0)
	If $hinstance = 0 Then $hinstance = _winapi_getmodulehandle("")
	Local $aresult = DllCall("user32.dll", "hwnd", "CreateWindowExW", "dword", $iexstyle, "wstr", $sclass, "wstr", $sname, "dword", $istyle, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight, "hwnd", $hparent, "handle", $hmenu, "handle", $hinstance, "ptr", $pparam)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_defwindowproc($hwnd, $imsg, $iwparam, $ilparam)
	Local $aresult = DllCall("user32.dll", "lresult", "DefWindowProc", "hwnd", $hwnd, "uint", $imsg, "wparam", $iwparam, "lparam", $ilparam)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_deletedc($hdc)
	Local $aresult = DllCall("gdi32.dll", "bool", "DeleteDC", "handle", $hdc)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_deleteobject($hobject)
	Local $aresult = DllCall("gdi32.dll", "bool", "DeleteObject", "handle", $hobject)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_destroyicon($hicon)
	Local $aresult = DllCall("user32.dll", "bool", "DestroyIcon", "handle", $hicon)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_destroywindow($hwnd)
	Local $aresult = DllCall("user32.dll", "bool", "DestroyWindow", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_drawedge($hdc, $ptrrect, $nedgetype, $grfflags)
	Local $aresult = DllCall("user32.dll", "bool", "DrawEdge", "handle", $hdc, "ptr", $ptrrect, "uint", $nedgetype, "uint", $grfflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_drawframecontrol($hdc, $ptrrect, $ntype, $nstate)
	Local $aresult = DllCall("user32.dll", "bool", "DrawFrameControl", "handle", $hdc, "ptr", $ptrrect, "uint", $ntype, "uint", $nstate)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_drawicon($hdc, $ix, $iy, $hicon)
	Local $aresult = DllCall("user32.dll", "bool", "DrawIcon", "handle", $hdc, "int", $ix, "int", $iy, "handle", $hicon)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_drawiconex($hdc, $ix, $iy, $hicon, $iwidth = 0, $iheight = 0, $istep = 0, $hbrush = 0, $iflags = 3)
	Local $ioptions
	Switch $iflags
		Case 1
			$ioptions = $__winapiconstant_di_mask
		Case 2
			$ioptions = $__winapiconstant_di_image
		Case 3
			$ioptions = $__winapiconstant_di_normal
		Case 4
			$ioptions = $__winapiconstant_di_compat
		Case 5
			$ioptions = $__winapiconstant_di_defaultsize
		Case Else
			$ioptions = $__winapiconstant_di_nomirror
	EndSwitch
	Local $aresult = DllCall("user32.dll", "bool", "DrawIconEx", "handle", $hdc, "int", $ix, "int", $iy, "handle", $hicon, "int", $iwidth, "int", $iheight, "uint", $istep, "handle", $hbrush, "uint", $ioptions)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_drawline($hdc, $ix1, $iy1, $ix2, $iy2)
	_winapi_moveto($hdc, $ix1, $iy1)
	If @error Then Return SetError(@error, @extended, False)
	_winapi_lineto($hdc, $ix2, $iy2)
	If @error Then Return SetError(@error, @extended, False)
	Return True
EndFunc

Func _winapi_drawtext($hdc, $stext, ByRef $trect, $iflags)
	Local $aresult = DllCall("user32.dll", "int", "DrawTextW", "handle", $hdc, "wstr", $stext, "int", -1, "struct*", $trect, "uint", $iflags)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_duplicatehandle($hsourceprocesshandle, $hsourcehandle, $htargetprocesshandle, $idesiredaccess, $finherithandle, $ioptions)
	Local $acall = DllCall("kernel32.dll", "bool", "DuplicateHandle", "handle", $hsourceprocesshandle, "handle", $hsourcehandle, "handle", $htargetprocesshandle, "handle*", 0, "dword", $idesiredaccess, "bool", $finherithandle, "dword", $ioptions)
	If @error OR NOT $acall[0] Then Return SetError(1, @extended, 0)
	Return $acall[4]
EndFunc

Func _winapi_enablewindow($hwnd, $fenable = True)
	Local $aresult = DllCall("user32.dll", "bool", "EnableWindow", "hwnd", $hwnd, "bool", $fenable)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_enumdisplaydevices($sdevice, $idevnum)
	Local $tname = 0, $iflags = 0, $adevice[5]
	If $sdevice <> "" Then
		$tname = DllStructCreate("wchar Text[" & StringLen($sdevice) + 1 & "]")
		DllStructSetData($tname, "Text", $sdevice)
	EndIf
	Local $tdevice = DllStructCreate($tagdisplay_device)
	Local $idevice = DllStructGetSize($tdevice)
	DllStructSetData($tdevice, "Size", $idevice)
	DllCall("user32.dll", "bool", "EnumDisplayDevicesW", "struct*", $tname, "dword", $idevnum, "struct*", $tdevice, "dword", 1)
	If @error Then Return SetError(@error, @extended, 0)
	Local $in = DllStructGetData($tdevice, "Flags")
	If BitAND($in, $__winapiconstant_display_device_attached_to_desktop) <> 0 Then $iflags = BitOR($iflags, 1)
	If BitAND($in, $__winapiconstant_display_device_primary_device) <> 0 Then $iflags = BitOR($iflags, 2)
	If BitAND($in, $__winapiconstant_display_device_mirroring_driver) <> 0 Then $iflags = BitOR($iflags, 4)
	If BitAND($in, $__winapiconstant_display_device_vga_compatible) <> 0 Then $iflags = BitOR($iflags, 8)
	If BitAND($in, $__winapiconstant_display_device_removable) <> 0 Then $iflags = BitOR($iflags, 16)
	If BitAND($in, $__winapiconstant_display_device_modespruned) <> 0 Then $iflags = BitOR($iflags, 32)
	$adevice[0] = True
	$adevice[1] = DllStructGetData($tdevice, "Name")
	$adevice[2] = DllStructGetData($tdevice, "String")
	$adevice[3] = $iflags
	$adevice[4] = DllStructGetData($tdevice, "ID")
	Return $adevice
EndFunc

Func _winapi_enumwindows($fvisible = True, $hwnd = Default)
	__winapi_enumwindowsinit()
	If $hwnd = Default Then $hwnd = _winapi_getdesktopwindow()
	__winapi_enumwindowschild($hwnd, $fvisible)
	Return $__gawinlist_winapi
EndFunc

Func __winapi_enumwindowsadd($hwnd, $sclass = "")
	If $sclass = "" Then $sclass = _winapi_getclassname($hwnd)
	$__gawinlist_winapi[0][0] += 1
	Local $icount = $__gawinlist_winapi[0][0]
	If $icount >= $__gawinlist_winapi[0][1] Then
		ReDim $__gawinlist_winapi[$icount + 64][2]
		$__gawinlist_winapi[0][1] += 64
	EndIf
	$__gawinlist_winapi[$icount][0] = $hwnd
	$__gawinlist_winapi[$icount][1] = $sclass
EndFunc

Func __winapi_enumwindowschild($hwnd, $fvisible = True)
	$hwnd = _winapi_getwindow($hwnd, $__winapiconstant_gw_child)
	While $hwnd <> 0
		If (NOT $fvisible) OR _winapi_iswindowvisible($hwnd) Then
			__winapi_enumwindowschild($hwnd, $fvisible)
			__winapi_enumwindowsadd($hwnd)
		EndIf
		$hwnd = _winapi_getwindow($hwnd, $__winapiconstant_gw_hwndnext)
	WEnd
EndFunc

Func __winapi_enumwindowsinit()
	ReDim $__gawinlist_winapi[64][2]
	$__gawinlist_winapi[0][0] = 0
	$__gawinlist_winapi[0][1] = 64
EndFunc

Func _winapi_enumwindowspopup()
	__winapi_enumwindowsinit()
	Local $hwnd = _winapi_getwindow(_winapi_getdesktopwindow(), $__winapiconstant_gw_child)
	Local $sclass
	While $hwnd <> 0
		If _winapi_iswindowvisible($hwnd) Then
			$sclass = _winapi_getclassname($hwnd)
			If $sclass = "#32768" Then
				__winapi_enumwindowsadd($hwnd)
			ElseIf $sclass = "ToolbarWindow32" Then
				__winapi_enumwindowsadd($hwnd)
			ElseIf $sclass = "ToolTips_Class32" Then
				__winapi_enumwindowsadd($hwnd)
			ElseIf $sclass = "BaseBar" Then
				__winapi_enumwindowschild($hwnd)
			EndIf
		EndIf
		$hwnd = _winapi_getwindow($hwnd, $__winapiconstant_gw_hwndnext)
	WEnd
	Return $__gawinlist_winapi
EndFunc

Func _winapi_enumwindowstop()
	__winapi_enumwindowsinit()
	Local $hwnd = _winapi_getwindow(_winapi_getdesktopwindow(), $__winapiconstant_gw_child)
	While $hwnd <> 0
		If _winapi_iswindowvisible($hwnd) Then __winapi_enumwindowsadd($hwnd)
		$hwnd = _winapi_getwindow($hwnd, $__winapiconstant_gw_hwndnext)
	WEnd
	Return $__gawinlist_winapi
EndFunc

Func _winapi_expandenvironmentstrings($sstring)
	Local $aresult = DllCall("kernel32.dll", "dword", "ExpandEnvironmentStringsW", "wstr", $sstring, "wstr", "", "dword", 4096)
	If @error Then Return SetError(@error, @extended, "")
	Return $aresult[2]
EndFunc

Func _winapi_extracticonex($sfile, $iindex, $plarge, $psmall, $iicons)
	Local $aresult = DllCall("shell32.dll", "uint", "ExtractIconExW", "wstr", $sfile, "int", $iindex, "struct*", $plarge, "struct*", $psmall, "uint", $iicons)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_fatalappexit($smessage)
	DllCall("kernel32.dll", "none", "FatalAppExitW", "uint", 0, "wstr", $smessage)
	If @error Then Return SetError(@error, @extended)
EndFunc

Func _winapi_fillrect($hdc, $ptrrect, $hbrush)
	Local $aresult
	If IsPtr($hbrush) Then
		$aresult = DllCall("user32.dll", "int", "FillRect", "handle", $hdc, "struct*", $ptrrect, "handle", $hbrush)
	Else
		$aresult = DllCall("user32.dll", "int", "FillRect", "handle", $hdc, "struct*", $ptrrect, "dword_ptr", $hbrush)
	EndIf
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_findexecutable($sfilename, $sdirectory = "")
	Local $aresult = DllCall("shell32.dll", "INT", "FindExecutableW", "wstr", $sfilename, "wstr", $sdirectory, "wstr", "")
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _winapi_findwindow($sclassname, $swindowname)
	Local $aresult = DllCall("user32.dll", "hwnd", "FindWindowW", "wstr", $sclassname, "wstr", $swindowname)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_flashwindow($hwnd, $finvert = True)
	Local $aresult = DllCall("user32.dll", "bool", "FlashWindow", "hwnd", $hwnd, "bool", $finvert)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_flashwindowex($hwnd, $iflags = 3, $icount = 3, $itimeout = 0)
	Local $tflash = DllStructCreate($tagflashwinfo)
	Local $iflash = DllStructGetSize($tflash)
	Local $imode = 0
	If BitAND($iflags, 1) <> 0 Then $imode = BitOR($imode, $__winapiconstant_flashw_caption)
	If BitAND($iflags, 2) <> 0 Then $imode = BitOR($imode, $__winapiconstant_flashw_tray)
	If BitAND($iflags, 4) <> 0 Then $imode = BitOR($imode, $__winapiconstant_flashw_timer)
	If BitAND($iflags, 8) <> 0 Then $imode = BitOR($imode, $__winapiconstant_flashw_timernofg)
	DllStructSetData($tflash, "Size", $iflash)
	DllStructSetData($tflash, "hWnd", $hwnd)
	DllStructSetData($tflash, "Flags", $imode)
	DllStructSetData($tflash, "Count", $icount)
	DllStructSetData($tflash, "Timeout", $itimeout)
	Local $aresult = DllCall("user32.dll", "bool", "FlashWindowEx", "struct*", $tflash)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_floattoint($nfloat)
	Local $tfloat = DllStructCreate("float")
	Local $tint = DllStructCreate("int", DllStructGetPtr($tfloat))
	DllStructSetData($tfloat, 1, $nfloat)
	Return DllStructGetData($tint, 1)
EndFunc

Func _winapi_flushfilebuffers($hfile)
	Local $aresult = DllCall("kernel32.dll", "bool", "FlushFileBuffers", "handle", $hfile)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_formatmessage($iflags, $psource, $imessageid, $ilanguageid, ByRef $pbuffer, $isize, $varguments)
	Local $sbuffertype = "struct*"
	If IsString($pbuffer) Then $sbuffertype = "wstr"
	Local $aresult = DllCall("Kernel32.dll", "dword", "FormatMessageW", "dword", $iflags, "ptr", $psource, "dword", $imessageid, "dword", $ilanguageid, $sbuffertype, $pbuffer, "dword", $isize, "ptr", $varguments)
	If @error Then Return SetError(@error, @extended, 0)
	If $sbuffertype = "wstr" Then $pbuffer = $aresult[5]
	Return $aresult[0]
EndFunc

Func _winapi_framerect($hdc, $ptrrect, $hbrush)
	Local $aresult = DllCall("user32.dll", "int", "FrameRect", "handle", $hdc, "ptr", $ptrrect, "handle", $hbrush)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_freelibrary($hmodule)
	Local $aresult = DllCall("kernel32.dll", "bool", "FreeLibrary", "handle", $hmodule)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_getancestor($hwnd, $iflags = 1)
	Local $aresult = DllCall("user32.dll", "hwnd", "GetAncestor", "hwnd", $hwnd, "uint", $iflags)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getasynckeystate($ikey)
	Local $aresult = DllCall("user32.dll", "short", "GetAsyncKeyState", "int", $ikey)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getbkmode($hdc)
	Local $aresult = DllCall("gdi32.dll", "int", "GetBkMode", "handle", $hdc)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getclassname($hwnd)
	If NOT IsHWnd($hwnd) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $aresult = DllCall("user32.dll", "int", "GetClassNameW", "hwnd", $hwnd, "wstr", "", "int", 4096)
	If @error Then Return SetError(@error, @extended, False)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _winapi_getclientheight($hwnd)
	Local $trect = _winapi_getclientrect($hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($trect, "Bottom") - DllStructGetData($trect, "Top")
EndFunc

Func _winapi_getclientwidth($hwnd)
	Local $trect = _winapi_getclientrect($hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($trect, "Right") - DllStructGetData($trect, "Left")
EndFunc

Func _winapi_getclientrect($hwnd)
	Local $trect = DllStructCreate($tagrect)
	DllCall("user32.dll", "bool", "GetClientRect", "hwnd", $hwnd, "struct*", $trect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $trect
EndFunc

Func _winapi_getcurrentprocess()
	Local $aresult = DllCall("kernel32.dll", "handle", "GetCurrentProcess")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getcurrentprocessid()
	Local $aresult = DllCall("kernel32.dll", "dword", "GetCurrentProcessId")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getcurrentthread()
	Local $aresult = DllCall("kernel32.dll", "handle", "GetCurrentThread")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getcurrentthreadid()
	Local $aresult = DllCall("kernel32.dll", "dword", "GetCurrentThreadId")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getcursorinfo()
	Local $tcursor = DllStructCreate($tagcursorinfo)
	Local $icursor = DllStructGetSize($tcursor)
	DllStructSetData($tcursor, "Size", $icursor)
	DllCall("user32.dll", "bool", "GetCursorInfo", "struct*", $tcursor)
	If @error Then Return SetError(@error, @extended, 0)
	Local $acursor[5]
	$acursor[0] = True
	$acursor[1] = DllStructGetData($tcursor, "Flags") <> 0
	$acursor[2] = DllStructGetData($tcursor, "hCursor")
	$acursor[3] = DllStructGetData($tcursor, "X")
	$acursor[4] = DllStructGetData($tcursor, "Y")
	Return $acursor
EndFunc

Func _winapi_getdc($hwnd)
	Local $aresult = DllCall("user32.dll", "handle", "GetDC", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getdesktopwindow()
	Local $aresult = DllCall("user32.dll", "hwnd", "GetDesktopWindow")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getdevicecaps($hdc, $iindex)
	Local $aresult = DllCall("gdi32.dll", "int", "GetDeviceCaps", "handle", $hdc, "int", $iindex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getdibits($hdc, $hbmp, $istartscan, $iscanlines, $pbits, $pbi, $iusage)
	Local $aresult = DllCall("gdi32.dll", "int", "GetDIBits", "handle", $hdc, "handle", $hbmp, "uint", $istartscan, "uint", $iscanlines, "ptr", $pbits, "ptr", $pbi, "uint", $iusage)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_getdlgctrlid($hwnd)
	Local $aresult = DllCall("user32.dll", "int", "GetDlgCtrlID", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getdlgitem($hwnd, $iitemid)
	Local $aresult = DllCall("user32.dll", "hwnd", "GetDlgItem", "hwnd", $hwnd, "int", $iitemid)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getfocus()
	Local $aresult = DllCall("user32.dll", "hwnd", "GetFocus")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getforegroundwindow()
	Local $aresult = DllCall("user32.dll", "hwnd", "GetForegroundWindow")
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getguiresources($iflag = 0, $hprocess = -1)
	If $hprocess = -1 Then $hprocess = _winapi_getcurrentprocess()
	Local $aresult = DllCall("user32.dll", "dword", "GetGuiResources", "handle", $hprocess, "dword", $iflag)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_geticoninfo($hicon)
	Local $tinfo = DllStructCreate($tagiconinfo)
	DllCall("user32.dll", "bool", "GetIconInfo", "handle", $hicon, "struct*", $tinfo)
	If @error Then Return SetError(@error, @extended, 0)
	Local $aicon[6]
	$aicon[0] = True
	$aicon[1] = DllStructGetData($tinfo, "Icon") <> 0
	$aicon[2] = DllStructGetData($tinfo, "XHotSpot")
	$aicon[3] = DllStructGetData($tinfo, "YHotSpot")
	$aicon[4] = DllStructGetData($tinfo, "hMask")
	$aicon[5] = DllStructGetData($tinfo, "hColor")
	Return $aicon
EndFunc

Func _winapi_getfilesizeex($hfile)
	Local $aresult = DllCall("kernel32.dll", "bool", "GetFileSizeEx", "handle", $hfile, "int64*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[2]
EndFunc

Func _winapi_getlasterrormessage()
	Local $tbufferptr = DllStructCreate("ptr")
	Local $ncount = _winapi_formatmessage(BitOR($__winapiconstant_format_message_allocate_buffer, $__winapiconstant_format_message_from_system), 0, _winapi_getlasterror(), 0, $tbufferptr, 0, 0)
	If @error Then Return SetError(@error, 0, "")
	Local $stext = ""
	Local $pbuffer = DllStructGetData($tbufferptr, 1)
	If $pbuffer Then
		If $ncount > 0 Then
			Local $tbuffer = DllStructCreate("wchar[" & ($ncount + 1) & "]", $pbuffer)
			$stext = DllStructGetData($tbuffer, 1)
		EndIf
		_winapi_localfree($pbuffer)
	EndIf
	Return $stext
EndFunc

Func _winapi_getlayeredwindowattributes($hwnd, ByRef $i_transcolor, ByRef $transparency, $ascolorref = False)
	$i_transcolor = -1
	$transparency = -1
	Local $aresult = DllCall("user32.dll", "bool", "GetLayeredWindowAttributes", "hwnd", $hwnd, "dword*", $i_transcolor, "byte*", $transparency, "dword*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	If NOT $ascolorref Then
		$aresult[2] = Int(BinaryMid($aresult[2], 3, 1) & BinaryMid($aresult[2], 2, 1) & BinaryMid($aresult[2], 1, 1))
	EndIf
	$i_transcolor = $aresult[2]
	$transparency = $aresult[3]
	Return $aresult[4]
EndFunc

Func _winapi_getmodulehandle($smodulename)
	Local $smodulenametype = "wstr"
	If $smodulename = "" Then
		$smodulename = 0
		$smodulenametype = "ptr"
	EndIf
	Local $aresult = DllCall("kernel32.dll", "handle", "GetModuleHandleW", $smodulenametype, $smodulename)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getmousepos($ftoclient = False, $hwnd = 0)
	Local $imode = Opt("MouseCoordMode", 1)
	Local $apos = MouseGetPos()
	Opt("MouseCoordMode", $imode)
	Local $tpoint = DllStructCreate($tagpoint)
	DllStructSetData($tpoint, "X", $apos[0])
	DllStructSetData($tpoint, "Y", $apos[1])
	If $ftoclient Then
		_winapi_screentoclient($hwnd, $tpoint)
		If @error Then Return SetError(@error, @extended, 0)
	EndIf
	Return $tpoint
EndFunc

Func _winapi_getmouseposx($ftoclient = False, $hwnd = 0)
	Local $tpoint = _winapi_getmousepos($ftoclient, $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($tpoint, "X")
EndFunc

Func _winapi_getmouseposy($ftoclient = False, $hwnd = 0)
	Local $tpoint = _winapi_getmousepos($ftoclient, $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($tpoint, "Y")
EndFunc

Func _winapi_getobject($hobject, $isize, $pobject)
	Local $aresult = DllCall("gdi32.dll", "int", "GetObjectW", "handle", $hobject, "int", $isize, "ptr", $pobject)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getopenfilename($stitle = "", $sfilter = "All files (*.*)", $sinitaldir = ".", $sdefaultfile = "", $sdefaultext = "", $ifilterindex = 1, $iflags = 0, $iflagsex = 0, $hwndowner = 0)
	Local $ipathlen = 4096
	Local $inulls = 0
	Local $tofn = DllStructCreate($tagopenfilename)
	Local $afiles[1] = [0]
	Local $iflag = $iflags
	Local $asflines = StringSplit($sfilter, "|")
	Local $asfilter[$asflines[0] * 2 + 1]
	Local $istart, $ifinal, $stfilter
	$asfilter[0] = $asflines[0] * 2
	For $i = 1 To $asflines[0]
		$istart = StringInStr($asflines[$i], "(", 0, 1)
		$ifinal = StringInStr($asflines[$i], ")", 0, -1)
		$asfilter[$i * 2 - 1] = StringStripWS(StringLeft($asflines[$i], $istart - 1), 3)
		$asfilter[$i * 2] = StringStripWS(StringTrimRight(StringTrimLeft($asflines[$i], $istart), StringLen($asflines[$i]) - $ifinal + 1), 3)
		$stfilter &= "wchar[" & StringLen($asfilter[$i * 2 - 1]) + 1 & "];wchar[" & StringLen($asfilter[$i * 2]) + 1 & "];"
	Next
	Local $ttitle = DllStructCreate("wchar Title[" & StringLen($stitle) + 1 & "]")
	Local $tinitialdir = DllStructCreate("wchar InitDir[" & StringLen($sinitaldir) + 1 & "]")
	Local $tfilter = DllStructCreate($stfilter & "wchar")
	Local $tpath = DllStructCreate("wchar Path[" & $ipathlen & "]")
	Local $textn = DllStructCreate("wchar Extension[" & StringLen($sdefaultext) + 1 & "]")
	For $i = 1 To $asfilter[0]
		DllStructSetData($tfilter, $i, $asfilter[$i])
	Next
	DllStructSetData($ttitle, "Title", $stitle)
	DllStructSetData($tinitialdir, "InitDir", $sinitaldir)
	DllStructSetData($tpath, "Path", $sdefaultfile)
	DllStructSetData($textn, "Extension", $sdefaultext)
	DllStructSetData($tofn, "StructSize", DllStructGetSize($tofn))
	DllStructSetData($tofn, "hwndOwner", $hwndowner)
	DllStructSetData($tofn, "lpstrFilter", DllStructGetPtr($tfilter))
	DllStructSetData($tofn, "nFilterIndex", $ifilterindex)
	DllStructSetData($tofn, "lpstrFile", DllStructGetPtr($tpath))
	DllStructSetData($tofn, "nMaxFile", $ipathlen)
	DllStructSetData($tofn, "lpstrInitialDir", DllStructGetPtr($tinitialdir))
	DllStructSetData($tofn, "lpstrTitle", DllStructGetPtr($ttitle))
	DllStructSetData($tofn, "Flags", $iflag)
	DllStructSetData($tofn, "lpstrDefExt", DllStructGetPtr($textn))
	DllStructSetData($tofn, "FlagsEx", $iflagsex)
	DllCall("comdlg32.dll", "bool", "GetOpenFileNameW", "struct*", $tofn)
	If @error Then Return SetError(@error, @extended, $afiles)
	If BitAND($iflags, $ofn_allowmultiselect) = $ofn_allowmultiselect AND BitAND($iflags, $ofn_explorer) = $ofn_explorer Then
		For $x = 1 To $ipathlen
			If DllStructGetData($tpath, "Path", $x) = Chr(0) Then
				DllStructSetData($tpath, "Path", "|", $x)
				$inulls += 1
			Else
				$inulls = 0
			EndIf
			If $inulls = 2 Then ExitLoop
		Next
		DllStructSetData($tpath, "Path", Chr(0), $x - 1)
		$afiles = StringSplit(DllStructGetData($tpath, "Path"), "|")
		If $afiles[0] = 1 Then Return __winapi_parsefiledialogpath(DllStructGetData($tpath, "Path"))
		Return StringSplit(DllStructGetData($tpath, "Path"), "|")
	ElseIf BitAND($iflags, $ofn_allowmultiselect) = $ofn_allowmultiselect Then
		$afiles = StringSplit(DllStructGetData($tpath, "Path"), " ")
		If $afiles[0] = 1 Then Return __winapi_parsefiledialogpath(DllStructGetData($tpath, "Path"))
		Return StringSplit(StringReplace(DllStructGetData($tpath, "Path"), " ", "|"), "|")
	Else
		Return __winapi_parsefiledialogpath(DllStructGetData($tpath, "Path"))
	EndIf
EndFunc

Func _winapi_getoverlappedresult($hfile, $poverlapped, ByRef $ibytes, $fwait = False)
	Local $aresult = DllCall("kernel32.dll", "bool", "GetOverlappedResult", "handle", $hfile, "ptr", $poverlapped, "dword*", 0, "bool", $fwait)
	If @error Then Return SetError(@error, @extended, False)
	$ibytes = $aresult[3]
	Return $aresult[0]
EndFunc

Func _winapi_getparent($hwnd)
	Local $aresult = DllCall("user32.dll", "hwnd", "GetParent", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getprocessaffinitymask($hprocess)
	Local $aresult = DllCall("kernel32.dll", "bool", "GetProcessAffinityMask", "handle", $hprocess, "dword_ptr*", 0, "dword_ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Local $amask[3]
	$amask[0] = True
	$amask[1] = $aresult[2]
	$amask[2] = $aresult[3]
	Return $amask
EndFunc

Func _winapi_getsavefilename($stitle = "", $sfilter = "All files (*.*)", $sinitaldir = ".", $sdefaultfile = "", $sdefaultext = "", $ifilterindex = 1, $iflags = 0, $iflagsex = 0, $hwndowner = 0)
	Local $ipathlen = 4096
	Local $tofn = DllStructCreate($tagopenfilename)
	Local $afiles[1] = [0]
	Local $iflag = $iflags
	Local $asflines = StringSplit($sfilter, "|")
	Local $asfilter[$asflines[0] * 2 + 1]
	Local $istart, $ifinal, $stfilter
	$asfilter[0] = $asflines[0] * 2
	For $i = 1 To $asflines[0]
		$istart = StringInStr($asflines[$i], "(", 0, 1)
		$ifinal = StringInStr($asflines[$i], ")", 0, -1)
		$asfilter[$i * 2 - 1] = StringStripWS(StringLeft($asflines[$i], $istart - 1), 3)
		$asfilter[$i * 2] = StringStripWS(StringTrimRight(StringTrimLeft($asflines[$i], $istart), StringLen($asflines[$i]) - $ifinal + 1), 3)
		$stfilter &= "wchar[" & StringLen($asfilter[$i * 2 - 1]) + 1 & "];wchar[" & StringLen($asfilter[$i * 2]) + 1 & "];"
	Next
	Local $ttitle = DllStructCreate("wchar Title[" & StringLen($stitle) + 1 & "]")
	Local $tinitialdir = DllStructCreate("wchar InitDir[" & StringLen($sinitaldir) + 1 & "]")
	Local $tfilter = DllStructCreate($stfilter & "wchar")
	Local $tpath = DllStructCreate("wchar Path[" & $ipathlen & "]")
	Local $textn = DllStructCreate("wchar Extension[" & StringLen($sdefaultext) + 1 & "]")
	For $i = 1 To $asfilter[0]
		DllStructSetData($tfilter, $i, $asfilter[$i])
	Next
	DllStructSetData($ttitle, "Title", $stitle)
	DllStructSetData($tinitialdir, "InitDir", $sinitaldir)
	DllStructSetData($tpath, "Path", $sdefaultfile)
	DllStructSetData($textn, "Extension", $sdefaultext)
	DllStructSetData($tofn, "StructSize", DllStructGetSize($tofn))
	DllStructSetData($tofn, "hwndOwner", $hwndowner)
	DllStructSetData($tofn, "lpstrFilter", DllStructGetPtr($tfilter))
	DllStructSetData($tofn, "nFilterIndex", $ifilterindex)
	DllStructSetData($tofn, "lpstrFile", DllStructGetPtr($tpath))
	DllStructSetData($tofn, "nMaxFile", $ipathlen)
	DllStructSetData($tofn, "lpstrInitialDir", DllStructGetPtr($tinitialdir))
	DllStructSetData($tofn, "lpstrTitle", DllStructGetPtr($ttitle))
	DllStructSetData($tofn, "Flags", $iflag)
	DllStructSetData($tofn, "lpstrDefExt", DllStructGetPtr($textn))
	DllStructSetData($tofn, "FlagsEx", $iflagsex)
	DllCall("comdlg32.dll", "bool", "GetSaveFileNameW", "struct*", $tofn)
	If @error Then Return SetError(@error, @extended, $afiles)
	Return __winapi_parsefiledialogpath(DllStructGetData($tpath, "Path"))
EndFunc

Func _winapi_getstockobject($iobject)
	Local $aresult = DllCall("gdi32.dll", "handle", "GetStockObject", "int", $iobject)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getstdhandle($istdhandle)
	If $istdhandle < 0 OR $istdhandle > 2 Then Return SetError(2, 0, -1)
	Local Const $ahandle[3] = [-10, -11, -12]
	Local $aresult = DllCall("kernel32.dll", "handle", "GetStdHandle", "dword", $ahandle[$istdhandle])
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_getsyscolor($iindex)
	Local $aresult = DllCall("user32.dll", "dword", "GetSysColor", "int", $iindex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getsyscolorbrush($iindex)
	Local $aresult = DllCall("user32.dll", "handle", "GetSysColorBrush", "int", $iindex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getsystemmetrics($iindex)
	Local $aresult = DllCall("user32.dll", "int", "GetSystemMetrics", "int", $iindex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_gettextextentpoint32($hdc, $stext)
	Local $tsize = DllStructCreate($tagsize)
	Local $isize = StringLen($stext)
	DllCall("gdi32.dll", "bool", "GetTextExtentPoint32W", "handle", $hdc, "wstr", $stext, "int", $isize, "struct*", $tsize)
	If @error Then Return SetError(@error, @extended, 0)
	Return $tsize
EndFunc

Func _winapi_gettextmetrics($hdc)
	Local $ttextmetric = DllStructCreate($tagtextmetric)
	Local $ret = DllCall("gdi32.dll", "bool", "GetTextMetricsW", "handle", $hdc, "struct*", $ttextmetric)
	If @error Then Return SetError(@error, @extended, 0)
	If NOT $ret[0] Then Return SetError(-1, 0, 0)
	Return $ttextmetric
EndFunc

Func _winapi_getwindow($hwnd, $icmd)
	Local $aresult = DllCall("user32.dll", "hwnd", "GetWindow", "hwnd", $hwnd, "uint", $icmd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getwindowdc($hwnd)
	Local $aresult = DllCall("user32.dll", "handle", "GetWindowDC", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getwindowheight($hwnd)
	Local $trect = _winapi_getwindowrect($hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($trect, "Bottom") - DllStructGetData($trect, "Top")
EndFunc

Func _winapi_getwindowlong($hwnd, $iindex)
	Local $sfuncname = "GetWindowLongW"
	If @AutoItX64 Then $sfuncname = "GetWindowLongPtrW"
	Local $aresult = DllCall("user32.dll", "long_ptr", $sfuncname, "hwnd", $hwnd, "int", $iindex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getwindowplacement($hwnd)
	Local $twindowplacement = DllStructCreate($tagwindowplacement)
	DllStructSetData($twindowplacement, "length", DllStructGetSize($twindowplacement))
	DllCall("user32.dll", "bool", "GetWindowPlacement", "hwnd", $hwnd, "struct*", $twindowplacement)
	If @error Then Return SetError(@error, @extended, 0)
	Return $twindowplacement
EndFunc

Func _winapi_getwindowrect($hwnd)
	Local $trect = DllStructCreate($tagrect)
	DllCall("user32.dll", "bool", "GetWindowRect", "hwnd", $hwnd, "struct*", $trect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $trect
EndFunc

Func _winapi_getwindowrgn($hwnd, $hrgn)
	Local $aresult = DllCall("user32.dll", "int", "GetWindowRgn", "hwnd", $hwnd, "handle", $hrgn)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_getwindowtext($hwnd)
	Local $aresult = DllCall("user32.dll", "int", "GetWindowTextW", "hwnd", $hwnd, "wstr", "", "int", 4096)
	If @error Then Return SetError(@error, @extended, "")
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _winapi_getwindowthreadprocessid($hwnd, ByRef $ipid)
	Local $aresult = DllCall("user32.dll", "dword", "GetWindowThreadProcessId", "hwnd", $hwnd, "dword*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	$ipid = $aresult[2]
	Return $aresult[0]
EndFunc

Func _winapi_getwindowwidth($hwnd)
	Local $trect = _winapi_getwindowrect($hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return DllStructGetData($trect, "Right") - DllStructGetData($trect, "Left")
EndFunc

Func _winapi_getxyfrompoint(ByRef $tpoint, ByRef $ix, ByRef $iy)
	$ix = DllStructGetData($tpoint, "X")
	$iy = DllStructGetData($tpoint, "Y")
EndFunc

Func _winapi_globalmemorystatus()
	Local $tmem = DllStructCreate($tagmemorystatusex)
	Local $imem = DllStructGetSize($tmem)
	DllStructSetData($tmem, 1, $imem)
	DllCall("kernel32.dll", "none", "GlobalMemoryStatusEx", "ptr", $tmem)
	If @error Then Return SetError(@error, @extended, 0)
	Local $amem[7]
	$amem[0] = DllStructGetData($tmem, 2)
	$amem[1] = DllStructGetData($tmem, 3)
	$amem[2] = DllStructGetData($tmem, 4)
	$amem[3] = DllStructGetData($tmem, 5)
	$amem[4] = DllStructGetData($tmem, 6)
	$amem[5] = DllStructGetData($tmem, 7)
	$amem[6] = DllStructGetData($tmem, 8)
	Return $amem
EndFunc

Func _winapi_guidfromstring($sguid)
	Local $tguid = DllStructCreate($tagguid)
	_winapi_guidfromstringex($sguid, $tguid)
	If @error Then Return SetError(@error, @extended, 0)
	Return $tguid
EndFunc

Func _winapi_guidfromstringex($sguid, $pguid)
	Local $aresult = DllCall("ole32.dll", "long", "CLSIDFromString", "wstr", $sguid, "struct*", $pguid)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_hiword($ilong)
	Return BitShift($ilong, 16)
EndFunc

Func _winapi_inprocess($hwnd, ByRef $hlastwnd)
	If $hwnd = $hlastwnd Then Return True
	For $ii = $__gainprocess_winapi[0][0] To 1 Step -1
		If $hwnd = $__gainprocess_winapi[$ii][0] Then
			If $__gainprocess_winapi[$ii][1] Then
				$hlastwnd = $hwnd
				Return True
			Else
				Return False
			EndIf
		EndIf
	Next
	Local $iprocessid
	_winapi_getwindowthreadprocessid($hwnd, $iprocessid)
	Local $icount = $__gainprocess_winapi[0][0] + 1
	If $icount >= 64 Then $icount = 1
	$__gainprocess_winapi[0][0] = $icount
	$__gainprocess_winapi[$icount][0] = $hwnd
	$__gainprocess_winapi[$icount][1] = ($iprocessid = @AutoItPID)
	Return $__gainprocess_winapi[$icount][1]
EndFunc

Func _winapi_inttofloat($iint)
	Local $tint = DllStructCreate("int")
	Local $tfloat = DllStructCreate("float", DllStructGetPtr($tint))
	DllStructSetData($tint, 1, $iint)
	Return DllStructGetData($tfloat, 1)
EndFunc

Func _winapi_isclassname($hwnd, $sclassname)
	Local $sseparator = Opt("GUIDataSeparatorChar")
	Local $aclassname = StringSplit($sclassname, $sseparator)
	If NOT IsHWnd($hwnd) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $sclasscheck = _winapi_getclassname($hwnd)
	For $x = 1 To UBound($aclassname) - 1
		If StringUpper(StringMid($sclasscheck, 1, StringLen($aclassname[$x]))) = StringUpper($aclassname[$x]) Then Return True
	Next
	Return False
EndFunc

Func _winapi_iswindow($hwnd)
	Local $aresult = DllCall("user32.dll", "bool", "IsWindow", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_iswindowvisible($hwnd)
	Local $aresult = DllCall("user32.dll", "bool", "IsWindowVisible", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_invalidaterect($hwnd, $trect = 0, $ferase = True)
	Local $aresult = DllCall("user32.dll", "bool", "InvalidateRect", "hwnd", $hwnd, "struct*", $trect, "bool", $ferase)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_lineto($hdc, $ix, $iy)
	Local $aresult = DllCall("gdi32.dll", "bool", "LineTo", "handle", $hdc, "int", $ix, "int", $iy)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_loadbitmap($hinstance, $sbitmap)
	Local $sbitmaptype = "int"
	If IsString($sbitmap) Then $sbitmaptype = "wstr"
	Local $aresult = DllCall("user32.dll", "handle", "LoadBitmapW", "handle", $hinstance, $sbitmaptype, $sbitmap)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_loadimage($hinstance, $simage, $itype, $ixdesired, $iydesired, $iload)
	Local $aresult, $simagetype = "int"
	If IsString($simage) Then $simagetype = "wstr"
	$aresult = DllCall("user32.dll", "handle", "LoadImageW", "handle", $hinstance, $simagetype, $simage, "uint", $itype, "int", $ixdesired, "int", $iydesired, "uint", $iload)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_loadlibrary($sfilename)
	Local $aresult = DllCall("kernel32.dll", "handle", "LoadLibraryW", "wstr", $sfilename)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_loadlibraryex($sfilename, $iflags = 0)
	Local $aresult = DllCall("kernel32.dll", "handle", "LoadLibraryExW", "wstr", $sfilename, "ptr", 0, "dword", $iflags)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_loadshell32icon($iiconid)
	Local $ticons = DllStructCreate("ptr Data")
	Local $iicons = _winapi_extracticonex("shell32.dll", $iiconid, 0, $ticons, 1)
	If @error Then Return SetError(@error, @extended, 0)
	If $iicons <= 0 Then Return SetError(1, 0, 0)
	Return DllStructGetData($ticons, "Data")
EndFunc

Func _winapi_loadstring($hinstance, $istringid)
	Local $aresult = DllCall("user32.dll", "int", "LoadStringW", "handle", $hinstance, "uint", $istringid, "wstr", "", "int", 4096)
	If @error Then Return SetError(@error, @extended, "")
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _winapi_localfree($hmem)
	Local $aresult = DllCall("kernel32.dll", "handle", "LocalFree", "handle", $hmem)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_loword($ilong)
	Return BitAND($ilong, 65535)
EndFunc

Func _winapi_makelangid($lgidprimary, $lgidsub)
	Return BitOR(BitShift($lgidsub, -10), $lgidprimary)
EndFunc

Func _winapi_makelcid($lgid, $srtid)
	Return BitOR(BitShift($srtid, -16), $lgid)
EndFunc

Func _winapi_makelong($ilo, $ihi)
	Return BitOR(BitShift($ihi, -16), BitAND($ilo, 65535))
EndFunc

Func _winapi_makeqword($lodword, $hidword)
	Local $tint64 = DllStructCreate("uint64")
	Local $tdwords = DllStructCreate("dword;dword", DllStructGetPtr($tint64))
	DllStructSetData($tdwords, 1, $lodword)
	DllStructSetData($tdwords, 2, $hidword)
	Return DllStructGetData($tint64, 1)
EndFunc

Func _winapi_messagebeep($itype = 1)
	Local $isound
	Switch $itype
		Case 1
			$isound = 0
		Case 2
			$isound = 16
		Case 3
			$isound = 32
		Case 4
			$isound = 48
		Case 5
			$isound = 64
		Case Else
			$isound = -1
	EndSwitch
	Local $aresult = DllCall("user32.dll", "bool", "MessageBeep", "uint", $isound)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_msgbox($iflags, $stitle, $stext)
	BlockInput(0)
	MsgBox($iflags, $stitle, $stext & "      ")
EndFunc

Func _winapi_mouse_event($iflags, $ix = 0, $iy = 0, $idata = 0, $iextrainfo = 0)
	DllCall("user32.dll", "none", "mouse_event", "dword", $iflags, "dword", $ix, "dword", $iy, "dword", $idata, "ulong_ptr", $iextrainfo)
	If @error Then Return SetError(@error, @extended)
EndFunc

Func _winapi_moveto($hdc, $ix, $iy)
	Local $aresult = DllCall("gdi32.dll", "bool", "MoveToEx", "handle", $hdc, "int", $ix, "int", $iy, "ptr", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_movewindow($hwnd, $ix, $iy, $iwidth, $iheight, $frepaint = True)
	Local $aresult = DllCall("user32.dll", "bool", "MoveWindow", "hwnd", $hwnd, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight, "bool", $frepaint)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_muldiv($inumber, $inumerator, $idenominator)
	Local $aresult = DllCall("kernel32.dll", "int", "MulDiv", "int", $inumber, "int", $inumerator, "int", $idenominator)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_multibytetowidechar($stext, $icodepage = 0, $iflags = 0, $bretstring = False)
	Local $stexttype = "str"
	If NOT IsString($stext) Then $stexttype = "struct*"
	Local $aresult = DllCall("kernel32.dll", "int", "MultiByteToWideChar", "uint", $icodepage, "dword", $iflags, $stexttype, $stext, "int", -1, "ptr", 0, "int", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Local $iout = $aresult[0]
	Local $tout = DllStructCreate("wchar[" & $iout & "]")
	$aresult = DllCall("kernel32.dll", "int", "MultiByteToWideChar", "uint", $icodepage, "dword", $iflags, $stexttype, $stext, "int", -1, "struct*", $tout, "int", $iout)
	If @error Then Return SetError(@error, @extended, 0)
	If $bretstring Then Return DllStructGetData($tout, 1)
	Return $tout
EndFunc

Func _winapi_multibytetowidecharex($stext, $ptext, $icodepage = 0, $iflags = 0)
	Local $aresult = DllCall("kernel32.dll", "int", "MultiByteToWideChar", "uint", $icodepage, "dword", $iflags, "STR", $stext, "int", -1, "struct*", $ptext, "int", (StringLen($stext) + 1) * 2)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_openprocess($iaccess, $finherit, $iprocessid, $fdebugpriv = False)
	Local $aresult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iaccess, "bool", $finherit, "dword", $iprocessid)
	If @error Then Return SetError(@error, @extended, 0)
	If $aresult[0] Then Return $aresult[0]
	If NOT $fdebugpriv Then Return 0
	Local $htoken = _security__openthreadtokenex(BitOR($token_adjust_privileges, $token_query))
	If @error Then Return SetError(@error, @extended, 0)
	_security__setprivilege($htoken, "SeDebugPrivilege", True)
	Local $ierror = @error
	Local $ilasterror = @extended
	Local $iret = 0
	If NOT @error Then
		$aresult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iaccess, "bool", $finherit, "dword", $iprocessid)
		$ierror = @error
		$ilasterror = @extended
		If $aresult[0] Then $iret = $aresult[0]
		_security__setprivilege($htoken, "SeDebugPrivilege", False)
		If @error Then
			$ierror = @error
			$ilasterror = @extended
		EndIf
	EndIf
	_winapi_closehandle($htoken)
	Return SetError($ierror, $ilasterror, $iret)
EndFunc

Func __winapi_parsefiledialogpath($spath)
	Local $afiles[3]
	$afiles[0] = 2
	Local $stemp = StringMid($spath, 1, StringInStr($spath, "\", 0, -1) - 1)
	$afiles[1] = $stemp
	$afiles[2] = StringMid($spath, StringInStr($spath, "\", 0, -1) + 1)
	Return $afiles
EndFunc

Func _winapi_pathfindonpath(Const $szfile, $aextrapaths = "", Const $szpathdelimiter = @LF)
	Local $iextracount = 0
	If IsString($aextrapaths) Then
		If StringLen($aextrapaths) Then
			$aextrapaths = StringSplit($aextrapaths, $szpathdelimiter, 1 + 2)
			$iextracount = UBound($aextrapaths, 1)
		EndIf
	ElseIf IsArray($aextrapaths) Then
		$iextracount = UBound($aextrapaths)
	EndIf
	Local $tpaths, $tpathptrs
	If $iextracount Then
		Local $szstruct = ""
		For $path In $aextrapaths
			$szstruct &= "wchar[" & StringLen($path) + 1 & "];"
		Next
		$tpaths = DllStructCreate($szstruct)
		$tpathptrs = DllStructCreate("ptr[" & $iextracount + 1 & "]")
		For $i = 1 To $iextracount
			DllStructSetData($tpaths, $i, $aextrapaths[$i - 1])
			DllStructSetData($tpathptrs, 1, DllStructGetPtr($tpaths, $i), $i)
		Next
		DllStructSetData($tpathptrs, 1, Ptr(0), $iextracount + 1)
	EndIf
	Local $aresult = DllCall("shlwapi.dll", "bool", "PathFindOnPathW", "wstr", $szfile, "struct*", $tpathptrs)
	If @error Then Return SetError(@error, @extended, False)
	If $aresult[0] = 0 Then Return SetError(1, 0, $szfile)
	Return $aresult[1]
EndFunc

Func _winapi_pointfromrect(ByRef $trect, $fcenter = True)
	Local $ix1 = DllStructGetData($trect, "Left")
	Local $iy1 = DllStructGetData($trect, "Top")
	Local $ix2 = DllStructGetData($trect, "Right")
	Local $iy2 = DllStructGetData($trect, "Bottom")
	If $fcenter Then
		$ix1 = $ix1 + (($ix2 - $ix1) / 2)
		$iy1 = $iy1 + (($iy2 - $iy1) / 2)
	EndIf
	Local $tpoint = DllStructCreate($tagpoint)
	DllStructSetData($tpoint, "X", $ix1)
	DllStructSetData($tpoint, "Y", $iy1)
	Return $tpoint
EndFunc

Func _winapi_postmessage($hwnd, $imsg, $iwparam, $ilparam)
	Local $aresult = DllCall("user32.dll", "bool", "PostMessage", "hwnd", $hwnd, "uint", $imsg, "wparam", $iwparam, "lparam", $ilparam)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_primarylangid($lgid)
	Return BitAND($lgid, 1023)
EndFunc

Func _winapi_ptinrect(ByRef $trect, ByRef $tpoint)
	Local $aresult = DllCall("user32.dll", "bool", "PtInRect", "struct*", $trect, "struct", $tpoint)
	If @error Then Return SetError(1, @extended, False)
	Return NOT ($aresult[0] = 0)
EndFunc

Func _winapi_readfile($hfile, $pbuffer, $itoread, ByRef $iread, $poverlapped = 0)
	Local $aresult = DllCall("kernel32.dll", "bool", "ReadFile", "handle", $hfile, "ptr", $pbuffer, "dword", $itoread, "dword*", 0, "ptr", $poverlapped)
	If @error Then Return SetError(@error, @extended, False)
	$iread = $aresult[4]
	Return $aresult[0]
EndFunc

Func _winapi_readprocessmemory($hprocess, $pbaseaddress, $pbuffer, $isize, ByRef $iread)
	Local $aresult = DllCall("kernel32.dll", "bool", "ReadProcessMemory", "handle", $hprocess, "ptr", $pbaseaddress, "ptr", $pbuffer, "ulong_ptr", $isize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	$iread = $aresult[5]
	Return $aresult[0]
EndFunc

Func _winapi_rectisempty(ByRef $trect)
	Return (DllStructGetData($trect, "Left") = 0) AND (DllStructGetData($trect, "Top") = 0) AND (DllStructGetData($trect, "Right") = 0) AND (DllStructGetData($trect, "Bottom") = 0)
EndFunc

Func _winapi_redrawwindow($hwnd, $trect = 0, $hregion = 0, $iflags = 5)
	Local $aresult = DllCall("user32.dll", "bool", "RedrawWindow", "hwnd", $hwnd, "struct*", $trect, "handle", $hregion, "uint", $iflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_registerwindowmessage($smessage)
	Local $aresult = DllCall("user32.dll", "uint", "RegisterWindowMessageW", "wstr", $smessage)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_releasecapture()
	Local $aresult = DllCall("user32.dll", "bool", "ReleaseCapture")
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_releasedc($hwnd, $hdc)
	Local $aresult = DllCall("user32.dll", "int", "ReleaseDC", "hwnd", $hwnd, "handle", $hdc)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_screentoclient($hwnd, ByRef $tpoint)
	Local $aresult = DllCall("user32.dll", "bool", "ScreenToClient", "hwnd", $hwnd, "struct*", $tpoint)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_selectobject($hdc, $hgdiobj)
	Local $aresult = DllCall("gdi32.dll", "handle", "SelectObject", "handle", $hdc, "handle", $hgdiobj)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setbkcolor($hdc, $icolor)
	Local $aresult = DllCall("gdi32.dll", "INT", "SetBkColor", "handle", $hdc, "dword", $icolor)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_setbkmode($hdc, $ibkmode)
	Local $aresult = DllCall("gdi32.dll", "int", "SetBkMode", "handle", $hdc, "int", $ibkmode)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setcapture($hwnd)
	Local $aresult = DllCall("user32.dll", "hwnd", "SetCapture", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setcursor($hcursor)
	Local $aresult = DllCall("user32.dll", "handle", "SetCursor", "handle", $hcursor)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setdefaultprinter($sprinter)
	Local $aresult = DllCall("winspool.drv", "bool", "SetDefaultPrinterW", "wstr", $sprinter)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setdibits($hdc, $hbmp, $istartscan, $iscanlines, $pbits, $pbmi, $icoloruse = 0)
	Local $aresult = DllCall("gdi32.dll", "int", "SetDIBits", "handle", $hdc, "handle", $hbmp, "uint", $istartscan, "uint", $iscanlines, "ptr", $pbits, "ptr", $pbmi, "uint", $icoloruse)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setendoffile($hfile)
	Local $aresult = DllCall("kernel32.dll", "bool", "SetEndOfFile", "handle", $hfile)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setevent($hevent)
	Local $aresult = DllCall("kernel32.dll", "bool", "SetEvent", "handle", $hevent)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setfilepointer($hfile, $ipos, $imethod = 0)
	Local $aresult = DllCall("kernel32.dll", "INT", "SetFilePointer", "handle", $hfile, "long", $ipos, "ptr", 0, "long", $imethod)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_setfocus($hwnd)
	Local $aresult = DllCall("user32.dll", "hwnd", "SetFocus", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setfont($hwnd, $hfont, $fredraw = True)
	_sendmessage($hwnd, $__winapiconstant_wm_setfont, $hfont, $fredraw, 0, "hwnd")
EndFunc

Func _winapi_sethandleinformation($hobject, $imask, $iflags)
	Local $aresult = DllCall("kernel32.dll", "bool", "SetHandleInformation", "handle", $hobject, "dword", $imask, "dword", $iflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setlayeredwindowattributes($hwnd, $i_transcolor, $transparency = 255, $dwflags = 3, $iscolorref = False)
	If $dwflags = Default OR $dwflags = "" OR $dwflags < 0 Then $dwflags = 3
	If NOT $iscolorref Then
		$i_transcolor = Int(BinaryMid($i_transcolor, 3, 1) & BinaryMid($i_transcolor, 2, 1) & BinaryMid($i_transcolor, 1, 1))
	EndIf
	Local $aresult = DllCall("user32.dll", "bool", "SetLayeredWindowAttributes", "hwnd", $hwnd, "dword", $i_transcolor, "byte", $transparency, "dword", $dwflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setparent($hwndchild, $hwndparent)
	Local $aresult = DllCall("user32.dll", "hwnd", "SetParent", "hwnd", $hwndchild, "hwnd", $hwndparent)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setprocessaffinitymask($hprocess, $imask)
	Local $aresult = DllCall("kernel32.dll", "bool", "SetProcessAffinityMask", "handle", $hprocess, "ulong_ptr", $imask)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setsyscolors($velements, $vcolors)
	Local $isearray = IsArray($velements), $iscarray = IsArray($vcolors)
	Local $ielementnum
	If NOT $iscarray AND NOT $isearray Then
		$ielementnum = 1
	ElseIf $iscarray OR $isearray Then
		If NOT $iscarray OR NOT $isearray Then Return SetError(-1, -1, False)
		If UBound($velements) <> UBound($vcolors) Then Return SetError(-1, -1, False)
		$ielementnum = UBound($velements)
	EndIf
	Local $telements = DllStructCreate("int Element[" & $ielementnum & "]")
	Local $tcolors = DllStructCreate("dword NewColor[" & $ielementnum & "]")
	If NOT $isearray Then
		DllStructSetData($telements, "Element", $velements, 1)
	Else
		For $x = 0 To $ielementnum - 1
			DllStructSetData($telements, "Element", $velements[$x], $x + 1)
		Next
	EndIf
	If NOT $iscarray Then
		DllStructSetData($tcolors, "NewColor", $vcolors, 1)
	Else
		For $x = 0 To $ielementnum - 1
			DllStructSetData($tcolors, "NewColor", $vcolors[$x], $x + 1)
		Next
	EndIf
	Local $aresult = DllCall("user32.dll", "bool", "SetSysColors", "int", $ielementnum, "struct*", $telements, "struct*", $tcolors)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_settextcolor($hdc, $icolor)
	Local $aresult = DllCall("gdi32.dll", "INT", "SetTextColor", "handle", $hdc, "dword", $icolor)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowlong($hwnd, $iindex, $ivalue)
	_winapi_setlasterror(0)
	Local $sfuncname = "SetWindowLongW"
	If @AutoItX64 Then $sfuncname = "SetWindowLongPtrW"
	Local $aresult = DllCall("user32.dll", "long_ptr", $sfuncname, "hwnd", $hwnd, "int", $iindex, "long_ptr", $ivalue)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowplacement($hwnd, $pwindowplacement)
	Local $aresult = DllCall("user32.dll", "bool", "SetWindowPlacement", "hwnd", $hwnd, "ptr", $pwindowplacement)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowpos($hwnd, $hafter, $ix, $iy, $icx, $icy, $iflags)
	Local $aresult = DllCall("user32.dll", "bool", "SetWindowPos", "hwnd", $hwnd, "hwnd", $hafter, "int", $ix, "int", $iy, "int", $icx, "int", $icy, "uint", $iflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowrgn($hwnd, $hrgn, $bredraw = True)
	Local $aresult = DllCall("user32.dll", "int", "SetWindowRgn", "hwnd", $hwnd, "handle", $hrgn, "bool", $bredraw)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowshookex($idhook, $lpfn, $hmod, $dwthreadid = 0)
	Local $aresult = DllCall("user32.dll", "handle", "SetWindowsHookEx", "int", $idhook, "ptr", $lpfn, "handle", $hmod, "dword", $dwthreadid)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_setwindowtext($hwnd, $stext)
	Local $aresult = DllCall("user32.dll", "bool", "SetWindowTextW", "hwnd", $hwnd, "wstr", $stext)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_showcursor($fshow)
	Local $aresult = DllCall("user32.dll", "int", "ShowCursor", "bool", $fshow)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_showerror($stext, $fexit = True)
	_winapi_msgbox(266256, "Error", $stext)
	If $fexit Then Exit
EndFunc

Func _winapi_showmsg($stext)
	_winapi_msgbox(64 + 4096, "Information", $stext)
EndFunc

Func _winapi_showwindow($hwnd, $icmdshow = 5)
	Local $aresult = DllCall("user32.dll", "bool", "ShowWindow", "hwnd", $hwnd, "int", $icmdshow)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_stringfromguid($pguid)
	Local $aresult = DllCall("ole32.dll", "int", "StringFromGUID2", "struct*", $pguid, "wstr", "", "int", 40)
	If @error Then Return SetError(@error, @extended, "")
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _winapi_stringlena($vstring)
	Local $acall = DllCall("kernel32.dll", "int", "lstrlenA", "struct*", $vstring)
	If @error Then Return SetError(1, @extended, 0)
	Return $acall[0]
EndFunc

Func _winapi_stringlenw($vstring)
	Local $acall = DllCall("kernel32.dll", "int", "lstrlenW", "struct*", $vstring)
	If @error Then Return SetError(1, @extended, 0)
	Return $acall[0]
EndFunc

Func _winapi_sublangid($lgid)
	Return BitShift($lgid, 10)
EndFunc

Func _winapi_systemparametersinfo($iaction, $iparam = 0, $vparam = 0, $iwinini = 0)
	Local $aresult = DllCall("user32.dll", "bool", "SystemParametersInfoW", "uint", $iaction, "uint", $iparam, "ptr", $vparam, "uint", $iwinini)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_twipsperpixelx()
	Local $lngdc, $twipsperpixelx
	$lngdc = _winapi_getdc(0)
	$twipsperpixelx = 1440 / _winapi_getdevicecaps($lngdc, $__winapiconstant_logpixelsx)
	_winapi_releasedc(0, $lngdc)
	Return $twipsperpixelx
EndFunc

Func _winapi_twipsperpixely()
	Local $lngdc, $twipsperpixely
	$lngdc = _winapi_getdc(0)
	$twipsperpixely = 1440 / _winapi_getdevicecaps($lngdc, $__winapiconstant_logpixelsy)
	_winapi_releasedc(0, $lngdc)
	Return $twipsperpixely
EndFunc

Func _winapi_unhookwindowshookex($hhk)
	Local $aresult = DllCall("user32.dll", "bool", "UnhookWindowsHookEx", "handle", $hhk)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_updatelayeredwindow($hwnd, $hdcdest, $pptdest, $psize, $hdcsrce, $pptsrce, $irgb, $pblend, $iflags)
	Local $aresult = DllCall("user32.dll", "bool", "UpdateLayeredWindow", "hwnd", $hwnd, "handle", $hdcdest, "ptr", $pptdest, "ptr", $psize, "handle", $hdcsrce, "ptr", $pptsrce, "dword", $irgb, "ptr", $pblend, "dword", $iflags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_updatewindow($hwnd)
	Local $aresult = DllCall("user32.dll", "bool", "UpdateWindow", "hwnd", $hwnd)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_waitforinputidle($hprocess, $itimeout = -1)
	Local $aresult = DllCall("user32.dll", "dword", "WaitForInputIdle", "handle", $hprocess, "dword", $itimeout)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_waitformultipleobjects($icount, $phandles, $fwaitall = False, $itimeout = -1)
	Local $aresult = DllCall("kernel32.dll", "INT", "WaitForMultipleObjects", "dword", $icount, "ptr", $phandles, "bool", $fwaitall, "dword", $itimeout)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_waitforsingleobject($hhandle, $itimeout = -1)
	Local $aresult = DllCall("kernel32.dll", "INT", "WaitForSingleObject", "handle", $hhandle, "dword", $itimeout)
	If @error Then Return SetError(@error, @extended, -1)
	Return $aresult[0]
EndFunc

Func _winapi_widechartomultibyte($punicode, $icodepage = 0, $bretstring = True)
	Local $sunicodetype = "wstr"
	If NOT IsString($punicode) Then $sunicodetype = "struct*"
	Local $aresult = DllCall("kernel32.dll", "int", "WideCharToMultiByte", "uint", $icodepage, "dword", 0, $sunicodetype, $punicode, "int", -1, "ptr", 0, "int", 0, "ptr", 0, "ptr", 0)
	If @error Then Return SetError(@error, @extended, "")
	Local $tmultibyte = DllStructCreate("char[" & $aresult[0] & "]")
	$aresult = DllCall("kernel32.dll", "int", "WideCharToMultiByte", "uint", $icodepage, "dword", 0, $sunicodetype, $punicode, "int", -1, "struct*", $tmultibyte, "int", $aresult[0], "ptr", 0, "ptr", 0)
	If @error Then Return SetError(@error, @extended, "")
	If $bretstring Then Return DllStructGetData($tmultibyte, 1)
	Return $tmultibyte
EndFunc

Func _winapi_windowfrompoint(ByRef $tpoint)
	Local $aresult = DllCall("user32.dll", "hwnd", "WindowFromPoint", "struct", $tpoint)
	If @error Then Return SetError(1, @extended, 0)
	Return $aresult[0]
EndFunc

Func _winapi_writeconsole($hconsole, $stext)
	Local $aresult = DllCall("kernel32.dll", "bool", "WriteConsoleW", "handle", $hconsole, "wstr", $stext, "dword", StringLen($stext), "dword*", 0, "ptr", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _winapi_writefile($hfile, $pbuffer, $itowrite, ByRef $iwritten, $poverlapped = 0)
	Local $aresult = DllCall("kernel32.dll", "bool", "WriteFile", "handle", $hfile, "ptr", $pbuffer, "dword", $itowrite, "dword*", 0, "ptr", $poverlapped)
	If @error Then Return SetError(@error, @extended, False)
	$iwritten = $aresult[4]
	Return $aresult[0]
EndFunc

Func _winapi_writeprocessmemory($hprocess, $pbaseaddress, $pbuffer, $isize, ByRef $iwritten, $sbuffer = "ptr")
	Local $aresult = DllCall("kernel32.dll", "bool", "WriteProcessMemory", "handle", $hprocess, "ptr", $pbaseaddress, $sbuffer, $pbuffer, "ulong_ptr", $isize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	$iwritten = $aresult[5]
	Return $aresult[0]
EndFunc

Global $ghgdipbrush = 0
Global $ghgdipdll = 0
Global $ghgdippen = 0
Global $gigdipref = 0
Global $gigdiptoken = 0

Func _gdiplus_arrowcapcreate($fheight, $fwidth, $bfilled = True)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateAdjustableArrowCap", "float", $fheight, "float", $fwidth, "bool", $bfilled, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[4])
EndFunc

Func _gdiplus_arrowcapdispose($hcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteCustomLineCap", "handle", $hcap)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_arrowcapgetfillstate($harrowcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetAdjustableArrowCapFillState", "handle", $harrowcap, "bool*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_arrowcapgetheight($harrowcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetAdjustableArrowCapHeight", "handle", $harrowcap, "float*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_arrowcapgetmiddleinset($harrowcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetAdjustableArrowCapMiddleInset", "handle", $harrowcap, "float*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_arrowcapgetwidth($harrowcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetAdjustableArrowCapWidth", "handle", $harrowcap, "float*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_arrowcapsetfillstate($harrowcap, $bfilled = True)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetAdjustableArrowCapFillState", "handle", $harrowcap, "bool", $bfilled)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_arrowcapsetheight($harrowcap, $fheight)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetAdjustableArrowCapHeight", "handle", $harrowcap, "float", $fheight)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_arrowcapsetmiddleinset($harrowcap, $finset)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetAdjustableArrowCapMiddleInset", "handle", $harrowcap, "float", $finset)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_arrowcapsetwidth($harrowcap, $fwidth)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetAdjustableArrowCapWidth", "handle", $harrowcap, "float", $fwidth)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_bitmapclonearea($hbmp, $ileft, $itop, $iwidth, $iheight, $iformat = 137224)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCloneBitmapAreaI", "int", $ileft, "int", $itop, "int", $iwidth, "int", $iheight, "int", $iformat, "handle", $hbmp, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[7])
EndFunc

Func _gdiplus_bitmapcreatefromfile($sfilename)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateBitmapFromFile", "wstr", $sfilename, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_bitmapcreatefromgraphics($iwidth, $iheight, $hgraphics)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateBitmapFromGraphics", "int", $iwidth, "int", $iheight, "handle", $hgraphics, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[4])
EndFunc

Func _gdiplus_bitmapcreatefromhbitmap($hbmp, $hpal = 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateBitmapFromHBITMAP", "handle", $hbmp, "handle", $hpal, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _gdiplus_bitmapcreatehbitmapfrombitmap($hbitmap, $iargb = -16777216)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateHBITMAPFromBitmap", "handle", $hbitmap, "ptr*", 0, "dword", $iargb)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_bitmapdispose($hbitmap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDisposeImage", "handle", $hbitmap)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_bitmaplockbits($hbitmap, $ileft, $itop, $iwidth, $iheight, $iflags = $gdip_ilmread, $iformat = $gdip_pxf32rgb)
	Local $tdata = DllStructCreate($taggdipbitmapdata)
	Local $trect = DllStructCreate($tagrect)
	DllStructSetData($trect, "Left", $ileft)
	DllStructSetData($trect, "Top", $itop)
	DllStructSetData($trect, "Right", $iwidth)
	DllStructSetData($trect, "Bottom", $iheight)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipBitmapLockBits", "handle", $hbitmap, "struct*", $trect, "uint", $iflags, "int", $iformat, "struct*", $tdata)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $tdata)
EndFunc

Func _gdiplus_bitmapunlockbits($hbitmap, $tbitmapdata)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipBitmapUnlockBits", "handle", $hbitmap, "struct*", $tbitmapdata)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_brushclone($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCloneBrush", "handle", $hbrush, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_brushcreatesolid($iargb = -16777216)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateSolidFill", "int", $iargb, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_brushdispose($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteBrush", "handle", $hbrush)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_brushgetsolidcolor($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetSolidFillColor", "handle", $hbrush, "dword*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_brushgettype($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetBrushType", "handle", $hbrush, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_brushsetsolidcolor($hbrush, $iargb = -16777216)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetSolidFillColor", "handle", $hbrush, "dword", $iargb)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_customlinecapdispose($hcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteCustomLineCap", "handle", $hcap)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_decoders()
	Local $icount = _gdiplus_decodersgetcount()
	Local $isize = _gdiplus_decodersgetsize()
	Local $tbuffer = DllStructCreate("byte[" & $isize & "]")
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageDecoders", "uint", $icount, "uint", $isize, "struct*", $tbuffer)
	If @error Then Return SetError(@error, @extended, 0)
	If $aresult[0] <> 0 Then Return SetError($aresult[0], 0, 0)
	Local $pbuffer = DllStructGetPtr($tbuffer)
	Local $tcodec, $ainfo[$icount + 1][14]
	$ainfo[0][0] = $icount
	For $ii = 1 To $icount
		$tcodec = DllStructCreate($taggdipimagecodecinfo, $pbuffer)
		$ainfo[$ii][1] = _winapi_stringfromguid(DllStructGetPtr($tcodec, "CLSID"))
		$ainfo[$ii][2] = _winapi_stringfromguid(DllStructGetPtr($tcodec, "FormatID"))
		$ainfo[$ii][3] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "CodecName"))
		$ainfo[$ii][4] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "DllName"))
		$ainfo[$ii][5] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "FormatDesc"))
		$ainfo[$ii][6] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "FileExt"))
		$ainfo[$ii][7] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "MimeType"))
		$ainfo[$ii][8] = DllStructGetData($tcodec, "Flags")
		$ainfo[$ii][9] = DllStructGetData($tcodec, "Version")
		$ainfo[$ii][10] = DllStructGetData($tcodec, "SigCount")
		$ainfo[$ii][11] = DllStructGetData($tcodec, "SigSize")
		$ainfo[$ii][12] = DllStructGetData($tcodec, "SigPattern")
		$ainfo[$ii][13] = DllStructGetData($tcodec, "SigMask")
		$pbuffer += DllStructGetSize($tcodec)
	Next
	Return $ainfo
EndFunc

Func _gdiplus_decodersgetcount()
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageDecodersSize", "uint*", 0, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[1])
EndFunc

Func _gdiplus_decodersgetsize()
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageDecodersSize", "uint*", 0, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_drawimagepoints($hgraphic, $himage, $nulx, $nuly, $nurx, $nury, $nllx, $nlly, $count = 3)
	Local $tpoint = DllStructCreate("float X;float Y;float X2;float Y2;float X3;float Y3")
	DllStructSetData($tpoint, "X", $nulx)
	DllStructSetData($tpoint, "Y", $nuly)
	DllStructSetData($tpoint, "X2", $nurx)
	DllStructSetData($tpoint, "Y2", $nury)
	DllStructSetData($tpoint, "X3", $nllx)
	DllStructSetData($tpoint, "Y3", $nlly)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawImagePoints", "handle", $hgraphic, "handle", $himage, "struct*", $tpoint, "int", $count)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_encoders()
	Local $icount = _gdiplus_encodersgetcount()
	Local $isize = _gdiplus_encodersgetsize()
	Local $tbuffer = DllStructCreate("byte[" & $isize & "]")
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageEncoders", "uint", $icount, "uint", $isize, "struct*", $tbuffer)
	If @error Then Return SetError(@error, @extended, 0)
	If $aresult[0] <> 0 Then Return SetError($aresult[0], 0, 0)
	Local $pbuffer = DllStructGetPtr($tbuffer)
	Local $tcodec, $ainfo[$icount + 1][14]
	$ainfo[0][0] = $icount
	For $ii = 1 To $icount
		$tcodec = DllStructCreate($taggdipimagecodecinfo, $pbuffer)
		$ainfo[$ii][1] = _winapi_stringfromguid(DllStructGetPtr($tcodec, "CLSID"))
		$ainfo[$ii][2] = _winapi_stringfromguid(DllStructGetPtr($tcodec, "FormatID"))
		$ainfo[$ii][3] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "CodecName"))
		$ainfo[$ii][4] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "DllName"))
		$ainfo[$ii][5] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "FormatDesc"))
		$ainfo[$ii][6] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "FileExt"))
		$ainfo[$ii][7] = _winapi_widechartomultibyte(DllStructGetData($tcodec, "MimeType"))
		$ainfo[$ii][8] = DllStructGetData($tcodec, "Flags")
		$ainfo[$ii][9] = DllStructGetData($tcodec, "Version")
		$ainfo[$ii][10] = DllStructGetData($tcodec, "SigCount")
		$ainfo[$ii][11] = DllStructGetData($tcodec, "SigSize")
		$ainfo[$ii][12] = DllStructGetData($tcodec, "SigPattern")
		$ainfo[$ii][13] = DllStructGetData($tcodec, "SigMask")
		$pbuffer += DllStructGetSize($tcodec)
	Next
	Return $ainfo
EndFunc

Func _gdiplus_encodersgetclsid($sfileext)
	Local $aencoders = _gdiplus_encoders()
	For $ii = 1 To $aencoders[0][0]
		If StringInStr($aencoders[$ii][6], "*." & $sfileext) > 0 Then Return $aencoders[$ii][1]
	Next
	Return SetError(-1, -1, "")
EndFunc

Func _gdiplus_encodersgetcount()
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageEncodersSize", "uint*", 0, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[1])
EndFunc

Func _gdiplus_encodersgetparamlist($himage, $sencoder)
	Local $isize = _gdiplus_encodersgetparamlistsize($himage, $sencoder)
	If @error Then Return SetError(@error, -1, 0)
	Local $tguid = _winapi_guidfromstring($sencoder)
	Local $tbuffer = DllStructCreate("dword Count;byte Params[" & $isize - 4 & "]")
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetEncoderParameterList", "handle", $himage, "struct*", $tguid, "uint", $isize, "struct*", $tbuffer)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $tbuffer)
EndFunc

Func _gdiplus_encodersgetparamlistsize($himage, $sencoder)
	Local $tguid = _winapi_guidfromstring($sencoder)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetEncoderParameterListSize", "handle", $himage, "struct*", $tguid, "uint*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _gdiplus_encodersgetsize()
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageEncodersSize", "uint*", 0, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_fontcreate($hfamily, $fsize, $istyle = 0, $iunit = 3)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateFont", "handle", $hfamily, "float", $fsize, "int", $istyle, "int", $iunit, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[5])
EndFunc

Func _gdiplus_fontdispose($hfont)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteFont", "handle", $hfont)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_fontfamilycreate($sfamily)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateFontFamilyFromName", "wstr", $sfamily, "ptr", 0, "handle*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _gdiplus_fontfamilydispose($hfamily)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteFontFamily", "handle", $hfamily)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsclear($hgraphics, $iargb = -16777216)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGraphicsClear", "handle", $hgraphics, "dword", $iargb)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicscreatefromhdc($hdc)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateFromHDC", "handle", $hdc, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_graphicscreatefromhwnd($hwnd)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateFromHWND", "hwnd", $hwnd, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_graphicsdispose($hgraphics)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteGraphics", "handle", $hgraphics)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawarc($hgraphics, $ix, $iy, $iwidth, $iheight, $fstartangle, $fsweepangle, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawArcI", "handle", $hgraphics, "handle", $hpen, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight, "float", $fstartangle, "float", $fsweepangle)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawbezier($hgraphics, $ix1, $iy1, $ix2, $iy2, $ix3, $iy3, $ix4, $iy4, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawBezierI", "handle", $hgraphics, "handle", $hpen, "int", $ix1, "int", $iy1, "int", $ix2, "int", $iy2, "int", $ix3, "int", $iy3, "int", $ix4, "int", $iy4)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawclosedcurve($hgraphics, $apoints, $hpen = 0)
	Local $icount = $apoints[0][0]
	Local $tpoints = DllStructCreate("long[" & $icount * 2 & "]")
	For $ii = 1 To $icount
		DllStructSetData($tpoints, 1, $apoints[$ii][0], (($ii - 1) * 2) + 1)
		DllStructSetData($tpoints, 1, $apoints[$ii][1], (($ii - 1) * 2) + 2)
	Next
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawClosedCurveI", "handle", $hgraphics, "handle", $hpen, "struct*", $tpoints, "int", $icount)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawcurve($hgraphics, $apoints, $hpen = 0)
	Local $icount = $apoints[0][0]
	Local $tpoints = DllStructCreate("long[" & $icount * 2 & "]")
	For $ii = 1 To $icount
		DllStructSetData($tpoints, 1, $apoints[$ii][0], (($ii - 1) * 2) + 1)
		DllStructSetData($tpoints, 1, $apoints[$ii][1], (($ii - 1) * 2) + 2)
	Next
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawCurveI", "handle", $hgraphics, "handle", $hpen, "struct*", $tpoints, "int", $icount)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawellipse($hgraphics, $ix, $iy, $iwidth, $iheight, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawEllipseI", "handle", $hgraphics, "handle", $hpen, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawimage($hgraphics, $himage, $ix, $iy)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawImageI", "handle", $hgraphics, "handle", $himage, "int", $ix, "int", $iy)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawimagerect($hgraphics, $himage, $ix, $iy, $iw, $ih)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawImageRectI", "handle", $hgraphics, "handle", $himage, "int", $ix, "int", $iy, "int", $iw, "int", $ih)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawimagerectrect($hgraphics, $himage, $isrcx, $isrcy, $isrcwidth, $isrcheight, $idstx, $idsty, $idstwidth, $idstheight, $iunit = 2)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawImageRectRectI", "handle", $hgraphics, "handle", $himage, "int", $idstx, "int", $idsty, "int", $idstwidth, "int", $idstheight, "int", $isrcx, "int", $isrcy, "int", $isrcwidth, "int", $isrcheight, "int", $iunit, "int", 0, "int", 0, "int", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawline($hgraphics, $ix1, $iy1, $ix2, $iy2, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawLineI", "handle", $hgraphics, "handle", $hpen, "int", $ix1, "int", $iy1, "int", $ix2, "int", $iy2)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawpie($hgraphics, $ix, $iy, $iwidth, $iheight, $fstartangle, $fsweepangle, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawPieI", "handle", $hgraphics, "handle", $hpen, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight, "float", $fstartangle, "float", $fsweepangle)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawpolygon($hgraphics, $apoints, $hpen = 0)
	Local $icount = $apoints[0][0]
	Local $tpoints = DllStructCreate("long[" & $icount * 2 & "]")
	For $ii = 1 To $icount
		DllStructSetData($tpoints, 1, $apoints[$ii][0], (($ii - 1) * 2) + 1)
		DllStructSetData($tpoints, 1, $apoints[$ii][1], (($ii - 1) * 2) + 2)
	Next
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawPolygonI", "handle", $hgraphics, "handle", $hpen, "struct*", $tpoints, "int", $icount)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawrect($hgraphics, $ix, $iy, $iwidth, $iheight, $hpen = 0)
	__gdiplus_pendefcreate($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawRectangleI", "handle", $hgraphics, "handle", $hpen, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_pendefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsdrawstring($hgraphics, $sstring, $nx, $ny, $sfont = "Arial", $nsize = 10, $iformat = 0)
	Local $hbrush = _gdiplus_brushcreatesolid()
	Local $hformat = _gdiplus_stringformatcreate($iformat)
	Local $hfamily = _gdiplus_fontfamilycreate($sfont)
	Local $hfont = _gdiplus_fontcreate($hfamily, $nsize)
	Local $tlayout = _gdiplus_rectfcreate($nx, $ny, 0, 0)
	Local $ainfo = _gdiplus_graphicsmeasurestring($hgraphics, $sstring, $hfont, $tlayout, $hformat)
	Local $aresult = _gdiplus_graphicsdrawstringex($hgraphics, $sstring, $hfont, $ainfo[0], $hformat, $hbrush)
	Local $ierror = @error
	_gdiplus_fontdispose($hfont)
	_gdiplus_fontfamilydispose($hfamily)
	_gdiplus_stringformatdispose($hformat)
	_gdiplus_brushdispose($hbrush)
	Return SetError($ierror, 0, $aresult)
EndFunc

Func _gdiplus_graphicsdrawstringex($hgraphics, $sstring, $hfont, $tlayout, $hformat, $hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDrawString", "handle", $hgraphics, "wstr", $sstring, "int", -1, "handle", $hfont, "struct*", $tlayout, "handle", $hformat, "handle", $hbrush)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsfillclosedcurve($hgraphics, $apoints, $hbrush = 0)
	Local $icount = $apoints[0][0]
	Local $tpoints = DllStructCreate("long[" & $icount * 2 & "]")
	For $ii = 1 To $icount
		DllStructSetData($tpoints, 1, $apoints[$ii][0], (($ii - 1) * 2) + 1)
		DllStructSetData($tpoints, 1, $apoints[$ii][1], (($ii - 1) * 2) + 2)
	Next
	__gdiplus_brushdefcreate($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipFillClosedCurveI", "handle", $hgraphics, "handle", $hbrush, "struct*", $tpoints, "int", $icount)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_brushdefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsfillellipse($hgraphics, $ix, $iy, $iwidth, $iheight, $hbrush = 0)
	__gdiplus_brushdefcreate($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipFillEllipseI", "handle", $hgraphics, "handle", $hbrush, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_brushdefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsfillpie($hgraphics, $ix, $iy, $iwidth, $iheight, $fstartangle, $fsweepangle, $hbrush = 0)
	__gdiplus_brushdefcreate($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipFillPieI", "handle", $hgraphics, "handle", $hbrush, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight, "float", $fstartangle, "float", $fsweepangle)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_brushdefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsfillpolygon($hgraphics, $apoints, $hbrush = 0)
	Local $icount = $apoints[0][0]
	Local $tpoints = DllStructCreate("long[" & $icount * 2 & "]")
	For $ii = 1 To $icount
		DllStructSetData($tpoints, 1, $apoints[$ii][0], (($ii - 1) * 2) + 1)
		DllStructSetData($tpoints, 1, $apoints[$ii][1], (($ii - 1) * 2) + 2)
	Next
	__gdiplus_brushdefcreate($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipFillPolygonI", "handle", $hgraphics, "handle", $hbrush, "struct*", $tpoints, "int", $icount, "int", "FillModeAlternate")
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_brushdefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsfillrect($hgraphics, $ix, $iy, $iwidth, $iheight, $hbrush = 0)
	__gdiplus_brushdefcreate($hbrush)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipFillRectangleI", "handle", $hgraphics, "handle", $hbrush, "int", $ix, "int", $iy, "int", $iwidth, "int", $iheight)
	Local $tmperror = @error, $tmpextended = @extended
	__gdiplus_brushdefdispose()
	If $tmperror Then Return SetError($tmperror, $tmpextended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicsgetdc($hgraphics)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetDC", "handle", $hgraphics, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_graphicsgetsmoothingmode($hgraphics)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetSmoothingMode", "handle", $hgraphics, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Switch $aresult[2]
		Case 3
			Return SetExtended($aresult[0], 1)
		Case 7
			Return SetExtended($aresult[0], 2)
		Case Else
			Return SetExtended($aresult[0], 0)
	EndSwitch
EndFunc

Func _gdiplus_graphicsmeasurestring($hgraphics, $sstring, $hfont, $tlayout, $hformat)
	Local $trectf = DllStructCreate($taggdiprectf)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipMeasureString", "handle", $hgraphics, "wstr", $sstring, "int", -1, "handle", $hfont, "struct*", $tlayout, "handle", $hformat, "struct*", $trectf, "int*", 0, "int*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Local $ainfo[3]
	$ainfo[0] = $trectf
	$ainfo[1] = $aresult[8]
	$ainfo[2] = $aresult[9]
	Return SetExtended($aresult[0], $ainfo)
EndFunc

Func _gdiplus_graphicsreleasedc($hgraphics, $hdc)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipReleaseDC", "handle", $hgraphics, "handle", $hdc)
	If @error Then Return SetError(@error, @extended, False)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_graphicssettransform($hgraphics, $hmatrix)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetWorldTransform", "handle", $hgraphics, "handle", $hmatrix)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_graphicssetsmoothingmode($hgraphics, $ismooth)
	If $ismooth < 0 OR $ismooth > 4 Then $ismooth = 0
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetSmoothingMode", "handle", $hgraphics, "int", $ismooth)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_imagedispose($himage)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDisposeImage", "handle", $himage)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_imagegetflags($himage)
	Local $aflag[2] = [0, ""]
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 1, $aflag)
	Local $aimageflags[13][2] = [["Pixel data Cacheable", $gdip_imageflags_caching], ["Pixel data read-only", $gdip_imageflags_readonly], ["Pixel size in image", $gdip_imageflags_hasrealpixelsize], ["DPI info in image", $gdip_imageflags_hasrealdpi], ["YCCK color space", $gdip_imageflags_colorspace_ycck], ["YCBCR color space", $gdip_imageflags_colorspace_ycbcr], ["Grayscale image", $gdip_imageflags_colorspace_gray], ["CMYK color space", $gdip_imageflags_colorspace_cmyk], ["RGB color space", $gdip_imageflags_colorspace_rgb], ["Partially scalable", $gdip_imageflags_partiallyscalable], ["Alpha values other than 0 (transparent) and 255 (opaque)", $gdip_imageflags_hastranslucent], ["Alpha values", $gdip_imageflags_hasalpha], ["Scalable", $gdip_imageflags_scalable]]
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageFlags", "handle", $himage, "long*", 0)
	If @error Then Return SetError(@error, 2, $aflag)
	If $aresult[2] = $gdip_imageflags_none Then
		$aflag[1] = "No pixel data"
		Return SetError($aresult[0], 3, $aflag)
	EndIf
	$aflag[0] = $aresult[2]
	For $i = 0 To 12
		If BitAND($aresult[2], $aimageflags[$i][1]) = $aimageflags[$i][1] Then
			If StringLen($aflag[1]) Then $aflag[1] &= "|"
			$aresult[2] -= $aimageflags[$i][1]
			$aflag[1] &= $aimageflags[$i][0]
		EndIf
	Next
	Return SetExtended($aresult[0], $aflag)
EndFunc

Func _gdiplus_imagegetgraphicscontext($himage)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageGraphicsContext", "handle", $himage, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_imagegetheight($himage)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageHeight", "handle", $himage, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_imagegethorizontalresolution($himage)
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 1, 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageHorizontalResolution", "handle", $himage, "float*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], Round($aresult[2]))
EndFunc

Func _gdiplus_imagegetpixelformat($himage)
	Local $aformat[2] = [0, ""]
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 1, $aformat)
	Local $apixelformat[14][2] = [["1 Bpp Indexed", $gdip_pxf01indexed], ["4 Bpp Indexed", $gdip_pxf04indexed], ["8 Bpp Indexed", $gdip_pxf08indexed], ["16 Bpp Grayscale", $gdip_pxf16grayscale], ["16 Bpp RGB 555", $gdip_pxf16rgb555], ["16 Bpp RGB 565", $gdip_pxf16rgb565], ["16 Bpp ARGB 1555", $gdip_pxf16argb1555], ["24 Bpp RGB", $gdip_pxf24rgb], ["32 Bpp RGB", $gdip_pxf32rgb], ["32 Bpp ARGB", $gdip_pxf32argb], ["32 Bpp PARGB", $gdip_pxf32pargb], ["48 Bpp RGB", $gdip_pxf48rgb], ["64 Bpp ARGB", $gdip_pxf64argb], ["64 Bpp PARGB", $gdip_pxf64pargb]]
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImagePixelFormat", "handle", $himage, "int*", 0)
	If @error Then Return SetError(@error, @extended, $aformat)
	For $i = 0 To 13
		If $apixelformat[$i][1] = $aresult[2] Then
			$aformat[0] = $apixelformat[$i][1]
			$aformat[1] = $apixelformat[$i][0]
			Return SetExtended($aresult[0], $aformat)
		EndIf
	Next
	Return SetExtended($aresult[0], $aformat)
EndFunc

Func _gdiplus_imagegetrawformat($himage)
	Local $aguid[2]
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 1, $aguid)
	Local $aimagetype[11][2] = [["UNDEFINED", $gdip_imageformat_undefined], ["MEMORYBMP", $gdip_imageformat_memorybmp], ["BMP", $gdip_imageformat_bmp], ["EMF", $gdip_imageformat_emf], ["WMF", $gdip_imageformat_wmf], ["JPEG", $gdip_imageformat_jpeg], ["PNG", $gdip_imageformat_png], ["GIF", $gdip_imageformat_gif], ["TIFF", $gdip_imageformat_tiff], ["EXIF", $gdip_imageformat_exif], ["ICON", $gdip_imageformat_icon]]
	Local $tstruct = DllStructCreate("byte[16]")
	Local $aresult1 = DllCall($ghgdipdll, "int", "GdipGetImageRawFormat", "handle", $himage, "struct*", $tstruct)
	If @error Then Return SetError(@error, @extended, $aguid)
	If (NOT IsArray($aresult1)) Then Return SetError(1, 3, $aguid)
	Local $sresult2 = _winapi_stringfromguid($aresult1[2])
	If @error Then Return SetError(@error, 4, $aguid)
	For $i = 0 To 10
		If $aimagetype[$i][1] == $sresult2 Then
			$aguid[0] = $aimagetype[$i][1]
			$aguid[1] = $aimagetype[$i][0]
			Return SetExtended($aresult1[0], $aguid)
		EndIf
	Next
	Return SetError(-1, 5, $aguid)
EndFunc

Func _gdiplus_imagegettype($himage)
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 0, -1)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageType", "handle", $himage, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_imagegetverticalresolution($himage)
	If ($himage = -1) OR (NOT $himage) Then Return SetError(10, 0, 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageVerticalResolution", "handle", $himage, "float*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], Round($aresult[2]))
EndFunc

Func _gdiplus_imagegetwidth($himage)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetImageWidth", "handle", $himage, "uint*", -1)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_imageloadfromfile($sfilename)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipLoadImageFromFile", "wstr", $sfilename, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_imagesavetofile($himage, $sfilename)
	Local $sext = __gdiplus_extractfileext($sfilename)
	Local $sclsid = _gdiplus_encodersgetclsid($sext)
	If $sclsid = "" Then Return SetError(-1, 0, False)
	Return _gdiplus_imagesavetofileex($himage, $sfilename, $sclsid, 0)
EndFunc

Func _gdiplus_imagesavetofileex($himage, $sfilename, $sencoder, $pparams = 0)
	Local $tguid = _winapi_guidfromstring($sencoder)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSaveImageToFile", "handle", $himage, "wstr", $sfilename, "struct*", $tguid, "struct*", $pparams)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_matrixcreate()
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateMatrix", "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[1])
EndFunc

Func _gdiplus_matrixdispose($hmatrix)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteMatrix", "handle", $hmatrix)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_matrixrotate($hmatrix, $fangle, $bappend = False)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipRotateMatrix", "handle", $hmatrix, "float", $fangle, "int", $bappend)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_matrixscale($hmatrix, $fscalex, $fscaley, $border = False)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipScaleMatrix", "handle", $hmatrix, "float", $fscalex, "float", $fscaley, "int", $border)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_matrixtranslate($hmatrix, $foffsetx, $foffsety, $bappend = False)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipTranslateMatrix", "handle", $hmatrix, "float", $foffsetx, "float", $foffsety, "int", $bappend)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_paramadd(ByRef $tparams, $sguid, $icount, $itype, $pvalues)
	Local $tparam = DllStructCreate($taggdipencoderparam, DllStructGetPtr($tparams, "Params") + (DllStructGetData($tparams, "Count") * 28))
	_winapi_guidfromstringex($sguid, DllStructGetPtr($tparam, "GUID"))
	DllStructSetData($tparam, "Type", $itype)
	DllStructSetData($tparam, "Count", $icount)
	DllStructSetData($tparam, "Values", $pvalues)
	DllStructSetData($tparams, "Count", DllStructGetData($tparams, "Count") + 1)
EndFunc

Func _gdiplus_paraminit($icount)
	If $icount <= 0 Then Return SetError(-1, -1, 0)
	Return DllStructCreate("dword Count;byte Params[" & $icount * 28 & "]")
EndFunc

Func _gdiplus_pencreate($iargb = -16777216, $fwidth = 1, $iunit = 2)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreatePen1", "dword", $iargb, "float", $fwidth, "int", $iunit, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[4])
EndFunc

Func _gdiplus_pendispose($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeletePen", "handle", $hpen)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pengetalignment($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenMode", "handle", $hpen, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetcolor($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenColor", "handle", $hpen, "dword*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetcustomendcap($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenCustomEndCap", "handle", $hpen, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetdashcap($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenDashCap197819", "handle", $hpen, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetdashstyle($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenDashStyle", "handle", $hpen, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetendcap($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenEndCap", "handle", $hpen, "int*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pengetwidth($hpen)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipGetPenWidth", "handle", $hpen, "float*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aresult[0], $aresult[2])
EndFunc

Func _gdiplus_pensetalignment($hpen, $ialignment = 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenMode", "handle", $hpen, "int", $ialignment)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetcolor($hpen, $iargb)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenColor", "handle", $hpen, "dword", $iargb)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetdashcap($hpen, $idash = 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenDashCap197819", "handle", $hpen, "int", $idash)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetcustomendcap($hpen, $hendcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenCustomEndCap", "handle", $hpen, "handle", $hendcap)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetdashstyle($hpen, $istyle = 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenDashStyle", "handle", $hpen, "int", $istyle)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetendcap($hpen, $iendcap)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenEndCap", "handle", $hpen, "int", $iendcap)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_pensetwidth($hpen, $fwidth)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetPenWidth", "handle", $hpen, "float", $fwidth)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_rectfcreate($nx = 0, $ny = 0, $nwidth = 0, $nheight = 0)
	Local $trectf = DllStructCreate($taggdiprectf)
	DllStructSetData($trectf, "X", $nx)
	DllStructSetData($trectf, "Y", $ny)
	DllStructSetData($trectf, "Width", $nwidth)
	DllStructSetData($trectf, "Height", $nheight)
	Return $trectf
EndFunc

Func _gdiplus_shutdown()
	If $ghgdipdll = 0 Then Return SetError(-1, -1, False)
	$gigdipref -= 1
	If $gigdipref = 0 Then
		DllCall($ghgdipdll, "none", "GdiplusShutdown", "ptr", $gigdiptoken)
		DllClose($ghgdipdll)
		$ghgdipdll = 0
	EndIf
	Return True
EndFunc

Func _gdiplus_startup()
	$gigdipref += 1
	If $gigdipref > 1 Then Return True
	$ghgdipdll = DllOpen("GDIPlus.dll")
	If $ghgdipdll = -1 Then
		$gigdipref = 0
		Return SetError(1, 2, False)
	EndIf
	Local $tinput = DllStructCreate($taggdipstartupinput)
	Local $ttoken = DllStructCreate("ulong_ptr Data")
	DllStructSetData($tinput, "Version", 1)
	Local $aresult = DllCall($ghgdipdll, "int", "GdiplusStartup", "struct*", $ttoken, "struct*", $tinput, "ptr", 0)
	If @error Then Return SetError(@error, @extended, False)
	$gigdiptoken = DllStructGetData($ttoken, "Data")
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_stringformatcreate($iformat = 0, $ilangid = 0)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipCreateStringFormat", "int", $iformat, "word", $ilangid, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aresult[0], $aresult[3])
EndFunc

Func _gdiplus_stringformatdispose($hformat)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipDeleteStringFormat", "handle", $hformat)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0] = 0
EndFunc

Func _gdiplus_stringformatsetalign($hstringformat, $iflag)
	Local $aresult = DllCall($ghgdipdll, "int", "GdipSetStringFormatAlign", "handle", $hstringformat, "int", $iflag)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0] = 0
EndFunc

Func __gdiplus_brushdefcreate(ByRef $hbrush)
	If $hbrush = 0 Then
		$ghgdipbrush = _gdiplus_brushcreatesolid()
		$hbrush = $ghgdipbrush
	EndIf
EndFunc

Func __gdiplus_brushdefdispose()
	If $ghgdipbrush <> 0 Then
		_gdiplus_brushdispose($ghgdipbrush)
		$ghgdipbrush = 0
	EndIf
EndFunc

Func __gdiplus_extractfileext($sfilename, $fnodot = True)
	Local $iindex = __gdiplus_lastdelimiter(".\:", $sfilename)
	If ($iindex > 0) AND (StringMid($sfilename, $iindex, 1) = ".") Then
		If $fnodot Then
			Return StringMid($sfilename, $iindex + 1)
		Else
			Return StringMid($sfilename, $iindex)
		EndIf
	Else
		Return ""
	EndIf
EndFunc

Func __gdiplus_lastdelimiter($sdelimiters, $sstring)
	Local $sdelimiter, $in
	For $ii = 1 To StringLen($sdelimiters)
		$sdelimiter = StringMid($sdelimiters, $ii, 1)
		$in = StringInStr($sstring, $sdelimiter, 0, -1)
		If $in > 0 Then Return $in
	Next
EndFunc

Func __gdiplus_pendefcreate(ByRef $hpen)
	If $hpen = 0 Then
		$ghgdippen = _gdiplus_pencreate()
		$hpen = $ghgdippen
	EndIf
EndFunc

Func __gdiplus_pendefdispose()
	If $ghgdippen <> 0 Then
		_gdiplus_pendispose($ghgdippen)
		$ghgdippen = 0
	EndIf
EndFunc

Global Const $gui_event_close = -3
Global Const $gui_event_minimize = -4
Global Const $gui_event_restore = -5
Global Const $gui_event_maximize = -6
Global Const $gui_event_primarydown = -7
Global Const $gui_event_primaryup = -8
Global Const $gui_event_secondarydown = -9
Global Const $gui_event_secondaryup = -10
Global Const $gui_event_mousemove = -11
Global Const $gui_event_resized = -12
Global Const $gui_event_dropped = -13
Global Const $gui_rundefmsg = "GUI_RUNDEFMSG"
Global Const $gui_avistop = 0
Global Const $gui_avistart = 1
Global Const $gui_aviclose = 2
Global Const $gui_checked = 1
Global Const $gui_indeterminate = 2
Global Const $gui_unchecked = 4
Global Const $gui_dropaccepted = 8
Global Const $gui_nodropaccepted = 4096
Global Const $gui_acceptfiles = $gui_dropaccepted
Global Const $gui_show = 16
Global Const $gui_hide = 32
Global Const $gui_enable = 64
Global Const $gui_disable = 128
Global Const $gui_focus = 256
Global Const $gui_nofocus = 8192
Global Const $gui_defbutton = 512
Global Const $gui_expand = 1024
Global Const $gui_ontop = 2048
Global Const $gui_fontitalic = 2
Global Const $gui_fontunder = 4
Global Const $gui_fontstrike = 8
Global Const $gui_dockauto = 1
Global Const $gui_dockleft = 2
Global Const $gui_dockright = 4
Global Const $gui_dockhcenter = 8
Global Const $gui_docktop = 32
Global Const $gui_dockbottom = 64
Global Const $gui_dockvcenter = 128
Global Const $gui_dockwidth = 256
Global Const $gui_dockheight = 512
Global Const $gui_docksize = 768
Global Const $gui_dockmenubar = 544
Global Const $gui_dockstatebar = 576
Global Const $gui_dockall = 802
Global Const $gui_dockborders = 102
Global Const $gui_gr_close = 1
Global Const $gui_gr_line = 2
Global Const $gui_gr_bezier = 4
Global Const $gui_gr_move = 6
Global Const $gui_gr_color = 8
Global Const $gui_gr_rect = 10
Global Const $gui_gr_ellipse = 12
Global Const $gui_gr_pie = 14
Global Const $gui_gr_dot = 16
Global Const $gui_gr_pixel = 18
Global Const $gui_gr_hint = 20
Global Const $gui_gr_refresh = 22
Global Const $gui_gr_pensize = 24
Global Const $gui_gr_nobkcolor = -2
Global Const $gui_bkcolor_default = -1
Global Const $gui_bkcolor_transparent = -2
Global Const $gui_bkcolor_lv_alternate = -33554432
Global Const $gui_ws_ex_parentdrag = 1048576
Global Const $ws_tiled = 0
Global Const $ws_overlapped = 0
Global Const $ws_maximizebox = 65536
Global Const $ws_minimizebox = 131072
Global Const $ws_tabstop = 65536
Global Const $ws_group = 131072
Global Const $ws_sizebox = 262144
Global Const $ws_thickframe = 262144
Global Const $ws_sysmenu = 524288
Global Const $ws_hscroll = 1048576
Global Const $ws_vscroll = 2097152
Global Const $ws_dlgframe = 4194304
Global Const $ws_border = 8388608
Global Const $ws_caption = 12582912
Global Const $ws_overlappedwindow = 13565952
Global Const $ws_tiledwindow = 13565952
Global Const $ws_maximize = 16777216
Global Const $ws_clipchildren = 33554432
Global Const $ws_clipsiblings = 67108864
Global Const $ws_disabled = 134217728
Global Const $ws_visible = 268435456
Global Const $ws_minimize = 536870912
Global Const $ws_child = 1073741824
Global Const $ws_popup = -2147483648
Global Const $ws_popupwindow = -2138570752
Global Const $ds_modalframe = 128
Global Const $ds_setforeground = 512
Global Const $ds_contexthelp = 8192
Global Const $ws_ex_acceptfiles = 16
Global Const $ws_ex_mdichild = 64
Global Const $ws_ex_appwindow = 262144
Global Const $ws_ex_composited = 33554432
Global Const $ws_ex_clientedge = 512
Global Const $ws_ex_contexthelp = 1024
Global Const $ws_ex_dlgmodalframe = 1
Global Const $ws_ex_leftscrollbar = 16384
Global Const $ws_ex_overlappedwindow = 768
Global Const $ws_ex_right = 4096
Global Const $ws_ex_staticedge = 131072
Global Const $ws_ex_toolwindow = 128
Global Const $ws_ex_topmost = 8
Global Const $ws_ex_transparent = 32
Global Const $ws_ex_windowedge = 256
Global Const $ws_ex_layered = 524288
Global Const $ws_ex_controlparent = 65536
Global Const $ws_ex_layoutrtl = 4194304
Global Const $ws_ex_rtlreading = 8192
Global Const $wm_gettextlength = 14
Global Const $wm_gettext = 13
Global Const $wm_size = 5
Global Const $wm_sizing = 532
Global Const $wm_user = 1024
Global Const $wm_create = 1
Global Const $wm_destroy = 2
Global Const $wm_move = 3
Global Const $wm_activate = 6
Global Const $wm_setfocus = 7
Global Const $wm_killfocus = 8
Global Const $wm_enable = 10
Global Const $wm_setredraw = 11
Global Const $wm_settext = 12
Global Const $wm_paint = 15
Global Const $wm_close = 16
Global Const $wm_queryendsession = 17
Global Const $wm_quit = 18
Global Const $wm_erasebkgnd = 20
Global Const $wm_queryopen = 19
Global Const $wm_syscolorchange = 21
Global Const $wm_endsession = 22
Global Const $wm_showwindow = 24
Global Const $wm_settingchange = 26
Global Const $wm_wininichange = 26
Global Const $wm_devmodechange = 27
Global Const $wm_activateapp = 28
Global Const $wm_fontchange = 29
Global Const $wm_timechange = 30
Global Const $wm_cancelmode = 31
Global Const $wm_ime_startcomposition = 269
Global Const $wm_ime_endcomposition = 270
Global Const $wm_ime_composition = 271
Global Const $wm_ime_keylast = 271
Global Const $wm_setcursor = 32
Global Const $wm_mouseactivate = 33
Global Const $wm_childactivate = 34
Global Const $wm_queuesync = 35
Global Const $wm_getminmaxinfo = 36
Global Const $wm_painticon = 38
Global Const $wm_iconerasebkgnd = 39
Global Const $wm_nextdlgctl = 40
Global Const $wm_spoolerstatus = 42
Global Const $wm_drawitem = 43
Global Const $wm_measureitem = 44
Global Const $wm_deleteitem = 45
Global Const $wm_vkeytoitem = 46
Global Const $wm_chartoitem = 47
Global Const $wm_setfont = 48
Global Const $wm_getfont = 49
Global Const $wm_sethotkey = 50
Global Const $wm_gethotkey = 51
Global Const $wm_querydragicon = 55
Global Const $wm_compareitem = 57
Global Const $wm_getobject = 61
Global Const $wm_compacting = 65
Global Const $wm_commnotify = 68
Global Const $wm_windowposchanging = 70
Global Const $wm_windowposchanged = 71
Global Const $wm_power = 72
Global Const $wm_notify = 78
Global Const $wm_copydata = 74
Global Const $wm_canceljournal = 75
Global Const $wm_inputlangchangerequest = 80
Global Const $wm_inputlangchange = 81
Global Const $wm_tcard = 82
Global Const $wm_help = 83
Global Const $wm_userchanged = 84
Global Const $wm_notifyformat = 85
Global Const $wm_parentnotify = 528
Global Const $wm_entermenuloop = 529
Global Const $wm_exitmenuloop = 530
Global Const $wm_nextmenu = 531
Global Const $wm_capturechanged = 533
Global Const $wm_moving = 534
Global Const $wm_powerbroadcast = 536
Global Const $wm_devicechange = 537
Global Const $wm_mdicreate = 544
Global Const $wm_mdidestroy = 545
Global Const $wm_mdiactivate = 546
Global Const $wm_mdirestore = 547
Global Const $wm_mdinext = 548
Global Const $wm_mdimaximize = 549
Global Const $wm_mditile = 550
Global Const $wm_mdicascade = 551
Global Const $wm_mdiiconarrange = 552
Global Const $wm_mdigetactive = 553
Global Const $wm_mdisetmenu = 560
Global Const $wm_entersizemove = 561
Global Const $wm_exitsizemove = 562
Global Const $wm_dropfiles = 563
Global Const $wm_mdirefreshmenu = 564
Global Const $wm_ime_setcontext = 641
Global Const $wm_ime_notify = 642
Global Const $wm_ime_control = 643
Global Const $wm_ime_compositionfull = 644
Global Const $wm_ime_select = 645
Global Const $wm_ime_char = 646
Global Const $wm_ime_request = 648
Global Const $wm_ime_keydown = 656
Global Const $wm_ime_keyup = 657
Global Const $wm_ncmousehover = 672
Global Const $wm_mousehover = 673
Global Const $wm_ncmouseleave = 674
Global Const $wm_mouseleave = 675
Global Const $wm_wtssession_change = 689
Global Const $wm_tablet_first = 704
Global Const $wm_tablet_last = 735
Global Const $wm_cut = 768
Global Const $wm_copy = 769
Global Const $wm_paste = 770
Global Const $wm_clear = 771
Global Const $wm_undo = 772
Global Const $wm_paletteischanging = 784
Global Const $wm_hotkey = 786
Global Const $wm_palettechanged = 785
Global Const $wm_print = 791
Global Const $wm_printclient = 792
Global Const $wm_appcommand = 793
Global Const $wm_querynewpalette = 783
Global Const $wm_themechanged = 794
Global Const $wm_handheldfirst = 856
Global Const $wm_handheldlast = 863
Global Const $wm_afxfirst = 864
Global Const $wm_afxlast = 895
Global Const $wm_penwinfirst = 896
Global Const $wm_penwinlast = 911
Global Const $wm_contextmenu = 123
Global Const $wm_stylechanging = 124
Global Const $wm_stylechanged = 125
Global Const $wm_displaychange = 126
Global Const $wm_geticon = 127
Global Const $wm_seticon = 128
Global Const $wm_nccreate = 129
Global Const $wm_ncdestroy = 130
Global Const $wm_nccalcsize = 131
Global Const $wm_nchittest = 132
Global Const $wm_ncpaint = 133
Global Const $wm_ncactivate = 134
Global Const $wm_getdlgcode = 135
Global Const $wm_syncpaint = 136
Global Const $wm_ncmousemove = 160
Global Const $wm_nclbuttondown = 161
Global Const $wm_nclbuttonup = 162
Global Const $wm_nclbuttondblclk = 163
Global Const $wm_ncrbuttondown = 164
Global Const $wm_ncrbuttonup = 165
Global Const $wm_ncrbuttondblclk = 166
Global Const $wm_ncmbuttondown = 167
Global Const $wm_ncmbuttonup = 168
Global Const $wm_ncmbuttondblclk = 169
Global Const $wm_ncxbuttondown = 171
Global Const $wm_ncxbuttonup = 172
Global Const $wm_ncxbuttondblclk = 173
Global Const $wm_keydown = 256
Global Const $wm_keyfirst = 256
Global Const $wm_keyup = 257
Global Const $wm_char = 258
Global Const $wm_deadchar = 259
Global Const $wm_syskeydown = 260
Global Const $wm_syskeyup = 261
Global Const $wm_syschar = 262
Global Const $wm_sysdeadchar = 263
Global Const $wm_keylast = 265
Global Const $wm_unichar = 265
Global Const $wm_initdialog = 272
Global Const $wm_command = 273
Global Const $wm_syscommand = 274
Global Const $wm_timer = 275
Global Const $wm_hscroll = 276
Global Const $wm_vscroll = 277
Global Const $wm_initmenu = 278
Global Const $wm_initmenupopup = 279
Global Const $wm_menuselect = 287
Global Const $wm_menuchar = 288
Global Const $wm_enteridle = 289
Global Const $wm_menurbuttonup = 290
Global Const $wm_menudrag = 291
Global Const $wm_menugetobject = 292
Global Const $wm_uninitmenupopup = 293
Global Const $wm_menucommand = 294
Global Const $wm_changeuistate = 295
Global Const $wm_updateuistate = 296
Global Const $wm_queryuistate = 297
Global Const $wm_ctlcolormsgbox = 306
Global Const $wm_ctlcoloredit = 307
Global Const $wm_ctlcolorlistbox = 308
Global Const $wm_ctlcolorbtn = 309
Global Const $wm_ctlcolordlg = 310
Global Const $wm_ctlcolorscrollbar = 311
Global Const $wm_ctlcolorstatic = 312
Global Const $wm_ctlcolor = 25
Global Const $mn_gethmenu = 481
Global Const $wm_app = 32768
Global Const $nm_first = 0
Global Const $nm_outofmemory = $nm_first - 1
Global Const $nm_click = $nm_first - 2
Global Const $nm_dblclk = $nm_first - 3
Global Const $nm_return = $nm_first - 4
Global Const $nm_rclick = $nm_first - 5
Global Const $nm_rdblclk = $nm_first - 6
Global Const $nm_setfocus = $nm_first - 7
Global Const $nm_killfocus = $nm_first - 8
Global Const $nm_customdraw = $nm_first - 12
Global Const $nm_hover = $nm_first - 13
Global Const $nm_nchittest = $nm_first - 14
Global Const $nm_keydown = $nm_first - 15
Global Const $nm_releasedcapture = $nm_first - 16
Global Const $nm_setcursor = $nm_first - 17
Global Const $nm_char = $nm_first - 18
Global Const $nm_tooltipscreated = $nm_first - 19
Global Const $nm_ldown = $nm_first - 20
Global Const $nm_rdown = $nm_first - 21
Global Const $nm_themechanged = $nm_first - 22
Global Const $wm_mousefirst = 512
Global Const $wm_mousemove = 512
Global Const $wm_lbuttondown = 513
Global Const $wm_lbuttonup = 514
Global Const $wm_lbuttondblclk = 515
Global Const $wm_rbuttondown = 516
Global Const $wm_rbuttonup = 517
Global Const $wm_rbuttondblclk = 518
Global Const $wm_mbuttondown = 519
Global Const $wm_mbuttonup = 520
Global Const $wm_mbuttondblclk = 521
Global Const $wm_mousewheel = 522
Global Const $wm_xbuttondown = 523
Global Const $wm_xbuttonup = 524
Global Const $wm_xbuttondblclk = 525
Global Const $wm_mousehwheel = 526
Global Const $ps_solid = 0
Global Const $ps_dash = 1
Global Const $ps_dot = 2
Global Const $ps_dashdot = 3
Global Const $ps_dashdotdot = 4
Global Const $ps_null = 5
Global Const $ps_insideframe = 6
Global Const $lwa_alpha = 2
Global Const $lwa_colorkey = 1
Global Const $rgn_and = 1
Global Const $rgn_or = 2
Global Const $rgn_xor = 3
Global Const $rgn_diff = 4
Global Const $rgn_copy = 5
Global Const $errorregion = 0
Global Const $nullregion = 1
Global Const $simpleregion = 2
Global Const $complexregion = 3
Global Const $transparent = 1
Global Const $opaque = 2
Global Const $ccm_first = 8192
Global Const $ccm_getunicodeformat = ($ccm_first + 6)
Global Const $ccm_setunicodeformat = ($ccm_first + 5)
Global Const $ccm_setbkcolor = $ccm_first + 1
Global Const $ccm_setcolorscheme = $ccm_first + 2
Global Const $ccm_getcolorscheme = $ccm_first + 3
Global Const $ccm_getdroptarget = $ccm_first + 4
Global Const $ccm_setwindowtheme = $ccm_first + 11
Global Const $ga_parent = 1
Global Const $ga_root = 2
Global Const $ga_rootowner = 3
Global Const $sm_cxscreen = 0
Global Const $sm_cyscreen = 1
Global Const $sm_cxvscroll = 2
Global Const $sm_cyhscroll = 3
Global Const $sm_cycaption = 4
Global Const $sm_cxborder = 5
Global Const $sm_cyborder = 6
Global Const $sm_cxdlgframe = 7
Global Const $sm_cydlgframe = 8
Global Const $sm_cyvthumb = 9
Global Const $sm_cxhthumb = 10
Global Const $sm_cxicon = 11
Global Const $sm_cyicon = 12
Global Const $sm_cxcursor = 13
Global Const $sm_cycursor = 14
Global Const $sm_cymenu = 15
Global Const $sm_cxfullscreen = 16
Global Const $sm_cyfullscreen = 17
Global Const $sm_cykanjiwindow = 18
Global Const $sm_mousepresent = 19
Global Const $sm_cyvscroll = 20
Global Const $sm_cxhscroll = 21
Global Const $sm_debug = 22
Global Const $sm_swapbutton = 23
Global Const $sm_reserved1 = 24
Global Const $sm_reserved2 = 25
Global Const $sm_reserved3 = 26
Global Const $sm_reserved4 = 27
Global Const $sm_cxmin = 28
Global Const $sm_cymin = 29
Global Const $sm_cxsize = 30
Global Const $sm_cysize = 31
Global Const $sm_cxframe = 32
Global Const $sm_cyframe = 33
Global Const $sm_cxmintrack = 34
Global Const $sm_cymintrack = 35
Global Const $sm_cxdoubleclk = 36
Global Const $sm_cydoubleclk = 37
Global Const $sm_cxiconspacing = 38
Global Const $sm_cyiconspacing = 39
Global Const $sm_menudropalignment = 40
Global Const $sm_penwindows = 41
Global Const $sm_dbcsenabled = 42
Global Const $sm_cmousebuttons = 43
Global Const $sm_secure = 44
Global Const $sm_cxedge = 45
Global Const $sm_cyedge = 46
Global Const $sm_cxminspacing = 47
Global Const $sm_cyminspacing = 48
Global Const $sm_cxsmicon = 49
Global Const $sm_cysmicon = 50
Global Const $sm_cysmcaption = 51
Global Const $sm_cxsmsize = 52
Global Const $sm_cysmsize = 53
Global Const $sm_cxmenusize = 54
Global Const $sm_cymenusize = 55
Global Const $sm_arrange = 56
Global Const $sm_cxminimized = 57
Global Const $sm_cyminimized = 58
Global Const $sm_cxmaxtrack = 59
Global Const $sm_cymaxtrack = 60
Global Const $sm_cxmaximized = 61
Global Const $sm_cymaximized = 62
Global Const $sm_network = 63
Global Const $sm_cleanboot = 67
Global Const $sm_cxdrag = 68
Global Const $sm_cydrag = 69
Global Const $sm_showsounds = 70
Global Const $sm_cxmenucheck = 71
Global Const $sm_cymenucheck = 72
Global Const $sm_slowmachine = 73
Global Const $sm_mideastenabled = 74
Global Const $sm_mousewheelpresent = 75
Global Const $sm_xvirtualscreen = 76
Global Const $sm_yvirtualscreen = 77
Global Const $sm_cxvirtualscreen = 78
Global Const $sm_cyvirtualscreen = 79
Global Const $sm_cmonitors = 80
Global Const $sm_samedisplayformat = 81
Global Const $sm_immenabled = 82
Global Const $sm_cxfocusborder = 83
Global Const $sm_cyfocusborder = 84
Global Const $sm_tabletpc = 86
Global Const $sm_mediacenter = 87
Global Const $sm_starter = 88
Global Const $sm_serverr2 = 89
Global Const $sm_cmetrics = 90
Global Const $sm_remotesession = 4096
Global Const $sm_shuttingdown = 8192
Global Const $sm_remotecontrol = 8193
Global Const $sm_caretblinkingenabled = 8194
Global Const $blackness = 66
Global Const $captureblt = 1073741824
Global Const $dstinvert = 5570569
Global Const $mergecopy = 12583114
Global Const $mergepaint = 12255782
Global Const $nomirrorbitmap = -2147483648
Global Const $notsrccopy = 3342344
Global Const $notsrcerase = 1114278
Global Const $patcopy = 15728673
Global Const $patinvert = 5898313
Global Const $patpaint = 16452105
Global Const $srcand = 8913094
Global Const $srccopy = 13369376
Global Const $srcerase = 4457256
Global Const $srcinvert = 6684742
Global Const $srcpaint = 15597702
Global Const $whiteness = 16711778
Global Const $dt_bottom = 8
Global Const $dt_calcrect = 1024
Global Const $dt_center = 1
Global Const $dt_editcontrol = 8192
Global Const $dt_end_ellipsis = 32768
Global Const $dt_expandtabs = 64
Global Const $dt_externalleading = 512
Global Const $dt_hideprefix = 1048576
Global Const $dt_internal = 4096
Global Const $dt_left = 0
Global Const $dt_modifystring = 65536
Global Const $dt_noclip = 256
Global Const $dt_nofullwidthcharbreak = 524288
Global Const $dt_noprefix = 2048
Global Const $dt_path_ellipsis = 16384
Global Const $dt_prefixonly = 2097152
Global Const $dt_right = 2
Global Const $dt_rtlreading = 131072
Global Const $dt_singleline = 32
Global Const $dt_tabstop = 128
Global Const $dt_top = 0
Global Const $dt_vcenter = 4
Global Const $dt_wordbreak = 16
Global Const $dt_word_ellipsis = 262144
Global Const $rdw_erase = 4
Global Const $rdw_frame = 1024
Global Const $rdw_internalpaint = 2
Global Const $rdw_invalidate = 1
Global Const $rdw_noerase = 32
Global Const $rdw_noframe = 2048
Global Const $rdw_nointernalpaint = 16
Global Const $rdw_validate = 8
Global Const $rdw_erasenow = 512
Global Const $rdw_updatenow = 256
Global Const $rdw_allchildren = 128
Global Const $rdw_nochildren = 64
Global Const $wm_renderformat = 773
Global Const $wm_renderallformats = 774
Global Const $wm_destroyclipboard = 775
Global Const $wm_drawclipboard = 776
Global Const $wm_paintclipboard = 777
Global Const $wm_vscrollclipboard = 778
Global Const $wm_sizeclipboard = 779
Global Const $wm_askcbformatname = 780
Global Const $wm_changecbchain = 781
Global Const $wm_hscrollclipboard = 782
Global Const $hterror = -2
Global Const $httransparent = -1
Global Const $htnowhere = 0
Global Const $htclient = 1
Global Const $htcaption = 2
Global Const $htsysmenu = 3
Global Const $htgrowbox = 4
Global Const $htsize = $htgrowbox
Global Const $htmenu = 5
Global Const $hthscroll = 6
Global Const $htvscroll = 7
Global Const $htminbutton = 8
Global Const $htmaxbutton = 9
Global Const $htleft = 10
Global Const $htright = 11
Global Const $httop = 12
Global Const $httopleft = 13
Global Const $httopright = 14
Global Const $htbottom = 15
Global Const $htbottomleft = 16
Global Const $htbottomright = 17
Global Const $htborder = 18
Global Const $htreduce = $htminbutton
Global Const $htzoom = $htmaxbutton
Global Const $htsizefirst = $htleft
Global Const $htsizelast = $htbottomright
Global Const $htobject = 19
Global Const $htclose = 20
Global Const $hthelp = 21
Global Const $color_scrollbar = 0
Global Const $color_background = 1
Global Const $color_activecaption = 2
Global Const $color_inactivecaption = 3
Global Const $color_menu = 4
Global Const $color_window = 5
Global Const $color_windowframe = 6
Global Const $color_menutext = 7
Global Const $color_windowtext = 8
Global Const $color_captiontext = 9
Global Const $color_activeborder = 10
Global Const $color_inactiveborder = 11
Global Const $color_appworkspace = 12
Global Const $color_highlight = 13
Global Const $color_highlighttext = 14
Global Const $color_btnface = 15
Global Const $color_btnshadow = 16
Global Const $color_graytext = 17
Global Const $color_btntext = 18
Global Const $color_inactivecaptiontext = 19
Global Const $color_btnhighlight = 20
Global Const $color_3ddkshadow = 21
Global Const $color_3dlight = 22
Global Const $color_infotext = 23
Global Const $color_infobk = 24
Global Const $color_hotlight = 26
Global Const $color_gradientactivecaption = 27
Global Const $color_gradientinactivecaption = 28
Global Const $color_menuhilight = 29
Global Const $color_menubar = 30
Global Const $color_desktop = 1
Global Const $color_3dface = 15
Global Const $color_3dshadow = 16
Global Const $color_3dhighlight = 20
Global Const $color_3dhilight = 20
Global Const $color_btnhilight = 20
Global Const $hinst_commctrl = -1
Global Const $idb_std_small_color = 0
Global Const $idb_std_large_color = 1
Global Const $idb_view_small_color = 4
Global Const $idb_view_large_color = 5
Global Const $idb_hist_small_color = 8
Global Const $idb_hist_large_color = 9
Global Const $startf_forceofffeedback = 128
Global Const $startf_forceonfeedback = 64
Global Const $startf_runfullscreen = 32
Global Const $startf_usecountchars = 8
Global Const $startf_usefillattribute = 16
Global Const $startf_usehotkey = 512
Global Const $startf_useposition = 4
Global Const $startf_useshowwindow = 1
Global Const $startf_usesize = 2
Global Const $startf_usestdhandles = 256
Global Const $cdds_prepaint = 1
Global Const $cdds_postpaint = 2
Global Const $cdds_preerase = 3
Global Const $cdds_posterase = 4
Global Const $cdds_item = 65536
Global Const $cdds_itemprepaint = 65537
Global Const $cdds_itempostpaint = 65538
Global Const $cdds_itempreerase = 65539
Global Const $cdds_itemposterase = 65540
Global Const $cdds_subitem = 131072
Global Const $cdis_selected = 1
Global Const $cdis_grayed = 2
Global Const $cdis_disabled = 4
Global Const $cdis_checked = 8
Global Const $cdis_focus = 16
Global Const $cdis_default = 32
Global Const $cdis_hot = 64
Global Const $cdis_marked = 128
Global Const $cdis_indeterminate = 256
Global Const $cdis_showkeyboardcues = 512
Global Const $cdis_nearhot = 1024
Global Const $cdis_othersidehot = 2048
Global Const $cdis_drophilited = 4096
Global Const $cdrf_dodefault = 0
Global Const $cdrf_newfont = 2
Global Const $cdrf_skipdefault = 4
Global Const $cdrf_notifypostpaint = 16
Global Const $cdrf_notifyitemdraw = 32
Global Const $cdrf_notifysubitemdraw = 32
Global Const $cdrf_notifyposterase = 64
Global Const $cdrf_doerase = 8
Global Const $cdrf_skippostpaint = 256
Global Const $gui_ss_default_gui = BitOR($ws_minimizebox, $ws_caption, $ws_popup, $ws_sysmenu)
Global Const $gmem_fixed = 0
Global Const $gmem_moveable = 2
Global Const $gmem_nocompact = 16
Global Const $gmem_nodiscard = 32
Global Const $gmem_zeroinit = 64
Global Const $gmem_modify = 128
Global Const $gmem_discardable = 256
Global Const $gmem_not_banked = 4096
Global Const $gmem_share = 8192
Global Const $gmem_ddeshare = 8192
Global Const $gmem_notify = 16384
Global Const $gmem_lower = 4096
Global Const $gmem_valid_flags = 32626
Global Const $gmem_invalid_handle = 32768
Global Const $gptr = $gmem_fixed + $gmem_zeroinit
Global Const $ghnd = $gmem_moveable + $gmem_zeroinit
Global Const $mem_commit = 4096
Global Const $mem_reserve = 8192
Global Const $mem_top_down = 1048576
Global Const $mem_shared = 134217728
Global Const $page_noaccess = 1
Global Const $page_readonly = 2
Global Const $page_readwrite = 4
Global Const $page_execute = 16
Global Const $page_execute_read = 32
Global Const $page_execute_readwrite = 64
Global Const $page_guard = 256
Global Const $page_nocache = 512
Global Const $mem_decommit = 16384
Global Const $mem_release = 32768
Global Const $process_terminate = 1
Global Const $process_create_thread = 2
Global Const $process_set_sessionid = 4
Global Const $process_vm_operation = 8
Global Const $process_vm_read = 16
Global Const $process_vm_write = 32
Global Const $process_dup_handle = 64
Global Const $process_create_process = 128
Global Const $process_set_quota = 256
Global Const $process_set_information = 512
Global Const $process_query_information = 1024
Global Const $process_suspend_resume = 2048
Global Const $process_all_access = 2035711
Global Const $tagmemmap = "handle hProc;ulong_ptr Size;ptr Mem"

Func _memfree(ByRef $tmemmap)
	Local $pmemory = DllStructGetData($tmemmap, "Mem")
	Local $hprocess = DllStructGetData($tmemmap, "hProc")
	Local $bresult = _memvirtualfreeex($hprocess, $pmemory, 0, $mem_release)
	DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $hprocess)
	If @error Then Return SetError(@error, @extended, False)
	Return $bresult
EndFunc

Func _memglobalalloc($ibytes, $iflags = 0)
	Local $aresult = DllCall("kernel32.dll", "handle", "GlobalAlloc", "uint", $iflags, "ulong_ptr", $ibytes)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _memglobalfree($hmem)
	Local $aresult = DllCall("kernel32.dll", "ptr", "GlobalFree", "handle", $hmem)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _memgloballock($hmem)
	Local $aresult = DllCall("kernel32.dll", "ptr", "GlobalLock", "handle", $hmem)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _memglobalsize($hmem)
	Local $aresult = DllCall("kernel32.dll", "ulong_ptr", "GlobalSize", "handle", $hmem)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _memglobalunlock($hmem)
	Local $aresult = DllCall("kernel32.dll", "bool", "GlobalUnlock", "handle", $hmem)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _meminit($hwnd, $isize, ByRef $tmemmap)
	Local $aresult = DllCall("User32.dll", "dword", "GetWindowThreadProcessId", "hwnd", $hwnd, "dword*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Local $iprocessid = $aresult[2]
	If $iprocessid = 0 Then Return SetError(1, 0, 0)
	Local $iaccess = BitOR($process_vm_operation, $process_vm_read, $process_vm_write)
	Local $hprocess = __mem_openprocess($iaccess, False, $iprocessid, True)
	Local $ialloc = BitOR($mem_reserve, $mem_commit)
	Local $pmemory = _memvirtualallocex($hprocess, 0, $isize, $ialloc, $page_readwrite)
	If $pmemory = 0 Then Return SetError(2, 0, 0)
	$tmemmap = DllStructCreate($tagmemmap)
	DllStructSetData($tmemmap, "hProc", $hprocess)
	DllStructSetData($tmemmap, "Size", $isize)
	DllStructSetData($tmemmap, "Mem", $pmemory)
	Return $pmemory
EndFunc

Func _memmovememory($psource, $pdest, $ilength)
	DllCall("kernel32.dll", "none", "RtlMoveMemory", "struct*", $pdest, "struct*", $psource, "ulong_ptr", $ilength)
	If @error Then Return SetError(@error, @extended)
EndFunc

Func _memread(ByRef $tmemmap, $psrce, $pdest, $isize)
	Local $aresult = DllCall("kernel32.dll", "bool", "ReadProcessMemory", "handle", DllStructGetData($tmemmap, "hProc"), "ptr", $psrce, "struct*", $pdest, "ulong_ptr", $isize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _memwrite(ByRef $tmemmap, $psrce, $pdest = 0, $isize = 0, $ssrce = "struct*")
	If $pdest = 0 Then $pdest = DllStructGetData($tmemmap, "Mem")
	If $isize = 0 Then $isize = DllStructGetData($tmemmap, "Size")
	Local $aresult = DllCall("kernel32.dll", "bool", "WriteProcessMemory", "handle", DllStructGetData($tmemmap, "hProc"), "ptr", $pdest, $ssrce, $psrce, "ulong_ptr", $isize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _memvirtualalloc($paddress, $isize, $iallocation, $iprotect)
	Local $aresult = DllCall("kernel32.dll", "ptr", "VirtualAlloc", "ptr", $paddress, "ulong_ptr", $isize, "dword", $iallocation, "dword", $iprotect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _memvirtualallocex($hprocess, $paddress, $isize, $iallocation, $iprotect)
	Local $aresult = DllCall("kernel32.dll", "ptr", "VirtualAllocEx", "handle", $hprocess, "ptr", $paddress, "ulong_ptr", $isize, "dword", $iallocation, "dword", $iprotect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aresult[0]
EndFunc

Func _memvirtualfree($paddress, $isize, $ifreetype)
	Local $aresult = DllCall("kernel32.dll", "bool", "VirtualFree", "ptr", $paddress, "ulong_ptr", $isize, "dword", $ifreetype)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func _memvirtualfreeex($hprocess, $paddress, $isize, $ifreetype)
	Local $aresult = DllCall("kernel32.dll", "bool", "VirtualFreeEx", "handle", $hprocess, "ptr", $paddress, "ulong_ptr", $isize, "dword", $ifreetype)
	If @error Then Return SetError(@error, @extended, False)
	Return $aresult[0]
EndFunc

Func __mem_openprocess($iaccess, $finherit, $iprocessid, $fdebugpriv = False)
	Local $aresult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iaccess, "bool", $finherit, "dword", $iprocessid)
	If @error Then Return SetError(@error, @extended, 0)
	If $aresult[0] Then Return $aresult[0]
	If NOT $fdebugpriv Then Return 0
	Local $htoken = _security__openthreadtokenex(BitOR($token_adjust_privileges, $token_query))
	If @error Then Return SetError(@error, @extended, 0)
	_security__setprivilege($htoken, "SeDebugPrivilege", True)
	Local $ierror = @error
	Local $ilasterror = @extended
	Local $iret = 0
	If NOT @error Then
		$aresult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iaccess, "bool", $finherit, "dword", $iprocessid)
		$ierror = @error
		$ilasterror = @extended
		If $aresult[0] Then $iret = $aresult[0]
		_security__setprivilege($htoken, "SeDebugPrivilege", False)
		If @error Then
			$ierror = @error
			$ilasterror = @extended
		EndIf
	EndIf
	DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $htoken)
	Return SetError($ierror, $ilasterror, $iret)
EndFunc

#Region Header
Global Const $ddl_archive = 32
Global Const $ddl_directory = 16
Global Const $ddl_drives = 16384
Global Const $ddl_exclusive = 32768
Global Const $ddl_hidden = 2
Global Const $ddl_readonly = 1
Global Const $ddl_readwrite = 0
Global Const $ddl_system = 4
Global Const $color_aqua = 65535
Global Const $color_black = 0
Global Const $color_blue = 255
Global Const $color_cream = 16776176
Global Const $color_fuchsia = 16711935
Global Const $color_gray = 8421504
Global Const $color_green = 32768
Global Const $color_lime = 65280
Global Const $color_maroon = 9116770
Global Const $color_medblue = 708
Global Const $color_medgray = 10526884
Global Const $color_moneygreen = 12639424
Global Const $color_navy = 128
Global Const $color_olive = 8421376
Global Const $color_purple = 8388736
Global Const $color_red = 16711680
Global Const $color_silver = 12632256
Global Const $color_skyblue = 10930928
Global Const $color_teal = 32896
Global Const $color_white = 16777215
Global Const $color_yellow = 16776960
Global Const $clr_none = -1
Global Const $clr_default = -16777216
Global Const $clr_aqua = 16776960
Global Const $clr_black = 0
Global Const $clr_blue = 16711680
Global Const $clr_cream = 15793151
Global Const $clr_fuchsia = 16711935
Global Const $clr_gray = 8421504
Global Const $clr_green = 32768
Global Const $clr_lime = 65280
Global Const $clr_maroon = 6429835
Global Const $clr_medblue = 12845568
Global Const $clr_medgray = 10789024
Global Const $clr_moneygreen = 12639424
Global Const $clr_navy = 8388608
Global Const $clr_olive = 32896
Global Const $clr_purple = 8388736
Global Const $clr_red = 255
Global Const $clr_silver = 12632256
Global Const $clr_skyblue = 15780518
Global Const $clr_teal = 8421376
Global Const $clr_white = 16777215
Global Const $clr_yellow = 65535
Global Const $cc_anycolor = 256
Global Const $cc_fullopen = 2
Global Const $cc_rgbinit = 1
Global Const $opt_coordsrelative = 0
Global Const $opt_coordsabsolute = 1
Global Const $opt_coordsclient = 2
Global Const $opt_errorsilent = 0
Global Const $opt_errorfatal = 1
Global Const $opt_capsnostore = 0
Global Const $opt_capsstore = 1
Global Const $opt_matchstart = 1
Global Const $opt_matchany = 2
Global Const $opt_matchexact = 3
Global Const $opt_matchadvanced = 4
Global Const $ccs_top = 1
Global Const $ccs_nomovey = 2
Global Const $ccs_bottom = 3
Global Const $ccs_noresize = 4
Global Const $ccs_noparentalign = 8
Global Const $ccs_nohilite = 16
Global Const $ccs_adjustable = 32
Global Const $ccs_nodivider = 64
Global Const $ccs_vert = 128
Global Const $ccs_left = 129
Global Const $ccs_nomovex = 130
Global Const $ccs_right = 131
Global Const $di_mask = 1
Global Const $di_image = 2
Global Const $di_normal = 3
Global Const $di_compat = 4
Global Const $di_defaultsize = 8
Global Const $di_nomirror = 16
Global Const $display_device_attached_to_desktop = 1
Global Const $display_device_multi_driver = 2
Global Const $display_device_primary_device = 4
Global Const $display_device_mirroring_driver = 8
Global Const $display_device_vga_compatible = 16
Global Const $display_device_removable = 32
Global Const $display_device_disconnect = 33554432
Global Const $display_device_remote = 67108864
Global Const $display_device_modespruned = 134217728
Global Const $flashw_caption = 1
Global Const $flashw_tray = 2
Global Const $flashw_timer = 4
Global Const $flashw_timernofg = 12
Global Const $format_message_allocate_buffer = 256
Global Const $format_message_ignore_inserts = 512
Global Const $format_message_from_string = 1024
Global Const $format_message_from_hmodule = 2048
Global Const $format_message_from_system = 4096
Global Const $format_message_argument_array = 8192
Global Const $gw_hwndfirst = 0
Global Const $gw_hwndlast = 1
Global Const $gw_hwndnext = 2
Global Const $gw_hwndprev = 3
Global Const $gw_owner = 4
Global Const $gw_child = 5
Global Const $gwl_wndproc = -4
Global Const $gwl_hinstance = -6
Global Const $gwl_hwndparent = -8
Global Const $gwl_id = -12
Global Const $gwl_style = -16
Global Const $gwl_exstyle = -20
Global Const $gwl_userdata = -21
Global Const $std_cut = 0
Global Const $std_copy = 1
Global Const $std_paste = 2
Global Const $std_undo = 3
Global Const $std_redow = 4
Global Const $std_delete = 5
Global Const $std_filenew = 6
Global Const $std_fileopen = 7
Global Const $std_filesave = 8
Global Const $std_printpre = 9
Global Const $std_properties = 10
Global Const $std_help = 11
Global Const $std_find = 12
Global Const $std_replace = 13
Global Const $std_print = 14
Global Const $lr_defaultcolor = 0
Global Const $lr_monochrome = 1
Global Const $lr_color = 2
Global Const $lr_copyreturnorg = 4
Global Const $lr_copydeleteorg = 8
Global Const $lr_loadfromfile = 16
Global Const $lr_loadtransparent = 32
Global Const $lr_defaultsize = 64
Global Const $lr_vgacolor = 128
Global Const $lr_loadmap3dcolors = 4096
Global Const $lr_createdibsection = 8192
Global Const $lr_copyfromresource = 16384
Global Const $lr_shared = 32768
Global Const $image_bitmap = 0
Global Const $image_icon = 1
Global Const $image_cursor = 2
Global Const $kb_sendspecial = 0
Global Const $kb_sendraw = 1
Global Const $kb_capsoff = 0
Global Const $kb_capson = 1
Global Const $dont_resolve_dll_references = 1
Global Const $load_library_as_datafile = 2
Global Const $load_with_altered_search_path = 8
Global Const $objid_window = 0
Global Const $objid_titlebar = -2
Global Const $objid_sizegrip = -7
Global Const $objid_caret = -8
Global Const $objid_cursor = -9
Global Const $objid_alert = -10
Global Const $objid_sound = -11
Global Const $vk_down = 40
Global Const $vk_end = 35
Global Const $vk_home = 36
Global Const $vk_left = 37
Global Const $vk_next = 34
Global Const $vk_prior = 33
Global Const $vk_right = 39
Global Const $vk_up = 38
Global Const $vk_lbutton = 1
Global Const $vk_rbutton = 2
Global Const $vk_mbutton = 4
Global Const $mb_ok = 0
Global Const $mb_okcancel = 1
Global Const $mb_abortretryignore = 2
Global Const $mb_yesnocancel = 3
Global Const $mb_yesno = 4
Global Const $mb_retrycancel = 5
Global Const $mb_iconhand = 16
Global Const $mb_iconquestion = 32
Global Const $mb_iconexclamation = 48
Global Const $mb_iconasterisk = 64
Global Const $mb_defbutton1 = 0
Global Const $mb_defbutton2 = 256
Global Const $mb_defbutton3 = 512
Global Const $mb_applmodal = 0
Global Const $mb_systemmodal = 4096
Global Const $mb_taskmodal = 8192
Global Const $mb_topmost = 262144
Global Const $mb_rightjustified = 524288
Global Const $idtimeout = -1
Global Const $idok = 1
Global Const $idcancel = 2
Global Const $idabort = 3
Global Const $idretry = 4
Global Const $idignore = 5
Global Const $idyes = 6
Global Const $idno = 7
Global Const $idtryagain = 10
Global Const $idcontinue = 11
Global Const $dlg_notitle = 1
Global Const $dlg_notontop = 2
Global Const $dlg_textleft = 4
Global Const $dlg_textright = 8
Global Const $dlg_moveable = 16
Global Const $dlg_textvcenter = 32
Global Const $tip_iconnone = 0
Global Const $tip_iconasterisk = 1
Global Const $tip_iconexclamation = 2
Global Const $tip_iconhand = 3
Global Const $tip_nosound = 16
Global Const $idc_unknown = 0
Global Const $idc_appstarting = 1
Global Const $idc_arrow = 2
Global Const $idc_cross = 3
Global Const $idc_hand = 32649
Global Const $idc_help = 4
Global Const $idc_ibeam = 5
Global Const $idc_icon = 6
Global Const $idc_no = 7
Global Const $idc_size = 8
Global Const $idc_sizeall = 9
Global Const $idc_sizenesw = 10
Global Const $idc_sizens = 11
Global Const $idc_sizenwse = 12
Global Const $idc_sizewe = 13
Global Const $idc_uparrow = 14
Global Const $idc_wait = 15
Global Const $idi_application = 32512
Global Const $idi_asterisk = 32516
Global Const $idi_exclamation = 32515
Global Const $idi_hand = 32513
Global Const $idi_question = 32514
Global Const $idi_winlogo = 32517
Global Const $sd_logoff = 0
Global Const $sd_shutdown = 1
Global Const $sd_reboot = 2
Global Const $sd_force = 4
Global Const $sd_powerdown = 8
Global Const $str_nocasesense = 0
Global Const $str_casesense = 1
Global Const $str_stripleading = 1
Global Const $str_striptrailing = 2
Global Const $str_stripspaces = 4
Global Const $str_stripall = 8
Global Const $tray_item_exit = 3
Global Const $tray_item_pause = 4
Global Const $tray_item_first = 7
Global Const $tray_checked = 1
Global Const $tray_unchecked = 4
Global Const $tray_enable = 64
Global Const $tray_disable = 128
Global Const $tray_focus = 256
Global Const $tray_default = 512
Global Const $tray_event_showicon = -3
Global Const $tray_event_hideicon = -4
Global Const $tray_event_flashicon = -5
Global Const $tray_event_noflashicon = -6
Global Const $tray_event_primarydown = -7
Global Const $tray_event_primaryup = -8
Global Const $tray_event_secondarydown = -9
Global Const $tray_event_secondaryup = -10
Global Const $tray_event_mouseover = -11
Global Const $tray_event_mouseout = -12
Global Const $tray_event_primarydouble = -13
Global Const $tray_event_secondarydouble = -14
Global Const $stdin_child = 1
Global Const $stdout_child = 2
Global Const $stderr_child = 4
Global Const $stderr_merged = 8
Global Const $stdio_inherit_parent = 16
Global Const $run_create_new_console = 65536
Global Const $mouseeventf_absolute = 32768
Global Const $mouseeventf_move = 1
Global Const $mouseeventf_leftdown = 2
Global Const $mouseeventf_leftup = 4
Global Const $mouseeventf_rightdown = 8
Global Const $mouseeventf_rightup = 16
Global Const $mouseeventf_middledown = 32
Global Const $mouseeventf_middleup = 64
Global Const $mouseeventf_wheel = 2048
Global Const $mouseeventf_xdown = 128
Global Const $mouseeventf_xup = 256
Global Const $reg_none = 0
Global Const $reg_sz = 1
Global Const $reg_expand_sz = 2
Global Const $reg_binary = 3
Global Const $reg_dword = 4
Global Const $reg_dword_big_endian = 5
Global Const $reg_link = 6
Global Const $reg_multi_sz = 7
Global Const $reg_resource_list = 8
Global Const $reg_full_resource_descriptor = 9
Global Const $reg_resource_requirements_list = 10
Global Const $hwnd_bottom = 1
Global Const $hwnd_notopmost = -2
Global Const $hwnd_top = 0
Global Const $hwnd_topmost = -1
Global Const $swp_nosize = 1
Global Const $swp_nomove = 2
Global Const $swp_nozorder = 4
Global Const $swp_noredraw = 8
Global Const $swp_noactivate = 16
Global Const $swp_framechanged = 32
Global Const $swp_drawframe = 32
Global Const $swp_showwindow = 64
Global Const $swp_hidewindow = 128
Global Const $swp_nocopybits = 256
Global Const $swp_noownerzorder = 512
Global Const $swp_noreposition = 512
Global Const $swp_nosendchanging = 1024
Global Const $swp_defererase = 8192
Global Const $swp_asyncwindowpos = 16384
Global Const $lang_afrikaans = 54
Global Const $lang_albanian = 28
Global Const $lang_arabic = 1
Global Const $lang_armenian = 43
Global Const $lang_assamese = 77
Global Const $lang_azeri = 44
Global Const $lang_basque = 45
Global Const $lang_belarusian = 35
Global Const $lang_bengali = 69
Global Const $lang_bulgarian = 2
Global Const $lang_catalan = 3
Global Const $lang_chinese = 4
Global Const $lang_croatian = 26
Global Const $lang_czech = 5
Global Const $lang_danish = 6
Global Const $lang_dutch = 19
Global Const $lang_english = 9
Global Const $lang_estonian = 37
Global Const $lang_faeroese = 56
Global Const $lang_farsi = 41
Global Const $lang_finnish = 11
Global Const $lang_french = 156
Global Const $lang_georgian = 55
Global Const $lang_german = 7
Global Const $lang_greek = 8
Global Const $lang_gujarati = 71
Global Const $lang_hebrew = 13
Global Const $lang_hindi = 57
Global Const $lang_hungarian = 14
Global Const $lang_icelandic = 15
Global Const $lang_indonesian = 33
Global Const $lang_italian = 16
Global Const $lang_japanese = 17
Global Const $lang_kannada = 75
Global Const $lang_kashmiri = 96
Global Const $lang_kazak = 63
Global Const $lang_konkani = 87
Global Const $lang_korean = 18
Global Const $lang_latvian = 38
Global Const $lang_lithuanian = 39
Global Const $lang_macedonian = 47
Global Const $lang_malay = 62
Global Const $lang_malayalam = 76
Global Const $lang_manipuri = 88
Global Const $lang_marathi = 78
Global Const $lang_nepali = 97
Global Const $lang_neutral = 0
Global Const $lang_norwegian = 20
Global Const $lang_oriya = 72
Global Const $lang_polish = 21
Global Const $lang_portuguese = 22
Global Const $lang_punjabi = 70
Global Const $lang_romanian = 24
Global Const $lang_russian = 25
Global Const $lang_sanskrit = 79
Global Const $lang_serbian = 26
Global Const $lang_sindhi = 89
Global Const $lang_slovak = 27
Global Const $lang_slovenian = 36
Global Const $lang_spanish = 10
Global Const $lang_swahili = 65
Global Const $lang_swedish = 29
Global Const $lang_tamil = 73
Global Const $lang_tatar = 68
Global Const $lang_telugu = 74
Global Const $lang_thai = 30
Global Const $lang_turkish = 31
Global Const $lang_ukrainian = 34
Global Const $lang_urdu = 32
Global Const $lang_uzbek = 67
Global Const $lang_vietnamese = 42
Global Const $sublang_arabic_algeria = 5
Global Const $sublang_arabic_bahrain = 15
Global Const $sublang_arabic_egypt = 3
Global Const $sublang_arabic_iraq = 2
Global Const $sublang_arabic_jordan = 11
Global Const $sublang_arabic_kuwait = 13
Global Const $sublang_arabic_lebanon = 12
Global Const $sublang_arabic_libya = 4
Global Const $sublang_arabic_morocco = 6
Global Const $sublang_arabic_oman = 8
Global Const $sublang_arabic_qatar = 16
Global Const $sublang_arabic_saudi_arabia = 1
Global Const $sublang_arabic_syria = 10
Global Const $sublang_arabic_tunisia = 7
Global Const $sublang_arabic_uae = 14
Global Const $sublang_arabic_yemen = 9
Global Const $sublang_azeri_cyrillic = 2
Global Const $sublang_azeri_latin = 1
Global Const $sublang_chinese_hongkong = 3
Global Const $sublang_chinese_macau = 5
Global Const $sublang_chinese_simplified = 2
Global Const $sublang_chinese_singapore = 4
Global Const $sublang_chinese_traditional = 1
Global Const $sublang_default = 1
Global Const $sublang_dutch = 1
Global Const $sublang_dutch_belgian = 2
Global Const $sublang_english_aus = 3
Global Const $sublang_english_belize = 10
Global Const $sublang_english_can = 4
Global Const $sublang_english_caribbean = 9
Global Const $sublang_english_eire = 6
Global Const $sublang_english_jamaica = 8
Global Const $sublang_english_nz = 5
Global Const $sublang_english_philippines = 13
Global Const $sublang_english_south_africa = 7
Global Const $sublang_english_trinidad = 11
Global Const $sublang_english_uk = 2
Global Const $sublang_english_us = 1
Global Const $sublang_english_zimbabwe = 12
Global Const $sublang_french = 1
Global Const $sublang_french_belgian = 2
Global Const $sublang_french_canadian = 3
Global Const $sublang_french_luxembourg = 5
Global Const $sublang_french_monaco = 6
Global Const $sublang_french_swiss = 4
Global Const $sublang_german = 1
Global Const $sublang_german_austrian = 3
Global Const $sublang_german_liechtenstein = 5
Global Const $sublang_german_luxembourg = 4
Global Const $sublang_german_swiss = 2
Global Const $sublang_italian = 1
Global Const $sublang_italian_swiss = 2
Global Const $sublang_kashmiri_india = 2
Global Const $sublang_korean = 1
Global Const $sublang_lithuanian = 1
Global Const $sublang_malay_brunei_darussalam = 2
Global Const $sublang_malay_malaysia = 1
Global Const $sublang_nepali_india = 2
Global Const $sublang_neutral = 0
Global Const $sublang_norwegian_bokmal = 1
Global Const $sublang_norwegian_nynorsk = 2
Global Const $sublang_portuguese = 2
Global Const $sublang_portuguese_brazilian = 1
Global Const $sublang_serbian_cyrillic = 3
Global Const $sublang_serbian_latin = 2
Global Const $sublang_spanish = 1
Global Const $sublang_spanish_argentina = 11
Global Const $sublang_spanish_bolivia = 16
Global Const $sublang_spanish_chile = 13
Global Const $sublang_spanish_colombia = 9
Global Const $sublang_spanish_costa_rica = 5
Global Const $sublang_spanish_dominican_republic = 7
Global Const $sublang_spanish_ecuador = 12
Global Const $sublang_spanish_el_salvador = 17
Global Const $sublang_spanish_guatemala = 4
Global Const $sublang_spanish_honduras = 18
Global Const $sublang_spanish_mexican = 2
Global Const $sublang_spanish_modern = 3
Global Const $sublang_spanish_nicaragua = 19
Global Const $sublang_spanish_panama = 6
Global Const $sublang_spanish_paraguay = 15
Global Const $sublang_spanish_peru = 10
Global Const $sublang_spanish_puerto_rico = 20
Global Const $sublang_spanish_uruguay = 14
Global Const $sublang_spanish_venezuela = 8
Global Const $sublang_swedish = 1
Global Const $sublang_swedish_finland = 2
Global Const $sublang_sys_default = 2
Global Const $sublang_urdu_india = 2
Global Const $sublang_urdu_pakistan = 1
Global Const $sublang_uzbek_cyrillic = 2
Global Const $sort_default = 0
Global Const $sort_japanese_xjis = 0
Global Const $sort_japanese_unicode = 1
Global Const $sort_chinese_big5 = 0
Global Const $sort_chinese_prcp = 0
Global Const $sort_chinese_unicode = 1
Global Const $sort_chinese_prc = 2
Global Const $sort_korean_ksc = 0
Global Const $sort_korean_unicode = 1
Global Const $sort_german_phone_book = 1
Global Const $sort_hungarian_default = 0
Global Const $sort_hungarian_technical = 1
Global Const $sort_georgian_traditional = 0
Global Const $sort_georgian_modern = 1
Global Const $es_left = 0
Global Const $es_center = 1
Global Const $es_right = 2
Global Const $es_multiline = 4
Global Const $es_uppercase = 8
Global Const $es_lowercase = 16
Global Const $es_password = 32
Global Const $es_autovscroll = 64
Global Const $es_autohscroll = 128
Global Const $es_nohidesel = 256
Global Const $es_oemconvert = 1024
Global Const $es_readonly = 2048
Global Const $es_wantreturn = 4096
Global Const $es_number = 8192
Global Const $ec_err = -1
Global Const $ecm_first = 5376
Global Const $em_canundo = 198
Global Const $em_charfrompos = 215
Global Const $em_emptyundobuffer = 205
Global Const $em_fmtlines = 200
Global Const $em_getcuebanner = ($ecm_first + 2)
Global Const $em_getfirstvisibleline = 206
Global Const $em_gethandle = 189
Global Const $em_getimestatus = 217
Global Const $em_getlimittext = 213
Global Const $em_getline = 196
Global Const $em_getlinecount = 186
Global Const $em_getmargins = 212
Global Const $em_getmodify = 184
Global Const $em_getpasswordchar = 210
Global Const $em_getrect = 178
Global Const $em_getsel = 176
Global Const $em_getthumb = 190
Global Const $em_getwordbreakproc = 209
Global Const $em_hideballoontip = ($ecm_first + 4)
Global Const $em_limittext = 197
Global Const $em_linefromchar = 201
Global Const $em_lineindex = 187
Global Const $em_linelength = 193
Global Const $em_linescroll = 182
Global Const $em_posfromchar = 214
Global Const $em_replacesel = 194
Global Const $em_scroll = 181
Global Const $em_scrollcaret = 183
Global Const $em_setcuebanner = ($ecm_first + 1)
Global Const $em_sethandle = 188
Global Const $em_setimestatus = 216
Global Const $em_setlimittext = $em_limittext
Global Const $em_setmargins = 211
Global Const $em_setmodify = 185
Global Const $em_setpasswordchar = 204
Global Const $em_setreadonly = 207
Global Const $em_setrect = 179
Global Const $em_setrectnp = 180
Global Const $em_setsel = 177
Global Const $em_settabstops = 203
Global Const $em_setwordbreakproc = 208
Global Const $em_showballoontip = ($ecm_first + 3)
Global Const $em_undo = 199
Global Const $ec_leftmargin = 1
Global Const $ec_rightmargin = 2
Global Const $ec_usefontinfo = 65535
Global Const $emsis_compositionstring = 1
Global Const $eimes_getcompstratonce = 1
Global Const $eimes_cancelcompstrinfocus = 2
Global Const $eimes_completecompstrkillfocus = 4
Global Const $en_align_ltr_ec = 1792
Global Const $en_align_rtl_ec = 1793
Global Const $en_change = 768
Global Const $en_errspace = 1280
Global Const $en_hscroll = 1537
Global Const $en_killfocus = 512
Global Const $en_maxtext = 1281
Global Const $en_setfocus = 256
Global Const $en_update = 1024
Global Const $en_vscroll = 1538
Global Const $tti_none = 0
Global Const $tti_info = 1
Global Const $tti_warning = 2
Global Const $tti_error = 3
Global Const $tti_info_large = 4
Global Const $tti_warning_large = 5
Global Const $tti_error_large = 6
Global Const $__editconstant_ws_vscroll = 2097152
Global Const $__editconstant_ws_hscroll = 1048576
Global Const $gui_ss_default_edit = BitOR($es_wantreturn, $__editconstant_ws_vscroll, $__editconstant_ws_hscroll, $es_autovscroll, $es_autohscroll)
Global Const $gui_ss_default_input = BitOR($es_left, $es_autohscroll)
Global Const $ss_left = 0
Global Const $ss_center = 1
Global Const $ss_right = 2
Global Const $ss_icon = 3
Global Const $ss_blackrect = 4
Global Const $ss_grayrect = 5
Global Const $ss_whiterect = 6
Global Const $ss_blackframe = 7
Global Const $ss_grayframe = 8
Global Const $ss_whiteframe = 9
Global Const $ss_simple = 11
Global Const $ss_leftnowordwrap = 12
Global Const $ss_bitmap = 14
Global Const $ss_etchedhorz = 16
Global Const $ss_etchedvert = 17
Global Const $ss_etchedframe = 18
Global Const $ss_noprefix = 128
Global Const $ss_notify = 256
Global Const $ss_centerimage = 512
Global Const $ss_rightjust = 1024
Global Const $ss_sunken = 4096
Global Const $gui_ss_default_label = 0
Global Const $gui_ss_default_graphic = 0
Global Const $gui_ss_default_icon = $ss_notify
Global Const $gui_ss_default_pic = $ss_notify
#EndRegion Header
#Region Global Variables and Constants
Global Const $cc_flag_solidcolor = 1
Global Const $cc_flag_capturecolor = 2
Global Const $cc_flag_usercolor = 64
Global Const $cc_flag_default = BitOR($cc_flag_solidcolor, $cc_flag_capturecolor)
#EndRegion Global Variables and Constants
#Region Local Variables and Constants
Global Const $cc_reg_commondata = "HKCU\SOFTWARE\Y's\Common Data\Color Chooser\1.1\Palette"
Global Const $cc_wm_command = 273
Global Const $cc_wm_ncrbuttondown = 164
Global Const $cc_wm_setcursor = 32
Global Const $cc_wm_syscommand = 274
Dim $ccdata[29] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, Default, Default, 0, 0]
Dim $ccpalette[21][3] = [[0, 1, 0]]
For $i = 1 To UBound($ccpalette) - 1
	$ccpalette[$i][0] = -1
Next
Global $__cc_rgb[3], $__cc_hsl[3], $__cc_hsb[3]
Global $__cc_wm0111 = 0
Global $__cc_wm0020 = 0
#EndRegion Local Variables and Constants
#Region Initialization
GUIRegisterMsg($cc_wm_command, "CC_WM_COMMAND")
GUIRegisterMsg($cc_wm_ncrbuttondown, "CC_WM_NCRBUTTONDOWN")
GUIRegisterMsg($cc_wm_setcursor, "CC_WM_SETCURSOR")
GUIRegisterMsg($cc_wm_syscommand, "CC_WM_SYSCOMMAND")
#EndRegion Initialization
#Region Public Functions

Func _colorchooserdialog($icolor = 0, $hparent = 0, $ireftype = 0, $ireturntype = 0, $iflags = -1, $stitle = "Color")
	If $iflags < 0 Then
		$iflags = $cc_flag_default
	EndIf
	$ccdata[8] = _image_arrow()
	Local $hpopup = 0, $msg, $xp, $yp, $pos, $cursor, $index, $h1 = 0, $h2 = 0, $pressed = False, $return = False
	Local $h1 = 69 * (BitAND($iflags, $cc_flag_solidcolor) = $cc_flag_solidcolor)
	Local $h2 = 56 * (BitAND($iflags, $cc_flag_usercolor) = $cc_flag_usercolor)
	Local $guioneventmode = Opt("GUIOnEventMode", 0)
	Local $guicloseonesc = Opt("GUICloseOnESC", 1)
	GUISetState(@SW_DISABLE, $hparent)
	$ccdata[0] = GUICreate($stitle, 315, 396 + $h1 + $h2, -1, -1, BitOR($ws_caption, $ws_popup, $ws_sysmenu), $ws_ex_dlgmodalframe, $hparent)
	cc_setchildpos($ccdata[0], $hparent, $ccdata[25], $ccdata[26])
	GUISetFont(9, 400, 0, "Tahoma", $ccdata[0])
	$ccdata[23] = GUICtrlCreateButton("OK", 115, 365 + $h1 + $h2, 85, 23)
	GUICtrlSetFont(-1, 8.5, 400, 0, "MS Shell Dlg")
	GUICtrlSetState(-1, $gui_defbutton)
	$ccdata[1] = GUICtrlCreatePic("", 20, 20, 243, 243, BitOR($gui_ss_default_pic, $ss_sunken))
	If $ccdata[9] Then
		GUICtrlSetState(-1, $gui_disable)
	EndIf
	$ccdata[2] = GUICtrlCreatePic("", 264, 17, 8, 249)
	$ccdata[3] = GUICtrlCreatePic("", 296, 17, 8, 249)
	$ccdata[4] = GUICtrlCreatePic("", 273, 20, 22, 243, BitOR($gui_ss_default_pic, $ss_sunken))
	If BitAND($iflags, $cc_flag_solidcolor) Then
		GUICtrlCreatePic("", 20, 273, 243, 59, BitOR($gui_ss_default_pic, $ss_sunken))
		GUICtrlSetState(-1, $gui_disable)
		$ccdata[5] = GUICtrlCreatePic("", 21, 274, 123, 57)
		$ccdata[6] = GUICtrlCreatePic("", 144, 274, 118, 57)
	Else
		$ccdata[5] = 0
		$ccdata[6] = 0
	EndIf
	If BitAND($iflags, $cc_flag_capturecolor) Then
		$ccdata[7] = GUICtrlCreatePic("", 275, 273, 19, 19)
	Else
		$ccdata[7] = 0
	EndIf
	$ccpalette[0][0] = 0
	If BitAND($iflags, $cc_flag_usercolor) Then
		cc_loadusercolor()
		For $i = 1 To 2
			For $j = 1 To 10
				$index = 10 * ($i - 1) + $j
				$ccpalette[$index][1] = GUICtrlCreatePic("", 18 + 25 * ($j - 1), 271 + 28 * ($i - 1) + $h1, 22, 22)
				cc_setusercolor($index)
			Next
		Next
	Else
		For $i = 1 To 10
			$ccpalette[$i][1] = 0
		Next
	EndIf
	GUICtrlCreateLabel("R:", 19, 279 + $h1 + $h2, 13, 14)
	$ccdata[10] = GUICtrlCreateInput("", 33, 277 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("G:", 19, 304 + $h1 + $h2, 13, 14)
	$ccdata[11] = GUICtrlCreateInput("", 33, 302 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("B:", 19, 329 + $h1 + $h2, 13, 14)
	$ccdata[12] = GUICtrlCreateInput("", 33, 327 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("H:", 86, 279 + $h1 + $h2, 13, 14)
	$ccdata[13] = GUICtrlCreateInput("", 100, 277 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("S:", 86, 304 + $h1 + $h2, 13, 14)
	$ccdata[14] = GUICtrlCreateInput("", 100, 302 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("L:", 86, 329 + $h1 + $h2, 13, 14)
	$ccdata[15] = GUICtrlCreateInput("", 100, 327 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("H:", 153, 279 + $h1 + $h2, 13, 14)
	GUICtrlCreateLabel("", 202, 279 + $h1 + $h2, 14, 14)
	$ccdata[16] = GUICtrlCreateInput("", 167, 277 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("S:", 153, 304 + $h1 + $h2, 13, 14)
	GUICtrlCreateLabel("%", 202, 304 + $h1 + $h2, 14, 14)
	$ccdata[17] = GUICtrlCreateInput("", 167, 302 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("B:", 153, 329 + $h1 + $h2, 13, 14)
	GUICtrlCreateLabel("%", 202, 329 + $h1 + $h2, 14, 14)
	$ccdata[18] = GUICtrlCreateInput("", 167, 327 + $h1 + $h2, 34, 19)
	GUICtrlCreateLabel("#", 223, 279 + $h1 + $h2, 10, 14)
	$ccdata[19] = GUICtrlCreateInput("", 234, 277 + $h1 + $h2, 61, 19)
	GUICtrlSetLimit(-1, 6)
	$ccdata[24] = GUICtrlCreateDummy()
	$ccdata[27] = GUICtrlCreateDummy()
	For $i = 10 To 18
		GUICtrlSetLimit($ccdata[$i], 3)
	Next
	cc_setpalette()
	cc_setpicker()
	cc_validatecolor($icolor, $ireftype)
	cc_update($ccdata[20])
	cc_setcolor($__cc_rgb)
	GUISetState(@SW_SHOW, $ccdata[0])
	$ccdata[22] = 0
	While 1
		$msg = 0
		$cursor = GUIGetCursorInfo($ccdata[0])
		If (NOT @error) AND (BitAND(WinGetState($ccdata[0]), 8)) Then
			If $cursor[2] Then
				If $cursor[4] = $ccdata[1] Then
					If NOT $pressed Then
						$msg = $gui_event_primarydown
					EndIf
				Else
					$pressed = 1
				EndIf
			Else
				$pressed = 0
			EndIf
		EndIf
		If NOT $msg Then
			$msg = GUIGetMsg(1)
			If $msg[1] = $ccdata[0] Then
				$msg = $msg[0]
			Else
				ContinueLoop
			EndIf
			If $msg = $gui_event_primarydown Then
				ContinueLoop
			EndIf
		EndIf
		Switch $msg
			Case $gui_event_primarydown
				GUICtrlSetState($ccdata[23], $gui_focus)
				$xp = Default
				While cc_ispressed(1)
					$pos = cc_getcursor($ccdata[1])
					If NOT @error Then
						If ($pos[0] <> $xp) OR ($pos[1] <> $yp) Then
							For $i = 1 To 2
								$__cc_hsb[$i] = Round($pos[$i - 1] / 240 * 100)
								If $__cc_hsb[$i] > 100 Then
									$__cc_hsb[$i] = 100
								EndIf
								If $__cc_hsb[$i] < 0 Then
									$__cc_hsb[$i] = 0
								EndIf
							Next
							$__cc_hsb[2] = 100 - $__cc_hsb[2]
							cc_update(3, 0)
							$xp = $pos[0]
							$yp = $pos[1]
						EndIf
					EndIf
				WEnd
			Case 0
				ContinueLoop
			Case $gui_event_close
				ExitLoop
			Case $ccdata[2], $ccdata[3], $ccdata[4]
				GUICtrlSetState($ccdata[23], $gui_focus)
				$xp = Default
				While cc_ispressed(1)
					$pos = cc_getcursor($ccdata[2])
					If NOT @error Then
						If $pos[1] <> $yp Then
							$__cc_hsb[0] = Round((240 - $pos[1] + 4) / 240 * 359)
							If $__cc_hsb[0] > 359 Then
								$__cc_hsb[0] = 359
							EndIf
							If $__cc_hsb[0] < 0 Then
								$__cc_hsb[0] = 0
							EndIf
							cc_update(3, 1)
							$xp = $pos[0]
							$yp = $pos[1]
						EndIf
					EndIf
				WEnd
			Case $ccdata[7]
				GUICtrlSetState($ccdata[23], $gui_focus)
				If NOT $ccdata[5] Then
					$hpopup = GUICreate("", 95, 95, -1, -1, $ws_popup, $ws_ex_topmost, $ccdata[0])
					GUISetBkColor(0)
					$ccdata[5] = GUICtrlCreatePic("", 1, 1, 93, 93, $ss_whiterect)
					GUICtrlSetState(-1, $gui_disable)
				EndIf
				$xp = Default
				While cc_ispressed(1)
					$pos = cc_getcursor()
					If NOT @error Then
						If ($pos[0] <> $xp) OR ($pos[1] <> $yp) Then
							If $hpopup Then
								WinMove($hpopup, "", $pos[0] + 16, $pos[1] + 16)
								If NOT BitAND(WinGetState($hpopup), 2) Then
									GUISetState(@SW_SHOWNOACTIVATE, $hpopup)
								EndIf
								cc_setbitmap($ccdata[5], cc_capture($pos[0] - 15, $pos[1] - 15, 31, 31, 93, 93))
							Else
								cc_setbitmap($ccdata[5], cc_capture($pos[0] - 20, $pos[1] - 9, 41, 19, 123, 57))
							EndIf
							$xp = $pos[0]
							$yp = $pos[1]
						EndIf
					EndIf
				WEnd
				If $hpopup Then
					GUIDelete($hpopup)
					$ccdata[5] = 0
				EndIf
				$__cc_rgb = cc_splitcolor($ccdata[21])
				cc_update(1)
			Case $ccdata[23]
				$return = 1
				ExitLoop
			Case $ccdata[24]
				$index = GUICtrlRead($ccdata[24])
				If $index Then
					cc_update($index, 1, 1)
				EndIf
			Case $ccdata[27]
				$index = GUICtrlRead($ccdata[27])
				Switch $index
					Case 0
					Case $ccdata[1], $ccdata[5]
						If $ccpalette[0][0] Then
							$ccpalette[$ccpalette[0][0]][0] = cc_rgb($__cc_rgb)
							cc_setusercolor($ccpalette[0][0], 1)
						EndIf
					Case $ccdata[6]
						cc_validatecolor($icolor, $ireftype)
						cc_update($ccdata[20])
					Case Else
						For $i = 1 To 20
							If $index = $ccpalette[$i][1] Then
								If ($ccpalette[$i][0] > -1) AND ($ccpalette[$i][0] <> cc_rgb($__cc_rgb)) Then
									$__cc_rgb = cc_splitcolor($ccpalette[$i][0])
									cc_update(1)
								EndIf
								ExitLoop
							EndIf
						Next
				EndSwitch
			Case Else
				For $i = 1 To 20
					If $msg = $ccpalette[$i][1] Then
						If $i <> $ccpalette[0][0] Then
							cc_setusercolor($ccpalette[0][0])
							cc_setusercolor($i, 1)
							$ccpalette[0][0] = $i
						EndIf
						ExitLoop
					EndIf
				Next
		EndSwitch
	WEnd
	$ccdata[22] = 1
	GUISetState(@SW_ENABLE, $hparent)
	GUIDelete($ccdata[0])
	$ccdata[0] = 0
	Opt("GUIOnEventMode", $guioneventmode)
	Opt("GUICloseOnESC", $guicloseonesc)
	_gdiplus_imagedispose($ccdata[8])
	If BitAND($iflags, $cc_flag_usercolor) Then
		cc_saveusercolor()
	EndIf
	If $return Then
		Switch $ireturntype
			Case 1
				Return $__cc_hsl
			Case 2
				Return $__cc_hsb
			Case Else
				Return cc_rgb($__cc_rgb)
		EndSwitch
	Else
		Return  - 1
	EndIf
EndFunc

#EndRegion Public Functions
#Region Internal Functions

Func cc_beep()
	DllCall("user32.dll", "int", "MessageBeep", "int", 0)
EndFunc

Func cc_capture($ix, $iy, $isrcwidth, $isrcheight, $idstwidth, $idstheight)
	Local $trect, $hwnd, $hdc, $hsrcdc, $hdstdc, $hgraphics, $hbrush, $hpen, $himage, $hbitmap, $hscreen
	Local $pos = cc_getclientpos($ccdata[0])
	$hwnd = _winapi_getdesktopwindow()
	$hdc = _winapi_getdc($hwnd)
	$hsrcdc = _winapi_createcompatibledc($hdc)
	$hscreen = _winapi_createcompatiblebitmap($hdc, $isrcwidth, $isrcheight)
	_winapi_selectobject($hsrcdc, $hscreen)
	_winapi_bitblt($hsrcdc, 0, 0, $isrcwidth, $isrcheight, $hdc, $ix, $iy, $srccopy)
	$trect = DllStructCreate($tagrect)
	DllStructSetData($trect, 1, $pos[0] - $ix + 21)
	DllStructSetData($trect, 2, $pos[1] - $iy + 274)
	DllStructSetData($trect, 3, $pos[0] - $ix + 21 + 123)
	DllStructSetData($trect, 4, $pos[1] - $iy + 274 + 57)
	$hbrush = _winapi_createsolidbrush(0)
	_winapi_fillrect($hsrcdc, DllStructGetPtr($trect), $hbrush)
	_winapi_deleteobject($hbrush)
	$hdstdc = _winapi_createcompatibledc($hdc)
	$hbitmap = _winapi_createcompatiblebitmap($hdc, $idstwidth, $idstheight)
	_winapi_selectobject($hdstdc, $hbitmap)
	DllCall("gdi32.dll", "int", "SetStretchBltMode", "hwnd", $hdstdc, "int", 3)
	DllCall("gdi32.dll", "int", "StretchBlt", "hwnd", $hdstdc, "int", 0, "int", 0, "int", $idstwidth, "int", $idstheight, "hwnd", $hsrcdc, "int", 0, "int", 0, "int", $isrcwidth, "int", $isrcheight, "dword", $srccopy)
	_winapi_releasedc($hwnd, $hdc)
	_winapi_deletedc($hdstdc)
	_winapi_deletedc($hsrcdc)
	_winapi_deleteobject($hscreen)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$ccdata[21] = __gdiplus_bitmapgetpixel($himage, $idstwidth / 2, $idstheight / 2)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hpen = _gdiplus_pencreate(1627324416, 3)
	_gdiplus_graphicsdrawline($hgraphics, 0, $idstheight / 2, $idstwidth / 2 - 4, $idstheight / 2, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $idstwidth / 2 + 5, $idstheight / 2, $idstwidth, $idstheight / 2, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $idstwidth / 2, 0, $idstwidth / 2, $idstheight / 2 - 4, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $idstwidth / 2, $idstheight / 2 + 5, $idstwidth / 2, $idstheight, $hpen)
	_gdiplus_graphicsdrawrect($hgraphics, $idstwidth / 2 - 3, $idstheight / 2 - 3, 6, 6, $hpen)
	_gdiplus_pendispose($hpen)
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($himage)
	Return $hbitmap
EndFunc

Func cc_getbvalue($irgb)
	Return BitAND($irgb, 255)
EndFunc

Func cc_getclientpos($hwnd)
	Local $size = WinGetClientSize($hwnd)
	If NOT IsArray($size) Then
		Return SetError(1, 0, 0)
	EndIf
	Local $tpoint = DllStructCreate($tagpoint)
	For $i = 1 To 2
		DllStructSetData($tpoint, $i, 0)
	Next
	_winapi_clienttoscreen($hwnd, $tpoint)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	Local $pos[4]
	For $i = 0 To 1
		$pos[$i] = DllStructGetData($tpoint, $i + 1)
	Next
	For $i = 2 To 3
		$pos[$i] = $size[$i - 2]
	Next
	Return $pos
EndFunc

Func cc_getcursor($hwnd = 0)
	If NOT IsHWnd($hwnd) Then
		$hwnd = GUICtrlGetHandle($hwnd)
	EndIf
	Local $tpoint = _winapi_getmousepos($hwnd, $hwnd)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	Local $pos[2]
	For $i = 0 To 1
		$pos[$i] = DllStructGetData($tpoint, $i + 1)
	Next
	Return $pos
EndFunc

Func cc_getgvalue($irgb)
	Return BitShift(BitAND($irgb, 65280), 8)
EndFunc

Func cc_getrvalue($irgb)
	Return BitShift(BitAND($irgb, 16711680), 16)
EndFunc

Func cc_isdark($irgb)
	If cc_getrvalue($irgb) + cc_getgvalue($irgb) + cc_getbvalue($irgb) < 3 * 255 / 2 Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc

Func cc_ispressed($ikey)
	Local $ret = DllCall("user32.dll", "short", "GetAsyncKeyState", "int", $ikey)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	Return Number(BitAND($ret[0], 32768) <> 0)
EndFunc

Func cc_loadimagefrommem(ByRef $bimage)
	Local $himage, $hstream, $bdata, $hdata, $pdata, $tdata, $lenght
	$bdata = Binary($bimage)
	$lenght = BinaryLen($bdata)
	$hdata = _memglobalalloc($lenght, 2)
	$pdata = _memgloballock($hdata)
	$tdata = DllStructCreate("byte[" & $lenght & "]", $pdata)
	DllStructSetData($tdata, 1, $bdata)
	_memglobalunlock($hdata)
	$hstream = DllCall("ole32.dll", "int", "CreateStreamOnHGlobal", "ptr", $hdata, "int", 1, "ptr*", 0)
	$himage = __gdiplus_bitmapcreatefromstream($hstream[3])
	Return $himage
EndFunc

Func cc_loadusercolor()
	For $i = 1 To UBound($ccpalette) - 1
		$ccpalette[$i][0] = RegRead($cc_reg_commondata, StringFormat("#%02d", $i))
		If (@error) OR (BitAND(-16777216, $ccpalette[$i][0])) Then
			$ccpalette[$i][0] = -1
		EndIf
	Next
EndFunc

Func cc_rgb($argb)
	Return BitOR(BitShift($argb[0], -16), BitShift($argb[1], -8), $argb[2])
EndFunc

Func cc_saveusercolor()
	For $i = 1 To UBound($ccpalette) - 1
		RegWrite($cc_reg_commondata, StringFormat("#%02d", $i), "REG_DWORD", $ccpalette[$i][0])
	Next
EndFunc

Func cc_setbitmap($hwnd, $hbitmap)
	If NOT IsHWnd($hwnd) Then
		$hwnd = GUICtrlGetHandle($hwnd)
		If $hwnd = 0 Then
			Return
		EndIf
	EndIf
	Local $hobj
	$hobj = _sendmessage($hwnd, 370, 0, $hbitmap)
	If $hobj Then
		_winapi_deleteobject($hobj)
	EndIf
	_winapi_invalidaterect($hwnd)
	$hobj = _sendmessage($hwnd, 371)
	If $hobj <> $hbitmap Then
		_winapi_deleteobject($hbitmap)
	EndIf
EndFunc

Func cc_setchildpos($hchild, $hparent, $ix = Default, $iy = Default)
	Local $pos1, $pos2 = cc_getclientpos($hparent)
	Local $trect, $ret, $x, $y, $height
	$pos1 = WinGetPos($hchild)
	If (@error) OR (NOT IsArray($pos2)) Then
		Return SetError(1, 0, 0)
	EndIf
	If $ix = Default Then
		$x = $pos2[0] + ($pos2[2] - $pos1[2]) / 2
	Else
		$x = $pos2[0] + $ix
	EndIf
	If $iy = Default Then
		$y = $pos2[1] + ($pos2[3] - $pos1[3]) / 2
	Else
		$y = $pos2[1] + $iy
	EndIf
	$trect = DllStructCreate($tagrect)
	$ret = DllCall("user32.dll", "int", "SystemParametersInfo", "int", 48, "int", 0, "ptr", DllStructGetPtr($trect), "int", 0)
	If (@error) OR ($ret[0] = 0) Then
		$height = @DesktopHeight
	Else
		$height = DllStructGetData($trect, 4)
	EndIf
	If $x < 0 Then
		$x = 0
	EndIf
	If $x > @DesktopWidth - $pos1[2] Then
		$x = @DesktopWidth - $pos1[2]
	EndIf
	If $y < 0 Then
		$y = 0
	EndIf
	If $y > $height - $pos1[3] Then
		$y = $height - $pos1[3]
	EndIf
	If NOT WinMove($hchild, "", $x, $y) Then
		Return SetError(1, 0, 0)
	EndIf
	Return 1
EndFunc

Func cc_setcolor($rgb)
	Local $hgraphics, $hbrush, $himage, $hbitmap
	$hbitmap = _winapi_createbitmap(118, 57, 1, 32)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hbrush = _gdiplus_brushcreatesolid(BitOR(-16777216, cc_rgb($rgb)))
	_gdiplus_graphicsfillrect($hgraphics, 0, 0, 118, 57, $hbrush)
	_gdiplus_brushdispose($hbrush)
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($himage)
	cc_setbitmap($ccdata[6], $hbitmap)
EndFunc

Func cc_setpalette()
	Local $hgraphics, $hpen, $himage, $hbitmap
	Local $argb, $rgb, $hsb[3]
	$hbitmap = _winapi_createbitmap(20, 241, 1, 32)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hsb[1] = 100
	$hsb[2] = 100
	For $i = 0 To 240
		$hsb[0] = (240 - $i) * 359 / 240
		$rgb = _hsb2rgb($hsb)
		$hpen = _gdiplus_pencreate(BitOR(-16777216, cc_rgb($rgb)), 1)
		_gdiplus_graphicsdrawline($hgraphics, 0, $i, 19, $i, $hpen)
		_gdiplus_pendispose($hpen)
	Next
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($himage)
	cc_setbitmap($ccdata[4], $hbitmap)
EndFunc

Func cc_setpicker()
	Local $hgraphics, $hbrush, $hpicker, $himage, $hbitmap
	$hbitmap = _winapi_createbitmap(19, 19, 1, 32)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hbrush = _gdiplus_brushcreatesolid(BitOR(-16777216, cc_switchcolor(_winapi_getsyscolor($color_3dface))))
	_gdiplus_graphicsfillrect($hgraphics, 0, 0, 19, 19, $hbrush)
	_gdiplus_brushdispose($hbrush)
	$hpicker = _image_picker()
	_gdiplus_graphicsdrawimagerect($hgraphics, $hpicker, 0, 0, 19, 19)
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($hpicker)
	_gdiplus_imagedispose($himage)
	cc_setbitmap($ccdata[7], $hbitmap)
EndFunc

Func cc_setusercolor($iindex, $fselect = 0)
	Local $hgraphics, $hbrush, $hpen, $himage, $hbitmap
	$hbitmap = _winapi_createbitmap(22, 22, 1, 32)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hbrush = _gdiplus_brushcreatesolid(BitOR(-16777216, cc_switchcolor(_winapi_getsyscolor($color_3dface))))
	_gdiplus_graphicsfillrect($hgraphics, 0, 0, 22, 22, $hbrush)
	$hpen = _gdiplus_pencreate(-5789785)
	_gdiplus_graphicsdrawrect($hgraphics, 2, 2, 17, 17, $hpen)
	If $fselect Then
		_gdiplus_pensetcolor($hpen, -10461088)
		_gdiplus_graphicsdrawrect($hgraphics, 0, 0, 21, 21, $hpen)
	EndIf
	If $ccpalette[$iindex][0] > -1 Then
		_gdiplus_brushsetsolidcolor($hbrush, BitOR(-16777216, $ccpalette[$iindex][0]))
		_gdiplus_graphicsfillrect($hgraphics, 3, 3, 16, 16, $hbrush)
		If $ccpalette[0][1] Then
			GUICtrlSetTip($ccpalette[$iindex][1], "#" & Hex($ccpalette[$iindex][0], 6))
		EndIf
	Else
		If $ccpalette[0][1] Then
			GUICtrlSetTip($ccpalette[$iindex][1], "None")
		EndIf
	EndIf
	_gdiplus_brushdispose($hbrush)
	_gdiplus_pendispose($hpen)
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($himage)
	cc_setbitmap($ccpalette[$iindex][1], $hbitmap)
EndFunc

Func cc_splitcolor($icolor)
	Local $rgb[3]
	$rgb[0] = cc_getrvalue($icolor)
	$rgb[1] = cc_getgvalue($icolor)
	$rgb[2] = cc_getbvalue($icolor)
	Return $rgb
EndFunc

Func cc_switchcolor($icolor)
	Return BitOR(BitAND($icolor, 65280), BitShift(BitAND($icolor, 255), -16), BitShift(BitAND($icolor, 16711680), 16))
EndFunc

Func cc_update($iindex, $fpalette = 1, $fskip = 0)
	Local $hgraphics, $hbrush, $hpen, $himage, $hbitmap
	Local $x, $y, $argb, $rgb, $hsb
	Switch $iindex
		Case 4
			ContinueCase
		Case 1
			$__cc_hsl = _rgb2hsl($__cc_rgb)
			$__cc_hsb = _rgb2hsb($__cc_rgb)
		Case 2
			$__cc_rgb = _hsl2rgb($__cc_hsl)
			$__cc_hsb = _rgb2hsb($__cc_rgb)
		Case 3
			$__cc_rgb = _hsb2rgb($__cc_hsb)
			$__cc_hsl = _rgb2hsl($__cc_rgb)
	EndSwitch
	If $fpalette Then
		$hbitmap = _winapi_createbitmap(8, 249, 1, 32)
		$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
		_winapi_deleteobject($hbitmap)
		$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
		$hbrush = _gdiplus_brushcreatesolid(BitOR(-16777216, cc_switchcolor(_winapi_getsyscolor($color_3dface))))
		_gdiplus_graphicsfillrect($hgraphics, 0, 0, 8, 249, $hbrush)
		_gdiplus_brushdispose($hbrush)
		_gdiplus_graphicsdrawimagerect($hgraphics, $ccdata[8], 0, Round((359 - $__cc_hsb[0]) / 359 * 240), 8, 9)
		_gdiplus_graphicsdispose($hgraphics)
		$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
		cc_setbitmap($ccdata[2], $hbitmap)
		__gdiplus_imagerotateflip($himage, 4)
		$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
		_gdiplus_imagedispose($himage)
		cc_setbitmap($ccdata[3], $hbitmap)
	EndIf
	$hsb = $__cc_hsb
	$hsb[1] = 100
	$hsb[2] = 100
	$rgb = _hsb2rgb($hsb)
	$hbitmap = _winapi_createbitmap(241, 241, 1, 32)
	$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
	_winapi_deleteobject($hbitmap)
	$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
	$hbrush = __gdiplus_linebrushcreate(0, 0, 241, 0, -1, BitOR(-16777216, cc_rgb($rgb)))
	_gdiplus_graphicsfillrect($hgraphics, 0, 0, 241, 241, $hbrush)
	_gdiplus_brushdispose($hbrush)
	$hbrush = __gdiplus_linebrushcreate(0, 0, 0, 241, 0, -16777216)
	_gdiplus_graphicsfillrect($hgraphics, 0, 0, 241, 241, $hbrush)
	_gdiplus_brushdispose($hbrush)
	$x = Round($__cc_hsb[1] / 100 * 241)
	$y = Round((1 - $__cc_hsb[2] / 100) * 241)
	If cc_isdark(cc_rgb($__cc_rgb)) Then
		$argb = -1
	Else
		$argb = -16777216
	EndIf
	$hpen = _gdiplus_pencreate($argb, 2)
	_gdiplus_graphicsdrawline($hgraphics, $x - 7, $y, $x - 3, $y, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $x + 3, $y, $x + 7, $y, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $x, $y - 7, $x, $y - 3, $hpen)
	_gdiplus_graphicsdrawline($hgraphics, $x, $y + 3, $x, $y + 7, $hpen)
	_gdiplus_pendispose($hpen)
	_gdiplus_graphicsdispose($hgraphics)
	$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
	_gdiplus_imagedispose($himage)
	cc_setbitmap($ccdata[1], $hbitmap)
	If $ccdata[5] Then
		$hbitmap = _winapi_createbitmap(123, 57, 1, 32)
		$himage = _gdiplus_bitmapcreatefromhbitmap($hbitmap)
		_winapi_deleteobject($hbitmap)
		$hgraphics = _gdiplus_imagegetgraphicscontext($himage)
		$hbrush = _gdiplus_brushcreatesolid(BitOR(-16777216, cc_rgb($__cc_rgb)))
		_gdiplus_graphicsfillrect($hgraphics, 0, 0, 123, 57, $hbrush)
		_gdiplus_brushdispose($hbrush)
		_gdiplus_graphicsdispose($hgraphics)
		$hbitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($himage)
		_gdiplus_imagedispose($himage)
		cc_setbitmap($ccdata[5], $hbitmap)
	EndIf
	$ccdata[22] = 1
	If ($iindex <> 1) OR (NOT $fskip) Then
		For $i = 10 To 12
			GUICtrlSetData($ccdata[$i], $__cc_rgb[$i - 10])
		Next
	EndIf
	If ($iindex <> 2) OR (NOT $fskip) Then
		For $i = 13 To 15
			GUICtrlSetData($ccdata[$i], $__cc_hsl[$i - 13])
		Next
	EndIf
	If ($iindex <> 3) OR (NOT $fskip) Then
		For $i = 16 To 18
			GUICtrlSetData($ccdata[$i], $__cc_hsb[$i - 16])
		Next
	EndIf
	If ($iindex <> 4) OR (NOT $fskip) Then
		GUICtrlSetData($ccdata[19], Hex(cc_rgb($__cc_rgb), 6))
	EndIf
	$ccdata[22] = 0
	If NOT $fskip Then
		GUICtrlSetState($ccdata[23], $gui_focus)
	EndIf
EndFunc

Func cc_validatecolor($icolor, $itype)
	For $i = 0 To 2
		$__cc_rgb[$i] = 0
		$__cc_hsl[$i] = 0
		$__cc_hsb[$i] = 0
	Next
	$__cc_hsl[0] = 160
	Switch $itype
		Case 0
			$__cc_rgb = cc_splitcolor($icolor)
			$ccdata[20] = 1
		Case 1
			If (UBound($icolor) = 3) AND (NOT UBound($icolor, 2)) Then
				For $i = 0 To 2
					$__cc_hsl[$i] = Round($icolor[$i])
					If ($__cc_hsl[$i] < 0) OR ($__cc_hsl[$i] > 240) Then
						$__cc_hsl = $__cc_rgb
						ExitLoop
					EndIf
				Next
				If NOT $__cc_hsl[1] Then
					$__cc_hsl[0] = 160
				EndIf
			EndIf
			$ccdata[20] = 2
		Case 2
			If (UBound($icolor) = 3) AND (NOT UBound($icolor, 2)) Then
				$__cc_hsb[0] = Round($icolor[0])
				If Abs($__cc_hsb[0]) >= 360 Then
					$__cc_hsb[0] = Mod($__cc_hsb[0], 360)
				EndIf
				If $__cc_hsb[0] < 0 Then
					$__cc_hsb[0] += 360
				EndIf
				For $i = 1 To 2
					$__cc_hsb[$i] = Round($icolor[$i])
					If ($__cc_hsb[$i] < 0) OR ($__cc_hsb[$i] > 100) Then
						$__cc_hsb = $__cc_rgb
						ExitLoop
					EndIf
				Next
			EndIf
			$ccdata[20] = 3
		Case Else
			$ccdata[20] = 1
	EndSwitch
EndFunc

#EndRegion Internal Functions
#Region Color Convertion Functions

Func _hsl2rgb($ahsl)
	If NOT $ahsl[1] Then
		$ahsl[0] = 160
	EndIf
	Local $ret = DllCall("shlwapi.dll", "dword", "ColorHLSToRGB", "dword", $ahsl[0], "dword", $ahsl[2], "dword", $ahsl[1])
	Local $rgb[3] = [0, 0, 0]
	If IsArray($ret) Then
		$rgb = cc_splitcolor(cc_switchcolor($ret[0]))
	EndIf
	Return $rgb
EndFunc

Func _hsb2rgb($ahsb)
	Local $rgb[3], $h, $l, $f, $p, $q, $t
	For $i = 1 To 2
		$ahsb[$i] /= 100
	Next
	If $ahsb[1] = 0 Then
		For $i = 0 To 2
			$rgb[$i] = $ahsb[2]
		Next
	Else
		$h = $ahsb[0] / 60
		$l = Floor($h)
		$f = $h - $l
		$p = $ahsb[2] * (1 - $ahsb[1])
		$q = $ahsb[2] * (1 - $ahsb[1] * $f)
		$t = $ahsb[2] * (1 - $ahsb[1] * (1 - $f))
		Switch $l
			Case 1
				$rgb[0] = $q
				$rgb[1] = $ahsb[2]
				$rgb[2] = $p
			Case 2
				$rgb[0] = $p
				$rgb[1] = $ahsb[2]
				$rgb[2] = $t
			Case 3
				$rgb[0] = $p
				$rgb[1] = $q
				$rgb[2] = $ahsb[2]
			Case 4
				$rgb[0] = $t
				$rgb[1] = $p
				$rgb[2] = $ahsb[2]
			Case 5
				$rgb[0] = $ahsb[2]
				$rgb[1] = $p
				$rgb[2] = $q
			Case Else
				$rgb[0] = $ahsb[2]
				$rgb[1] = $t
				$rgb[2] = $p
		EndSwitch
	EndIf
	For $i = 0 To 2
		$rgb[$i] = Round($rgb[$i] * 255)
	Next
	Return $rgb
EndFunc

Func _rgb2hsl($argb)
	Local $ret = DllCall("shlwapi.dll", "none", "ColorRGBToHLS", "dword", cc_switchcolor(cc_rgb($argb)), "dword*", 0, "dword*", 0, "dword*", 0)
	Local $hsl[3] = [160, 0, 0]
	If IsArray($ret) Then
		$hsl[0] = $ret[2]
		$hsl[1] = $ret[4]
		$hsl[2] = $ret[3]
	EndIf
	Return $hsl
EndFunc

Func _rgb2hsb($argb)
	Local $min = 255, $max = 0
	Local $hsb[3], $d, $h
	For $i = 0 To 2
		If $argb[$i] > $max Then
			$max = $argb[$i]
		EndIf
		If $argb[$i] < $min Then
			$min = $argb[$i]
		EndIf
	Next
	If $min = $max Then
		$hsb[0] = 0
		$hsb[1] = 0
		$hsb[2] = $max / 255
	Else
		If $argb[0] = $min Then
			$d = $argb[1] - $argb[2]
			$h = 3
		Else
			If $argb[1] = $min Then
				$d = $argb[2] - $argb[0]
				$h = 5
			Else
				$d = $argb[0] - $argb[1]
				$h = 1
			EndIf
		EndIf
		$hsb[0] = ($h - ($d / ($max - $min))) / 6
		$hsb[1] = ($max - $min) / $max
		$hsb[2] = $max / 255
	EndIf
	$hsb[0] = Round($hsb[0] * 360)
	If $hsb[0] = 360 Then
		$hsb[0] = 0
	EndIf
	For $i = 1 To 2
		$hsb[$i] = Round($hsb[$i] * 100)
	Next
	Return $hsb
EndFunc

#EndRegion Color Convertion Functions
#Region GDI+ Functions

Func __gdiplus_bitmapcreatefromstream($hstream)
	Local $aresult = DllCall($ghgdipdll, "uint", "GdipCreateBitmapFromStream", "ptr", $hstream, "int*", 0)
	If @error Then
		Return SetError(@error, @extended, 0)
	EndIf
	Return $aresult[2]
EndFunc

Func __gdiplus_bitmapgetpixel($hbitmap, $ix, $iy)
	Local $aresult = DllCall($ghgdipdll, "uint", "GdipBitmapGetPixel", "hwnd", $hbitmap, "int", $ix, "int", $iy, "uint*", 0)
	If @error Then
		Return SetError(@error, @extended, 0)
	EndIf
	Return $aresult[4]
EndFunc

Func __gdiplus_imagerotateflip($himage, $irotateflip)
	Local $aresult = DllCall($ghgdipdll, "uint", "GdipImageRotateFlip", "hwnd", $himage, "int", $irotateflip)
	If @error Then
		Return SetError(@error, @extended, False)
	EndIf
	Return $aresult[0] = 0
EndFunc

Func __gdiplus_linebrushcreate($nx1, $ny1, $nx2, $ny2, $iargb1, $iargb2, $iwrap = 0)
	Local $tpoint1 = DllStructCreate("float;float")
	Local $tpoint2 = DllStructCreate("float;float")
	DllStructSetData($tpoint1, 1, $nx1)
	DllStructSetData($tpoint1, 2, $ny1)
	DllStructSetData($tpoint2, 1, $nx2)
	DllStructSetData($tpoint2, 2, $ny2)
	Local $aresult = DllCall($ghgdipdll, "uint", "GdipCreateLineBrush", "ptr", DllStructGetPtr($tpoint1), "ptr", DllStructGetPtr($tpoint2), "uint", $iargb1, "uint", $iargb2, "int", $iwrap, "int*", 0)
	If @error Then
		Return SetError(@error, @extended, 0)
	EndIf
	Return $aresult[6]
EndFunc

Func __gdiplus_linebrushsettransform($hbrush, $hmatrix)
	Local $aresult = DllCall($ghgdipdll, "uint", "GdipSetLineTransform", "hwnd", $hbrush, "hwnd", $hmatrix)
	If @error Then
		Return SetError(@error, @extended, False)
	EndIf
	Return $aresult[0] = 0
EndFunc

#EndRegion GDI+ Functions
#Region Internal Image Functions

Func _image_arrow()
	Local $barrow = "0x89504E470D0A1A0A0000000D49484452000000080000000908060000000F536D" & "2E000000097048597300000B1300000B1301009A9C180000000467414D410000" & "B18E7CFB5193000000206348524D00007A25000080830000F9FF000080E90000" & "75300000EA6000003A980000176F925FC546000000474944415478DA8490410A" & "C0300804C77C7CDD97DB4B0A364DDA010FB283C2465561BB98480A3A99599DB9" & "73CF6041D2E3E24B58A5ADD0A5A3601B4931BEC2ED8B1E02C45F0FD70083FA3C" & "F26952F43C0000000049454E44AE426082"
	Return cc_loadimagefrommem($barrow)
EndFunc

Func _image_picker()
	Local $bpicker = "0x89504E470D0A1A0A0000000D4948445200000013000000130806000000725036" & "CC000000097048597300000B1300000B1301009A9C180000000467414D410000" & "B18E7CFB5193000000206348524D00007A25000080830000F9FF000080E90000" & "75300000EA6000003A980000176F925FC5460000028C4944415478DAAC943F4F" & "DB4018C67F8E53207692A24AC05586A0B46AAAB62A95BA77AED8D3853F22A253" & "D70A3E010B9E2BBE40D86040480858C2D02EA81EBA958E20085872D421C47F62" & "70AECB11514429489CF4CAF6DDBD3F3FEFFBE84E9352725F23C53D8EB4A66977" & "4FD2F5DE9142210238383878F27870F000907756A6EB7A66A450886CDB06E88C" & "8E8E3A4992F402A95BC12C21B462B1288177854221B06D1BC771181E1E6E03A6" & "AEEB7DC083D46D408F06063AB66D532A95BE5E80767777393A3ACA343CEF3DD0" & "0BE8FAFF403D994C67616101C77188A288B5B5359ACD66727878D8764F4E3EF5" & "E7F33F811868DF08CB67B3DA97A5A55F737373E566B3C9FEFE3E8661100441EA" & "E4F8F8737F3EFF0D88801068DF68E5C6C6C607CFF356E238667171B13B6F9A26" & "BEEF1387E133A0A522FA67CF363737CB9EE7AD542A15E238667C7CBCBBA6691A" & "7118BE52E545EA995C0BDBDEDE2E371A8DD54AA582EFFBECEDED51AD5689C3F0" & "2DC06FCF7B039C5D8AA4EEBA327D15B4B5B555765D77756666862008D8D9D961" & "79799987D9EC1820E3307C099CAB3E45EABD0390BE0AF23CAF0BAAD56A4C4D4D" & "9137CD319514036DA5A6ADE2FCDA1E55AB5529A594AD564BAEAFAFCB5C2E272D" & "215E5B42BCB08418B58418B084C80332679AD95C36DB6309D135310D303F3F6F" & "341A8DD5E9E9E96E6993939317A59D0381722C54EA6805419FA669F2B4D58AFF" & "BA353ECECE96007CDFA756AB313131711D28A8BBAE5F77DD330029A5D7E9745A" & "8001E800694B08EDBBE3FC2897CB0C0D0D015C0B02E2B4AEF79D2749166800CF" & "95CA8CDA9B68961029A0E73408C29C613C55E74CAA92BA20A05377DD945AF781" & "E2A59FB581E4C24D2D67180380A9EC3E531BC34B2009246ADE548A42F50DC09F" & "010041B73CFDB70CCD6E0000000049454E44AE426082"
	Return cc_loadimagefrommem($bpicker)
EndFunc

#EndRegion Internal Image Functions
#Region Windows Message Functions

Func cc_wm_command($hwnd, $imsg, $wparam, $lparam)
	If (IsDeclared("__CP_WM0111")) AND (NOT Eval("__CP_WM0111")) Then
		$__cc_wm0111 = 1
		Call("CP" & "_WM_COMMAND", $hwnd, $imsg, $wparam, $lparam)
		$__cc_wm0111 = 0
	EndIf
	If (NOT $ccdata[0]) OR ($ccdata[22]) Then
		Return $gui_rundefmsg
	EndIf
	Local $id = BitAND($wparam, 65535)
	Switch $hwnd
		Case $ccdata[0]
			Local $val, $data = GUICtrlRead($id)
			Switch BitShift($wparam, 16)
				Case 1
					GUICtrlSendToDummy($ccdata[27], $id)
				Case $en_change
					Switch $id
						Case $ccdata[19]
							$val = StringRegExpReplace($data, "[^[:xdigit:]]", "")
						Case Else
							$val = StringRegExpReplace($data, "[^0-9]", "")
					EndSwitch
					If $data <> $val Then
						GUICtrlSetData($id, $val)
						cc_beep()
					EndIf
					Switch $id
						Case $ccdata[19]
							$val = Number("0x" & $val)
						Case Else
							$val = Number($val)
					EndSwitch
					Switch $id
						Case $ccdata[10]
							If $val > 255 Then
								$val = 255
							EndIf
							If $val <> $__cc_rgb[0] Then
								$__cc_rgb[0] = $val
								GUICtrlSendToDummy($ccdata[24], 1)
							EndIf
						Case $ccdata[11]
							If $val > 255 Then
								$val = 255
							EndIf
							If $val <> $__cc_rgb[1] Then
								$__cc_rgb[1] = $val
								GUICtrlSendToDummy($ccdata[24], 1)
							EndIf
						Case $ccdata[12]
							If $val > 255 Then
								$val = 255
							EndIf
							If $val <> $__cc_rgb[2] Then
								$__cc_rgb[2] = $val
								GUICtrlSendToDummy($ccdata[24], 1)
							EndIf
						Case $ccdata[13]
							If $val > 240 Then
								$val = 240
							EndIf
							If $val <> $__cc_hsl[0] Then
								$__cc_hsl[0] = $val
								GUICtrlSendToDummy($ccdata[24], 2)
							EndIf
						Case $ccdata[14]
							If $val > 240 Then
								$val = 240
							EndIf
							If $val <> $__cc_hsl[1] Then
								$__cc_hsl[1] = $val
								GUICtrlSendToDummy($ccdata[24], 2)
							EndIf
						Case $ccdata[15]
							If $val > 240 Then
								$val = 240
							EndIf
							If $val <> $__cc_hsl[2] Then
								$__cc_hsl[2] = $val
								GUICtrlSendToDummy($ccdata[24], 2)
							EndIf
						Case $ccdata[16]
							If $val >= 360 Then
								$val = Mod($val, 360)
							EndIf
							If $val <> $__cc_hsb[0] Then
								$__cc_hsb[0] = $val
								GUICtrlSendToDummy($ccdata[24], 3)
							EndIf
						Case $ccdata[17]
							If $val > 100 Then
								$val = 100
							EndIf
							If $val <> $__cc_hsb[1] Then
								$__cc_hsb[1] = $val
								GUICtrlSendToDummy($ccdata[24], 3)
							EndIf
						Case $ccdata[18]
							If $val > 100 Then
								$val = 100
							EndIf
							If $val <> $__cc_hsb[2] Then
								$__cc_hsb[2] = $val
								GUICtrlSendToDummy($ccdata[24], 3)
							EndIf
						Case $ccdata[19]
							If $val <> cc_rgb($__cc_rgb) Then
								$__cc_rgb = cc_splitcolor($val)
								GUICtrlSendToDummy($ccdata[24], 4)
							EndIf
					EndSwitch
				Case $en_killfocus
					Switch $id
						Case $ccdata[10]
							GUICtrlSetData($id, $__cc_rgb[0])
						Case $ccdata[11]
							GUICtrlSetData($id, $__cc_rgb[1])
						Case $ccdata[12]
							GUICtrlSetData($id, $__cc_rgb[2])
						Case $ccdata[13]
							If NOT $__cc_hsl[1] Then
								$__cc_hsl[0] = 160
							EndIf
							GUICtrlSetData($id, $__cc_hsl[0])
						Case $ccdata[14]
							If NOT $__cc_hsl[1] Then
								$__cc_hsl[0] = 160
								GUICtrlSetData($ccdata[13], $__cc_hsl[0])
							EndIf
							GUICtrlSetData($id, $__cc_hsl[1])
						Case $ccdata[15]
							GUICtrlSetData($id, $__cc_hsl[2])
						Case $ccdata[16]
							GUICtrlSetData($id, $__cc_hsb[0])
						Case $ccdata[17]
							GUICtrlSetData($id, $__cc_hsb[1])
						Case $ccdata[18]
							GUICtrlSetData($id, $__cc_hsb[2])
						Case $ccdata[19]
							GUICtrlSetData($id, Hex(cc_rgb($__cc_rgb), 6))
					EndSwitch
			EndSwitch
	EndSwitch
	Return $gui_rundefmsg
EndFunc

Func cc_wm_ncrbuttondown($hwnd, $imsg, $wparam, $lparam)
	If NOT $ccdata[0] Then
		Return $gui_rundefmsg
	EndIf
	Switch $hwnd
		Case $ccdata[0]
			Switch $wparam
				Case 8, 9, 20, 21
					Return 0
			EndSwitch
	EndSwitch
	Return $gui_rundefmsg
EndFunc

Func cc_wm_setcursor($hwnd, $imsg, $wparam, $lparam)
	Local $result
	If (IsDeclared("__CP_WM0020")) AND (NOT Eval("__CP_WM0020")) Then
		$__cc_wm0020 = 1
		$result = Call("CP" & "_WM_SETCURSOR", $hwnd, $imsg, $wparam, $lparam)
		$__cc_wm0020 = 0
		If NOT $result Then
			Return 0
		EndIf
	EndIf
	If NOT $ccdata[0] Then
		Return $gui_rundefmsg
	EndIf
	Switch $hwnd
		Case $ccdata[0]
			If $ccdata[9] Then
				Local $cursor = GUIGetCursorInfo($ccdata[0])
				If (NOT @error) AND ($cursor[4] = $ccdata[1]) Then
					_winapi_setcursor($ccdata[9])
					Return 0
				EndIf
			EndIf
	EndSwitch
	Return $gui_rundefmsg
EndFunc

Func cc_wm_syscommand($hwnd, $imsg, $wparam, $lparam)
	If NOT $ccdata[0] Then
		Return $gui_rundefmsg
	EndIf
	Switch $hwnd
		Case $ccdata[0]
			Switch $wparam
				Case 61696
					Return 0
			EndSwitch
	EndSwitch
	Return $gui_rundefmsg
EndFunc

#EndRegion Windows Message Functions

Func setup_gui()
	Local $frm_settings_width = 600
	Local $frm_settings_height = 110
	$frm_radar = GUICreate("Reader", $width, $height, $radar_x, $radar_y, $ws_border, $ws_ex_layered + $ws_ex_topmost + $ws_ex_transparent)
	$frm_settings = GUICreate("Settings", $frm_settings_width, $frm_settings_height, $settings_x, $settings_y)
	build_config_gui()
	setup_gdi()
	GUISetOnEvent($gui_event_close, "GUI_Exit", $frm_settings)
	GUISetState(@SW_SHOW, $frm_radar)
	GUISetState(@SW_SHOW, $frm_settings)
	WinSetOnTop($frm_radar, "", 1)
EndFunc

Func build_config_gui()
	Local $btn_config_players
	Local $btn_config_npcs
	Local $btn_config_gather
	Local $btn_config_self
	Local $btn_config_radar
	Local $btn_gui_move_resize
	$btn_config_players = GUICtrlCreateButton("Players", 75, 10, 100, 25)
	$btn_config_npcs = GUICtrlCreateButton("NPCs", 250, 10, 100, 25)
	$btn_config_gather = GUICtrlCreateButton("Gathers", 425, 10, 100, 25)
	$btn_config_self = GUICtrlCreateButton("You", 75, 45, 100, 25)
	$btn_config_radar = GUICtrlCreateButton("Radar config", 250, 45, 100, 25)
	$btn_gui_move_resize = GUICtrlCreateButton("Move/Resize", 425, 45, 100, 25)
	GUICtrlSetOnEvent($btn_config_players, "GUI_Config_Players")
	GUICtrlSetOnEvent($btn_config_npcs, "GUI_Config_NPCs")
	GUICtrlSetOnEvent($btn_config_gather, "GUI_Config_Gathers")
	GUICtrlSetOnEvent($btn_config_self, "GUI_Config_Self")
	GUICtrlSetOnEvent($btn_config_radar, "GUI_Config_Radar")
	GUICtrlSetOnEvent($btn_gui_move_resize, "GUI_Move_Resize")
EndFunc

Func gui_config_players()
	Local $grp_group1
	Local $chk_showonmap1
	Local $btn_iconsize_minus1
	Local $btn_iconsize_plus1
	Local $chk_showlabels1
	Local $btn_stringsize_minus1
	Local $btn_stringsize_plus1
	Local $grp_group2
	Local $chk_showonmap2
	Local $btn_iconsize_minus2
	Local $btn_iconsize_plus2
	Local $chk_showlabels2
	Local $btn_stringsize_minus2
	Local $btn_stringsize_plus2
	Local $btn_close
	$frm_config = GUICreate("Config", 400, 270)
	$grp_group1 = GUICtrlCreateGroup("Friendly", 10, 10, 180, 215)
	$chk_showonmap1 = GUICtrlCreateCheckbox("Show on Radar", 25, 35, 100, 20)
	If $showuser_friendly Then GUICtrlSetState($chk_showonmap1, $gui_checked)
	If NOT $showuser_friendly Then GUICtrlSetState($chk_showonmap1, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 35, 65, 100, 20)
	GUICtrlCreateLabel("Size", 35, 95, 30, 20)
	$btn_iconsize_minus1 = GUICtrlCreateButton("-", 70, 90, 20, 20)
	$btn_iconsize_plus1 = GUICtrlCreateButton("+", 100, 90, 20, 20)
	$chk_showlabels1 = GUICtrlCreateCheckbox("Show Labels", 25, 125, 100, 20)
	If $userlabels_friendly Then GUICtrlSetState($chk_showlabels1, $gui_checked)
	If NOT $userlabels_friendly Then GUICtrlSetState($chk_showlabels1, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 35, 155, 100, 20)
	GUICtrlCreateLabel("Size", 35, 185, 30, 20)
	$btn_stringsize_minus1 = GUICtrlCreateButton("-", 70, 185, 20, 20)
	$btn_stringsize_plus1 = GUICtrlCreateButton("+", 100, 185, 20, 20)
	$grp_group2 = GUICtrlCreateGroup("Enemy", 210, 10, 180, 215)
	$chk_showonmap2 = GUICtrlCreateCheckbox("Show on Radar", 225, 35, 100, 20)
	If $showuser_enemy Then GUICtrlSetState($chk_showonmap2, $gui_checked)
	If NOT $showuser_enemy Then GUICtrlSetState($chk_showonmap2, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 235, 65, 100, 20)
	GUICtrlCreateLabel("Size", 235, 95, 30, 20)
	$btn_iconsize_minus2 = GUICtrlCreateButton("-", 270, 90, 20, 20)
	$btn_iconsize_plus2 = GUICtrlCreateButton("+", 300, 90, 20, 20)
	$chk_showlabels2 = GUICtrlCreateCheckbox("Show Labels", 225, 125, 100, 20)
	If $userlabels_enemy Then GUICtrlSetState($chk_showlabels2, $gui_checked)
	If NOT $userlabels_enemy Then GUICtrlSetState($chk_showlabels2, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 235, 155, 100, 20)
	GUICtrlCreateLabel("Size", 235, 185, 30, 20)
	$btn_stringsize_minus2 = GUICtrlCreateButton("-", 270, 185, 20, 20)
	$btn_stringsize_plus2 = GUICtrlCreateButton("+", 300, 185, 20, 20)
	$btn_close = GUICtrlCreateButton("Close", 180, 235, 50, 25)
	GUICtrlSetOnEvent($chk_showonmap1, "Switch_ShowUser_Friendly")
	GUICtrlSetOnEvent($btn_iconsize_minus1, "Icon_Size_Minus_UserFriendly")
	GUICtrlSetOnEvent($btn_iconsize_plus1, "Icon_Size_Plus_UserFriendly")
	GUICtrlSetOnEvent($chk_showonmap2, "Switch_ShowUser_Enemy")
	GUICtrlSetOnEvent($btn_iconsize_minus2, "Icon_Size_Minus_UserEnemy")
	GUICtrlSetOnEvent($btn_iconsize_plus2, "Icon_Size_Plus_UserEnemy")
	GUICtrlSetOnEvent($chk_showlabels1, "Switch_UserLabels_Friendly")
	GUICtrlSetOnEvent($btn_stringsize_minus1, "String_Size_Minus_UserFriendly")
	GUICtrlSetOnEvent($btn_stringsize_plus1, "String_Size_Plus_UserFriendly")
	GUICtrlSetOnEvent($chk_showlabels2, "Switch_UserLabels_Enemy")
	GUICtrlSetOnEvent($btn_stringsize_minus2, "String_Size_Minus_UserEnemy")
	GUICtrlSetOnEvent($btn_stringsize_plus2, "String_Size_Plus_UserEnemy")
	GUISetOnEvent($gui_event_close, "Close_Config", $frm_config)
	GUICtrlSetOnEvent($btn_close, "Close_Config")
	GUISetState(@SW_SHOW, $frm_config)
EndFunc

Func gui_config_npcs()
	Local $grp_group1
	Local $chk_showonmap1
	Local $btn_iconsize_minus1
	Local $btn_iconsize_plus1
	Local $chk_showlabels1
	Local $btn_stringsize_minus1
	Local $btn_stringsize_plus1
	Local $grp_group2
	Local $chk_showonmap2
	Local $btn_iconsize_minus2
	Local $btn_iconsize_plus2
	Local $chk_showlabels2
	Local $btn_stringsize_minus2
	Local $btn_stringsize_plus2
	Local $grp_group3
	Local $chk_showonmap3
	Local $btn_iconsize_minus3
	Local $btn_iconsize_plus3
	Local $chk_showlabels3
	Local $btn_stringsize_minus3
	Local $btn_stringsize_plus3
	Local $btn_close
	$frm_config = GUICreate("Config", 600, 270)
	$grp_group1 = GUICtrlCreateGroup("Friendly", 10, 10, 180, 215)
	$chk_showonmap1 = GUICtrlCreateCheckbox("Show on Radar", 25, 35, 100, 20)
	If $shownpc_friendly Then GUICtrlSetState($chk_showonmap1, $gui_checked)
	If NOT $shownpc_friendly Then GUICtrlSetState($chk_showonmap1, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 35, 65, 100, 20)
	GUICtrlCreateLabel("Size", 35, 95, 30, 20)
	$btn_iconsize_minus1 = GUICtrlCreateButton("-", 70, 90, 20, 20)
	$btn_iconsize_plus1 = GUICtrlCreateButton("+", 100, 90, 20, 20)
	$chk_showlabels1 = GUICtrlCreateCheckbox("Show Labels", 25, 125, 100, 20)
	If $npclabels_friendly Then GUICtrlSetState($chk_showlabels1, $gui_checked)
	If NOT $npclabels_friendly Then GUICtrlSetState($chk_showlabels1, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 35, 155, 100, 20)
	GUICtrlCreateLabel("Size", 35, 185, 30, 20)
	$btn_stringsize_minus1 = GUICtrlCreateButton("-", 70, 185, 20, 20)
	$btn_stringsize_plus1 = GUICtrlCreateButton("+", 100, 185, 20, 20)
	$grp_group2 = GUICtrlCreateGroup("Neutral", 210, 10, 180, 215)
	$chk_showonmap2 = GUICtrlCreateCheckbox("Show on Radar", 225, 35, 100, 20)
	If $shownpc_neutral Then GUICtrlSetState($chk_showonmap2, $gui_checked)
	If NOT $shownpc_neutral Then GUICtrlSetState($chk_showonmap2, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 235, 65, 100, 20)
	GUICtrlCreateLabel("Size", 235, 95, 30, 20)
	$btn_iconsize_minus2 = GUICtrlCreateButton("-", 270, 90, 20, 20)
	$btn_iconsize_plus2 = GUICtrlCreateButton("+", 300, 90, 20, 20)
	$chk_showlabels2 = GUICtrlCreateCheckbox("Show Labels", 225, 125, 100, 20)
	If $npclabels_neutral Then GUICtrlSetState($chk_showlabels2, $gui_checked)
	If NOT $npclabels_neutral Then GUICtrlSetState($chk_showlabels2, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 235, 155, 100, 20)
	GUICtrlCreateLabel("Size", 235, 185, 30, 20)
	$btn_stringsize_minus2 = GUICtrlCreateButton("-", 270, 185, 20, 20)
	$btn_stringsize_plus2 = GUICtrlCreateButton("+", 300, 185, 20, 20)
	$grp_group3 = GUICtrlCreateGroup("Aggresive", 410, 10, 180, 215)
	$chk_showonmap3 = GUICtrlCreateCheckbox("Show on Radar", 425, 35, 100, 20)
	If $shownpc_aggresive Then GUICtrlSetState($chk_showonmap3, $gui_checked)
	If NOT $shownpc_aggresive Then GUICtrlSetState($chk_showonmap3, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 435, 65, 100, 20)
	GUICtrlCreateLabel("Size", 435, 95, 30, 20)
	$btn_iconsize_minus3 = GUICtrlCreateButton("-", 470, 90, 20, 20)
	$btn_iconsize_plus3 = GUICtrlCreateButton("+", 500, 90, 20, 20)
	$chk_showlabels3 = GUICtrlCreateCheckbox("Show Labels", 425, 125, 100, 20)
	If $npclabels_aggresive Then GUICtrlSetState($chk_showlabels3, $gui_checked)
	If NOT $npclabels_aggresive Then GUICtrlSetState($chk_showlabels3, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 435, 155, 100, 20)
	GUICtrlCreateLabel("Size", 435, 185, 30, 20)
	$btn_stringsize_minus3 = GUICtrlCreateButton("-", 470, 185, 20, 20)
	$btn_stringsize_plus3 = GUICtrlCreateButton("+", 500, 185, 20, 20)
	$btn_close = GUICtrlCreateButton("Close", 285, 235, 50, 25)
	GUICtrlSetOnEvent($chk_showonmap1, "Switch_ShowNPC_Friendly")
	GUICtrlSetOnEvent($btn_iconsize_minus1, "Icon_Size_Minus_NPCFriendly")
	GUICtrlSetOnEvent($btn_iconsize_plus1, "Icon_Size_Plus_NPCFriendly")
	GUICtrlSetOnEvent($chk_showonmap2, "Switch_ShowNPC_Neutral")
	GUICtrlSetOnEvent($btn_iconsize_minus2, "Icon_Size_Minus_NPCNeutral")
	GUICtrlSetOnEvent($btn_iconsize_plus2, "Icon_Size_Plus_NPCNeutral")
	GUICtrlSetOnEvent($chk_showonmap3, "Switch_ShowNPC_Aggresive")
	GUICtrlSetOnEvent($btn_iconsize_minus3, "Icon_Size_Minus_NPCAggresive")
	GUICtrlSetOnEvent($btn_iconsize_plus3, "Icon_Size_Plus_NPCAggresive")
	GUICtrlSetOnEvent($chk_showlabels1, "Switch_NPCLabels_Friendly")
	GUICtrlSetOnEvent($btn_stringsize_minus1, "String_Size_Minus_NPCFriendly")
	GUICtrlSetOnEvent($btn_stringsize_plus1, "String_Size_Plus_NPCFriendly")
	GUICtrlSetOnEvent($chk_showlabels2, "Switch_NPCLabels_Neutral")
	GUICtrlSetOnEvent($btn_stringsize_minus2, "String_Size_Minus_NPCNeutral")
	GUICtrlSetOnEvent($btn_stringsize_plus2, "String_Size_Plus_NPCNeutral")
	GUICtrlSetOnEvent($chk_showlabels3, "Switch_NPCLabels_Aggresive")
	GUICtrlSetOnEvent($btn_stringsize_minus3, "String_Size_Minus_NPCAggresive")
	GUICtrlSetOnEvent($btn_stringsize_plus3, "String_Size_Plus_NPCAggresive")
	GUISetOnEvent($gui_event_close, "Close_Config", $frm_config)
	GUICtrlSetOnEvent($btn_close, "Close_Config")
	GUISetState(@SW_SHOW, $frm_config)
EndFunc

Func gui_config_gathers()
	Local $grp_group1
	Local $chk_showonmap1
	Local $btn_iconsize_minus1
	Local $btn_iconsize_plus1
	Local $chk_showlabels1
	Local $btn_stringsize_minus1
	Local $btn_stringsize_plus1
	Local $btn_close
	$frm_config = GUICreate("Config", 200, 270)
	$grp_group1 = GUICtrlCreateGroup("Gather Nodes", 10, 10, 180, 215)
	$chk_showonmap1 = GUICtrlCreateCheckbox("Show on Radar", 25, 35, 100, 20)
	If $showgather Then GUICtrlSetState($chk_showonmap1, $gui_checked)
	If NOT $showgather Then GUICtrlSetState($chk_showonmap1, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 35, 65, 100, 20)
	GUICtrlCreateLabel("Size", 35, 95, 30, 20)
	$btn_iconsize_minus1 = GUICtrlCreateButton("-", 70, 90, 20, 20)
	$btn_iconsize_plus1 = GUICtrlCreateButton("+", 100, 90, 20, 20)
	$chk_showlabels1 = GUICtrlCreateCheckbox("Show Labels", 25, 125, 100, 20)
	If $gatherlabels Then GUICtrlSetState($chk_showlabels1, $gui_checked)
	If NOT $gatherlabels Then GUICtrlSetState($chk_showlabels1, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 35, 155, 100, 20)
	GUICtrlCreateLabel("Size", 35, 185, 30, 20)
	$btn_stringsize_minus1 = GUICtrlCreateButton("-", 70, 185, 20, 20)
	$btn_stringsize_plus1 = GUICtrlCreateButton("+", 100, 185, 20, 20)
	$btn_close = GUICtrlCreateButton("Close", 75, 235, 50, 25)
	GUICtrlSetOnEvent($chk_showonmap1, "Switch_ShowGather")
	GUICtrlSetOnEvent($btn_iconsize_minus1, "Icon_Size_Minus_Gather")
	GUICtrlSetOnEvent($btn_iconsize_plus1, "Icon_Size_Plus_Gather")
	GUICtrlSetOnEvent($chk_showlabels1, "Switch_GatherLabels")
	GUICtrlSetOnEvent($btn_stringsize_minus1, "String_Size_Minus_Gather")
	GUICtrlSetOnEvent($btn_stringsize_plus1, "String_Size_Plus_Gather")
	GUISetOnEvent($gui_event_close, "Close_Config", $frm_config)
	GUICtrlSetOnEvent($btn_close, "Close_Config")
	GUISetState(@SW_SHOW, $frm_config)
EndFunc

Func gui_config_self()
	Local $grp_group1
	Local $chk_showonmap1
	Local $btn_iconsize_minus1
	Local $btn_iconsize_plus1
	Local $chk_showlabels1
	Local $btn_stringsize_minus1
	Local $btn_stringsize_plus1
	Local $chk_showheading
	Local $btn_close
	$frm_config = GUICreate("Config", 200, 315)
	$grp_group1 = GUICtrlCreateGroup("You", 10, 10, 180, 250)
	$chk_showonmap1 = GUICtrlCreateCheckbox("Show on Radar", 25, 35, 100, 20)
	If $showplayer Then GUICtrlSetState($chk_showonmap1, $gui_checked)
	If NOT $showplayer Then GUICtrlSetState($chk_showonmap1, $gui_unchecked)
	GUICtrlCreateLabel("Color - soon", 35, 65, 100, 20)
	GUICtrlCreateLabel("Size", 35, 95, 30, 20)
	$btn_iconsize_minus1 = GUICtrlCreateButton("-", 70, 90, 20, 20)
	$btn_iconsize_plus1 = GUICtrlCreateButton("+", 100, 90, 20, 20)
	$chk_showlabels1 = GUICtrlCreateCheckbox("Show Label", 25, 125, 100, 20)
	If $playerlabel Then GUICtrlSetState($chk_showlabels1, $gui_checked)
	If NOT $playerlabel Then GUICtrlSetState($chk_showlabels1, $gui_unchecked)
	GUICtrlCreateLabel("Font - soon", 35, 155, 100, 20)
	GUICtrlCreateLabel("Size", 35, 185, 30, 20)
	$btn_stringsize_minus1 = GUICtrlCreateButton("-", 70, 185, 20, 20)
	$btn_stringsize_plus1 = GUICtrlCreateButton("+", 100, 185, 20, 20)
	$chk_showheading = GUICtrlCreateCheckbox("Draw Heading arrow", 25, 220, 150, 20)
	If $draw_player_heading Then GUICtrlSetState($chk_showheading, $gui_checked)
	If NOT $draw_player_heading Then GUICtrlSetState($chk_showheading, $gui_unchecked)
	$btn_close = GUICtrlCreateButton("Close", 75, 270, 50, 25)
	GUICtrlSetOnEvent($chk_showonmap1, "Switch_ShowSelf")
	GUICtrlSetOnEvent($btn_iconsize_minus1, "Icon_Size_Minus_Self")
	GUICtrlSetOnEvent($btn_iconsize_plus1, "Icon_Size_Plus_Self")
	GUICtrlSetOnEvent($chk_showlabels1, "Switch_SelfLabel")
	GUICtrlSetOnEvent($btn_stringsize_minus1, "String_Size_Minus_Self")
	GUICtrlSetOnEvent($btn_stringsize_plus1, "String_Size_Plus_Self")
	GUICtrlSetOnEvent($chk_showheading, "Switch_Draw_Heading")
	GUISetOnEvent($gui_event_close, "Close_Config", $frm_config)
	GUICtrlSetOnEvent($btn_close, "Close_Config")
	GUISetState(@SW_SHOW, $frm_config)
EndFunc

Func gui_config_radar()
	Local $grp_group1
	Local $chk_enablefilter
	Local $chk_enablepartialfilter
	Local $btn_load
	Local $btn_clear
	Local $btn_close
	$frm_config = GUICreate("Config", 200, 315)
	$grp_group1 = GUICtrlCreateGroup("Radar", 10, 10, 180, 250)
	$chk_enablefilter = GUICtrlCreateCheckbox("Enable Name Filter", 40, 35, 120, 20)
	If $filter_enabled Then GUICtrlSetState($chk_enablefilter, $gui_checked)
	If NOT $filter_enabled Then GUICtrlSetState($chk_enablefilter, $gui_unchecked)
	$chk_enablepartialfilter = GUICtrlCreateCheckbox("Show on partial match", 35, 55, 130, 20)
	If $filter_partial_enabled Then GUICtrlSetState($chk_enablepartialfilter, $gui_checked)
	If NOT $filter_partial_enabled Then GUICtrlSetState($chk_enablepartialfilter, $gui_unchecked)
	$edt_name_0 = GUICtrlCreateEdit($filter_name[0], 30, 85, 140, 20, 128)
	$edt_name_1 = GUICtrlCreateEdit($filter_name[1], 30, 110, 140, 20, 128)
	$edt_name_2 = GUICtrlCreateEdit($filter_name[2], 30, 135, 140, 20, 128)
	$btn_load = GUICtrlCreateButton("Load", 35, 165, 50, 20)
	$btn_clear = GUICtrlCreateButton("Clear", 115, 165, 50, 20)
	$btn_close = GUICtrlCreateButton("Close", 75, 270, 50, 25)
	GUICtrlSetOnEvent($chk_enablefilter, "Switch_Filter_Enabled")
	GUICtrlSetOnEvent($chk_enablepartialfilter, "Switch_Filter_Partial_Enabled")
	GUICtrlSetOnEvent($btn_load, "NameFilter_Load")
	GUICtrlSetOnEvent($btn_clear, "NameFilter_Clear")
	GUISetOnEvent($gui_event_close, "Close_Config", $frm_config)
	GUICtrlSetOnEvent($btn_close, "Close_Config")
	GUISetState(@SW_SHOW, $frm_config)
EndFunc

Func close_config()
	GUIDelete($frm_config)
EndFunc

#Region Switch Enity Icons and Label variables

Func switch_showself()
	$showplayer = NOT $showplayer
EndFunc

Func switch_draw_heading()
	$draw_player_heading = NOT $draw_player_heading
EndFunc

Func switch_showuser_friendly()
	$showuser_friendly = NOT $showuser_friendly
EndFunc

Func switch_showuser_enemy()
	$showuser_enemy = NOT $showuser_enemy
EndFunc

Func switch_shownpc_friendly()
	$shownpc_friendly = NOT $shownpc_friendly
EndFunc

Func switch_shownpc_neutral()
	$shownpc_neutral = NOT $shownpc_neutral
EndFunc

Func switch_shownpc_aggresive()
	$shownpc_aggresive = NOT $shownpc_aggresive
EndFunc

Func switch_showgather()
	$showgather = NOT $showgather
EndFunc

Func switch_selflabel()
	$playerlabel = NOT $playerlabel
EndFunc

Func switch_userlabels_friendly()
	$userlabels_friendly = NOT $userlabels_friendly
EndFunc

Func switch_userlabels_enemy()
	$userlabels_enemy = NOT $userlabels_enemy
EndFunc

Func switch_npclabels_friendly()
	$npclabels_friendly = NOT $npclabels_friendly
EndFunc

Func switch_npclabels_neutral()
	$npclabels_neutral = NOT $npclabels_neutral
EndFunc

Func switch_npclabels_aggresive()
	$npclabels_aggresive = NOT $npclabels_aggresive
EndFunc

Func switch_gatherlabels()
	$gatherlabels = NOT $gatherlabels
EndFunc

Func switch_filter_enabled()
	$filter_enabled = NOT $filter_enabled
EndFunc

Func switch_filter_partial_enabled()
	$filter_partial_enabled = NOT $filter_partial_enabled
EndFunc

#EndRegion
#Region Switch icon size variables

Func icon_size_minus_self()
	$player_icon_size -= 1
	$player_icon_offset = Int($player_icon_size / 2)
EndFunc

Func icon_size_plus_self()
	$player_icon_size += 1
	$player_icon_offset = Int($player_icon_size / 2)
EndFunc

Func icon_size_minus_userfriendly()
	$user_friendly_icon_size -= 1
	$user_friendly_icon_offset = Int($user_friendly_icon_size / 2)
EndFunc

Func icon_size_plus_userfriendly()
	$user_friendly_icon_size += 1
	$user_friendly_icon_offset = Int($user_friendly_icon_size / 2)
EndFunc

Func icon_size_minus_userenemy()
	$user_enemy_icon_size -= 1
	$user_enemy_icon_offset = Int($user_enemy_icon_size / 2)
EndFunc

Func icon_size_plus_userenemy()
	$user_enemy_icon_size += 1
	$user_enemy_icon_offset = Int($user_enemy_icon_size / 2)
EndFunc

Func icon_size_minus_npcfriendly()
	$npc_friendly_icon_size -= 1
	$npc_friendly_icon_offset = Int($npc_friendly_icon_size / 2)
EndFunc

Func icon_size_plus_npcfriendly()
	$npc_friendly_icon_size += 1
	$npc_friendly_icon_offset = Int($npc_friendly_icon_size / 2)
EndFunc

Func icon_size_minus_npcneutral()
	$npc_neutral_icon_size -= 1
	$npc_neutral_icon_offset = Int($npc_neutral_icon_size / 2)
EndFunc

Func icon_size_plus_npcneutral()
	$npc_neutral_icon_size += 1
	$npc_neutral_icon_offset = Int($npc_neutral_icon_size / 2)
EndFunc

Func icon_size_minus_npcaggresive()
	$npc_aggresive_icon_size -= 1
	$npc_aggresive_icon_offset = Int($npc_aggresive_icon_size / 2)
EndFunc

Func icon_size_plus_npcaggresive()
	$npc_aggresive_icon_size += 1
	$npc_aggresive_icon_offset = Int($npc_aggresive_icon_size / 2)
EndFunc

Func icon_size_minus_gather()
	$gather_icon_size -= 1
	$gather_icon_offset = Int($gather_icon_size / 2)
EndFunc

Func icon_size_plus_gather()
	$gather_icon_size += 1
	$gather_icon_offset = Int($gather_icon_size / 2)
EndFunc

#EndRegion
#Region Switch string size variables

Func string_size_minus_self()
	$player_string_size -= 1
EndFunc

Func string_size_plus_self()
	$player_string_size += 1
EndFunc

Func string_size_minus_userfriendly()
	$user_friendly_string_size -= 1
EndFunc

Func string_size_plus_userfriendly()
	$user_friendly_string_size += 1
EndFunc

Func string_size_minus_userenemy()
	$user_enemy_string_size -= 1
EndFunc

Func string_size_plus_userenemy()
	$user_enemy_string_size += 1
EndFunc

Func string_size_minus_npcfriendly()
	$npc_friendly_string_size -= 1
EndFunc

Func string_size_plus_npcfriendly()
	$npc_friendly_string_size += 1
EndFunc

Func string_size_minus_npcneutral()
	$npc_neutral_string_size -= 1
EndFunc

Func string_size_plus_npcneutral()
	$npc_neutral_string_size += 1
EndFunc

Func string_size_minus_npcaggresive()
	$npc_aggresive_string_size -= 1
EndFunc

Func string_size_plus_npcaggresive()
	$npc_aggresive_string_size += 1
EndFunc

Func string_size_minus_gather()
	$gather_string_size -= 1
EndFunc

Func string_size_plus_gather()
	$gather_string_size += 1
EndFunc

#EndRegion

Func namefilter_load()
	$filter_name[0] = GUICtrlRead($edt_name_0)
	$filter_name[1] = GUICtrlRead($edt_name_1)
	$filter_name[2] = GUICtrlRead($edt_name_2)
	For $i = 0 To (UBound($filter_name) - 1)
		If $filter_name[$i] = " " Then $filter_name[$i] = ""
	Next
EndFunc

Func namefilter_clear()
	For $i = 0 To (UBound($filter_name) - 1)
		$filter_name[$i] = ""
	Next
	GUICtrlSetData($edt_name_0, "")
	GUICtrlSetData($edt_name_1, "")
	GUICtrlSetData($edt_name_2, "")
EndFunc

Func gui_move_resize()
	Local $frm_radar_pos = WinGetPos($frm_radar)
	$frm_moveresize = 1
	$frm_moveresize = GUICreate("", $width, $height, $frm_radar_pos[0], $frm_radar_pos[1], $ws_caption, $ws_ex_toolwindow + $ws_ex_appwindow)
	$btn_moveresize_minus = GUICtrlCreateButton("-", ($width / 2) - 35, ($height / 2) - 25, 20, 20)
	$lbl_moveresize_size = GUICtrlCreateLabel("size", ($width / 2) - 15, ($height / 2) - 22, 30, 20, 1)
	$btn_moveresize_plus = GUICtrlCreateButton("+", ($width / 2) + 15, ($height / 2) - 25, 20, 20)
	$btn_moveresize_apply = GUICtrlCreateButton("Apply", ($width / 2) - 100, ($height / 2) + 5, 60, 25)
	$btn_moveresize_defaults = GUICtrlCreateButton("Defaults", ($width / 2) - 30, ($height / 2) + 5, 60, 25)
	$btn_moveresize_close = GUICtrlCreateButton("Close", ($width / 2) + 40, ($height / 2) + 5, 60, 25)
	GUICtrlSetOnEvent($btn_moveresize_minus, "MoveResize_Minus")
	GUICtrlSetOnEvent($btn_moveresize_plus, "MoveResize_Plus")
	GUICtrlSetOnEvent($btn_moveresize_apply, "MoveResize_Apply")
	GUICtrlSetOnEvent($btn_moveresize_close, "MoveResize_Close")
	ControlFocus($frm_moveresize, "", $btn_moveresize_close)
	WinSetTrans($frm_moveresize, "", 208)
	GUISetState(@SW_SHOW, $frm_moveresize)
EndFunc

Func moveresize_minus()
	Local $frm_moveresize_pos = WinGetPos($frm_moveresize)
	Local $new_width = $frm_moveresize_pos[2]
	Local $new_height = $frm_moveresize_pos[3]
	If ($new_height < 400) OR ($new_width < 400) Then Return
	WinMove($frm_moveresize, "", Default, Default, $new_width - 100, $new_height - 100)
	GUICtrlDelete($btn_moveresize_minus)
	GUICtrlDelete($lbl_moveresize_size)
	GUICtrlDelete($btn_moveresize_plus)
	GUICtrlDelete($btn_moveresize_apply)
	GUICtrlDelete($btn_moveresize_defaults)
	GUICtrlDelete($btn_moveresize_close)
	$btn_moveresize_minus = GUICtrlCreateButton("-", (($new_width - 100) / 2) - 35, (($new_height - 100) / 2) - 25, 20, 20)
	$lbl_moveresize_size = GUICtrlCreateLabel("size", (($new_width - 100) / 2) - 15, (($new_height - 100) / 2) - 22, 30, 20, 1)
	$btn_moveresize_plus = GUICtrlCreateButton("+", (($new_width - 100) / 2) + 15, (($new_height - 100) / 2) - 25, 20, 20)
	$btn_moveresize_apply = GUICtrlCreateButton("Apply", (($new_width - 100) / 2) - 100, (($new_height - 100) / 2) + 5, 60, 25)
	$btn_moveresize_defaults = GUICtrlCreateButton("Defaults", (($new_width - 100) / 2) - 30, (($new_height - 100) / 2) + 5, 60, 25)
	$btn_moveresize_close = GUICtrlCreateButton("Close", (($new_width - 100) / 2) + 40, (($new_height - 100) / 2) + 5, 60, 25)
	GUICtrlSetOnEvent($btn_moveresize_minus, "MoveResize_Minus")
	GUICtrlSetOnEvent($btn_moveresize_plus, "MoveResize_Plus")
	GUICtrlSetOnEvent($btn_moveresize_apply, "MoveResize_Apply")
	GUICtrlSetOnEvent($btn_moveresize_defaults, "MoveResize_Defaults")
	GUICtrlSetOnEvent($btn_moveresize_close, "MoveResize_Close")
	ControlFocus($frm_moveresize, "", $btn_moveresize_minus)
	MouseMove((($new_width - 100) / 2) - 30, (($new_height - 100) / 2) - 20, 0)
EndFunc

Func moveresize_plus()
	Local $frm_moveresize_pos = WinGetPos($frm_moveresize)
	Local $new_width = $frm_moveresize_pos[2]
	Local $new_height = $frm_moveresize_pos[3]
	If ($new_height > @DesktopHeight) OR ($new_width > @DesktopWidth) Then Return
	WinMove($frm_moveresize, "", Default, Default, $new_width + 100, $new_height + 100)
	GUICtrlDelete($btn_moveresize_minus)
	GUICtrlDelete($lbl_moveresize_size)
	GUICtrlDelete($btn_moveresize_plus)
	GUICtrlDelete($btn_moveresize_apply)
	GUICtrlDelete($btn_moveresize_defaults)
	GUICtrlDelete($btn_moveresize_close)
	$btn_moveresize_minus = GUICtrlCreateButton("-", (($new_width + 100) / 2) - 35, (($new_height + 100) / 2) - 25, 20, 20)
	$lbl_moveresize_size = GUICtrlCreateLabel("size", (($new_width + 100) / 2) - 15, (($new_height + 100) / 2) - 22, 30, 20, 1)
	$btn_moveresize_plus = GUICtrlCreateButton("+", (($new_width + 100) / 2) + 15, (($new_height + 100) / 2) - 25, 20, 20)
	$btn_moveresize_apply = GUICtrlCreateButton("Apply", (($new_width + 100) / 2) - 100, (($new_height + 100) / 2) + 5, 60, 25)
	$btn_moveresize_defaults = GUICtrlCreateButton("Defaults", (($new_width + 100) / 2) - 30, (($new_height + 100) / 2) + 5, 60, 25)
	$btn_moveresize_close = GUICtrlCreateButton("Close", (($new_width + 100) / 2) + 40, (($new_height + 100) / 2) + 5, 60, 25)
	GUICtrlSetOnEvent($btn_moveresize_minus, "MoveResize_Minus")
	GUICtrlSetOnEvent($btn_moveresize_plus, "MoveResize_Plus")
	GUICtrlSetOnEvent($btn_moveresize_apply, "MoveResize_Apply")
	GUICtrlSetOnEvent($btn_moveresize_defaults, "MoveResize_Defaults")
	GUICtrlSetOnEvent($btn_moveresize_close, "MoveResize_Close")
	ControlFocus($frm_moveresize, "", $btn_moveresize_plus)
	MouseMove((($new_width + 100) / 2) + 20, (($new_height + 100) / 2) - 20, 0)
EndFunc

Func moveresize_apply()
	Local $new_window_pos = WinGetPos($frm_moveresize)
	Local $new_x = $new_window_pos[0]
	Local $new_y = $new_window_pos[1]
	$width = $new_window_pos[2]
	$height = $new_window_pos[3]
	$player_position = ($width - 5) / 2
	$scale = $player_position / 100
	WinMove($frm_radar, "", $new_x, $new_y, $width, $height)
	gdi_update_size()
EndFunc

Func moveresize_defaults()
	$width = Int(@DesktopHeight / 2 / 100) * 100 + 105
	$height = Int(@DesktopHeight / 2 / 100) * 100 + 105
	$player_position = ($width - 5) / 2
	$scale = $player_position / 100
	WinMove($frm_radar, "", 5, 5, $width, $height)
	gdi_update_size()
	moveresize_close()
	gui_move_resize()
EndFunc

Func moveresize_close()
	GUIDelete($frm_moveresize)
	$frm_moveresize = 0
EndFunc

Func loadconfig()
	$settings_x = IniRead($ini_path, "Position", "Settings_X", "Default")
	$settings_y = IniRead($ini_path, "Position", "Settings_Y", "Default")
	If $settings_x = "Default" Then $settings_x = -1
	If $settings_y = "Default" Then $settings_y = -1
	$radar_x = IniRead($ini_path, "Position", "Radar_X", "Default")
	$radar_y = IniRead($ini_path, "Position", "Radar_Y", "Default")
	$width = IniRead($ini_path, "Position", "Radar_Width", "Default")
	$height = IniRead($ini_path, "Position", "Radar_Height", "Default")
	If $radar_x = "Default" Then $radar_x = 5
	If $radar_y = "Default" Then $radar_y = 5
	If $width = "Default" Then $width = Int(@DesktopHeight / 2 / 100) * 100 + 105
	If $height = "Default" Then $height = Int(@DesktopHeight / 2 / 100) * 100 + 105
	$player_position = ($width - 5) / 2
	$scale = $player_position / 100
	$filter_enabled = IniRead($ini_path, "Filter", "Filter_Enabled", "False")
	$filter_partial_enabled = IniRead($ini_path, "Filter", "Filter_Partial_Enabled", "False")
	$filter_name[0] = IniRead($ini_path, "Filter", "Filter_Name_0", "")
	$filter_name[1] = IniRead($ini_path, "Filter", "Filter_Name_1", "")
	$filter_name[2] = IniRead($ini_path, "Filter", "Filter_Name_2", "")
	If $filter_enabled = "True" Then
		$filter_enabled = True
	ElseIf $filter_enabled = "False" Then
		$filter_enabled = False
	EndIf
	If $filter_partial_enabled = "True" Then
		$filter_partial_enabled = True
	ElseIf $filter_partial_enabled = "False" Then
		$filter_partial_enabled = False
	EndIf
	$showplayer = IniRead($ini_path, "Icons", "ShowPlayer", "True")
	$draw_player_heading = IniRead($ini_path, "Icons", "Draw_Player_Heading", "True")
	$showuser_friendly = IniRead($ini_path, "Icons", "ShowUser_Friendly", "True")
	$showuser_enemy = IniRead($ini_path, "Icons", "ShowUser_Enemy", "True")
	$shownpc_friendly = IniRead($ini_path, "Icons", "ShowNPC_Friendly", "True")
	$shownpc_neutral = IniRead($ini_path, "Icons", "ShowNPC_Neutral", "True")
	$shownpc_aggresive = IniRead($ini_path, "Icons", "ShowNPC_Aggresive", "True")
	$showgather = IniRead($ini_path, "Icons", "ShowGather", "True")
	If $showplayer = "True" Then
		$showplayer = True
	ElseIf $showplayer = "False" Then
		$showplayer = False
	EndIf
	If $draw_player_heading = "True" Then
		$draw_player_heading = True
	ElseIf $draw_player_heading = "False" Then
		$draw_player_heading = False
	EndIf
	If $showuser_friendly = "True" Then
		$showuser_friendly = True
	ElseIf $showuser_friendly = "False" Then
		$showuser_friendly = False
	EndIf
	If $showuser_enemy = "True" Then
		$showuser_enemy = True
	ElseIf $showuser_enemy = "False" Then
		$showuser_enemy = False
	EndIf
	If $shownpc_friendly = "True" Then
		$shownpc_friendly = True
	ElseIf $shownpc_friendly = "False" Then
		$shownpc_friendly = False
	EndIf
	If $shownpc_neutral = "True" Then
		$shownpc_neutral = True
	ElseIf $shownpc_neutral = "False" Then
		$shownpc_neutral = False
	EndIf
	If $shownpc_aggresive = "True" Then
		$shownpc_aggresive = True
	ElseIf $shownpc_aggresive = "False" Then
		$shownpc_aggresive = False
	EndIf
	If $showgather = "True" Then
		$showgather = True
	ElseIf $showgather = "False" Then
		$showgather = False
	EndIf
	$player_icon_size = IniRead($ini_path, "Icons", "Player_icon_size", 7)
	$player_icon_offset = Int($player_icon_size / 2)
	$user_friendly_icon_size = IniRead($ini_path, "Icons", "User_Friendly_icon_size", 7)
	$user_friendly_icon_offset = Int($user_friendly_icon_size / 2)
	$user_enemy_icon_size = IniRead($ini_path, "Icons", "User_Enemy_icon_size", 7)
	$user_enemy_icon_offset = Int($user_enemy_icon_size / 2)
	$npc_friendly_icon_size = IniRead($ini_path, "Icons", "NPC_Friendly_icon_size", 7)
	$npc_friendly_icon_offset = Int($npc_friendly_icon_size / 2)
	$npc_neutral_icon_size = IniRead($ini_path, "Icons", "NPC_Neutral_icon_size", 7)
	$npc_neutral_icon_offset = Int($npc_neutral_icon_size / 2)
	$npc_aggresive_icon_size = IniRead($ini_path, "Icons", "NPC_Aggresive_icon_size", 7)
	$npc_aggresive_icon_offset = Int($npc_aggresive_icon_size / 2)
	$gather_icon_size = IniRead($ini_path, "Icons", "Gather_icon_size", 7)
	$gather_icon_offset = Int($gather_icon_size / 2)
	$playerlabel = IniRead($ini_path, "Labels", "PlayerLabel", "True")
	$userlabels_friendly = IniRead($ini_path, "Labels", "UserLabels_Friendly", "True")
	$userlabels_enemy = IniRead($ini_path, "Labels", "UserLabels_Enemy", "True")
	$npclabels_friendly = IniRead($ini_path, "Labels", "NPCLabels_Friendly", "False")
	$npclabels_neutral = IniRead($ini_path, "Labels", "NPCLabels_Neutral", "False")
	$npclabels_aggresive = IniRead($ini_path, "Labels", "NPCLabels_Aggresive", "False")
	$gatherlabels = IniRead($ini_path, "Labels", "GatherLabels", "False")
	If $playerlabel = "True" Then
		$playerlabel = True
	ElseIf $playerlabel = "False" Then
		$playerlabel = False
	EndIf
	If $userlabels_friendly = "True" Then
		$userlabels_friendly = True
	ElseIf $userlabels_friendly = "False" Then
		$userlabels_friendly = False
	EndIf
	If $userlabels_enemy = "True" Then
		$userlabels_enemy = True
	ElseIf $userlabels_enemy = "False" Then
		$userlabels_enemy = False
	EndIf
	If $npclabels_friendly = "True" Then
		$npclabels_friendly = True
	ElseIf $npclabels_friendly = "False" Then
		$npclabels_friendly = False
	EndIf
	If $npclabels_neutral = "True" Then
		$npclabels_neutral = True
	ElseIf $npclabels_neutral = "False" Then
		$npclabels_neutral = False
	EndIf
	If $npclabels_aggresive = "True" Then
		$npclabels_aggresive = True
	ElseIf $npclabels_aggresive = "False" Then
		$npclabels_aggresive = False
	EndIf
	If $gatherlabels = "True" Then
		$gatherlabels = True
	ElseIf $gatherlabels = "False" Then
		$gatherlabels = False
	EndIf
	$player_string_size = IniRead($ini_path, "Labels", "Player_string_size", 7)
	$player_string_offset_x = IniRead($ini_path, "Labels", "Player_string_offset_x", -15)
	$player_string_offset_y = IniRead($ini_path, "Labels", "Player_string_offset_y", 2)
	$user_friendly_string_size = IniRead($ini_path, "Labels", "User_Friendly_string_size", 7)
	$user_friendly_string_offset_x = IniRead($ini_path, "Labels", "User_Friendly_string_offset_x", -15)
	$user_friendly_string_offset_y = IniRead($ini_path, "Labels", "User_Friendly_string_offset_y", 2)
	$user_enemy_string_size = IniRead($ini_path, "Labels", "User_Enemy_string_size", 7)
	$user_enemy_string_offset_x = IniRead($ini_path, "Labels", "User_Enemy_string_offset_x", -15)
	$user_enemy_string_offset_y = IniRead($ini_path, "Labels", "User_Enemy_string_offset_y", 2)
	$npc_friendly_string_size = IniRead($ini_path, "Labels", "NPC_Friendly_string_size", 7)
	$npc_friendly_string_offset_x = IniRead($ini_path, "Labels", "NPC_Friendly_string_offset_x", -15)
	$npc_friendly_string_offset_y = IniRead($ini_path, "Labels", "NPC_Friendly_string_offset_y", 2)
	$npc_neutral_string_size = IniRead($ini_path, "Labels", "NPC_Neutral_string_size", 7)
	$npc_neutral_string_offset_x = IniRead($ini_path, "Labels", "NPC_Neutral_string_offset_x", -15)
	$npc_neutral_string_offset_y = IniRead($ini_path, "Labels", "NPC_Neutral_string_offset_y", 2)
	$npc_aggresive_string_size = IniRead($ini_path, "Labels", "NPC_Aggresive_string_size", 7)
	$npc_aggresive_string_offset_x = IniRead($ini_path, "Labels", "NPC_Aggresive_string_offset_x", -15)
	$npc_aggresive_string_offset_y = IniRead($ini_path, "Labels", "NPC_Aggresive_string_offset_y", 2)
	$gather_string_size = IniRead($ini_path, "Labels", "Gather_string_size", 7)
	$gather_string_offset_x = IniRead($ini_path, "Labels", "Gather_string_offset_x", -15)
	$gather_string_offset_y = IniRead($ini_path, "Labels", "Gather_string_offset_y", 2)
EndFunc

Func saveconfig()
	Local $windowpos
	Local $windowsize
	$windowpos = WinGetPos($frm_settings)
	IniWrite($ini_path, "Position", "Settings_X", $windowpos[0])
	IniWrite($ini_path, "Position", "Settings_Y", $windowpos[1])
	$windowpos = WinGetPos($frm_radar)
	IniWrite($ini_path, "Position", "Radar_X", $windowpos[0])
	IniWrite($ini_path, "Position", "Radar_Y", $windowpos[1])
	;If NOT $donator Then
		;$windowsize = WinGetClientSize($frm_radar)
		;IniWrite($ini_path, "Position", "Radar_Width", $windowsize[0])
		;IniWrite($ini_path, "Position", "Radar_Height", $windowsize[1])
	;EndIf
	;If $donator Then
		IniWrite($ini_path, "Position", "Radar_Width", $windowpos[2])
		IniWrite($ini_path, "Position", "Radar_Height", $windowpos[3])
	;EndIf
	IniWrite($ini_path, "Filter", "Filter_Enabled", $filter_enabled)
	IniWrite($ini_path, "Filter", "Filter_Partial_Enabled", $filter_partial_enabled)
	IniWrite($ini_path, "Filter", "Filter_Name_0", $filter_name[0])
	IniWrite($ini_path, "Filter", "Filter_Name_1", $filter_name[1])
	IniWrite($ini_path, "Filter", "Filter_Name_2", $filter_name[2])
	IniWrite($ini_path, "Icons", "ShowPlayer", $showplayer)
	IniWrite($ini_path, "Icons", "Draw_Player_Heading", $draw_player_heading)
	IniWrite($ini_path, "Icons", "ShowUser_Friendly", $showuser_friendly)
	IniWrite($ini_path, "Icons", "ShowUser_Enemy", $showuser_enemy)
	IniWrite($ini_path, "Icons", "ShowNPC_Friendly", $shownpc_friendly)
	IniWrite($ini_path, "Icons", "ShowNPC_Neutral", $shownpc_neutral)
	IniWrite($ini_path, "Icons", "ShowNPC_Aggresive", $shownpc_aggresive)
	IniWrite($ini_path, "Icons", "ShowGather", $showgather)
	IniWrite($ini_path, "Icons", "Player_icon_size", $player_icon_size)
	IniWrite($ini_path, "Icons", "User_Friendly_icon_size", $user_friendly_icon_size)
	IniWrite($ini_path, "Icons", "User_Enemy_icon_size", $user_enemy_icon_size)
	IniWrite($ini_path, "Icons", "NPC_Friendly_icon_size", $npc_friendly_icon_size)
	IniWrite($ini_path, "Icons", "NPC_Neutral_icon_size", $npc_neutral_icon_size)
	IniWrite($ini_path, "Icons", "NPC_Aggresive_icon_size", $npc_aggresive_icon_size)
	IniWrite($ini_path, "Icons", "Gather_icon_size", $gather_icon_size)
	IniWrite($ini_path, "Labels", "PlayerLabel", $playerlabel)
	IniWrite($ini_path, "Labels", "UserLabels_Friendly", $userlabels_friendly)
	IniWrite($ini_path, "Labels", "UserLabels_Enemy", $userlabels_enemy)
	IniWrite($ini_path, "Labels", "NPCLabels_Friendly", $npclabels_friendly)
	IniWrite($ini_path, "Labels", "NPCLabels_Neutral", $npclabels_neutral)
	IniWrite($ini_path, "Labels", "NPCLabels_Aggresive", $npclabels_aggresive)
	IniWrite($ini_path, "Labels", "GatherLabels", $gatherlabels)
	IniWrite($ini_path, "Labels", "Player_string_size", $player_string_size)
	IniWrite($ini_path, "Labels", "Player_string_offset_x", $player_string_offset_x)
	IniWrite($ini_path, "Labels", "Player_string_offset_y", $player_string_offset_y)
	IniWrite($ini_path, "Labels", "User_Friendly_string_size", $user_friendly_string_size)
	IniWrite($ini_path, "Labels", "User_Friendly_string_offset_x", $user_friendly_string_offset_x)
	IniWrite($ini_path, "Labels", "User_Friendly_string_offset_y", $user_friendly_string_offset_y)
	IniWrite($ini_path, "Labels", "User_Enemy_string_size", $user_enemy_string_size)
	IniWrite($ini_path, "Labels", "User_Enemy_string_offset_x", $user_enemy_string_offset_x)
	IniWrite($ini_path, "Labels", "User_Enemy_string_offset_y", $user_enemy_string_offset_y)
	IniWrite($ini_path, "Labels", "NPC_Friendly_string_size", $npc_friendly_string_size)
	IniWrite($ini_path, "Labels", "NPC_Friendly_string_offset_x", $npc_friendly_string_offset_x)
	IniWrite($ini_path, "Labels", "NPC_Friendly_string_offset_y", $npc_friendly_string_offset_y)
	IniWrite($ini_path, "Labels", "NPC_Neutral_string_size", $npc_neutral_string_size)
	IniWrite($ini_path, "Labels", "NPC_Neutral_string_offset_x", $npc_neutral_string_offset_x)
	IniWrite($ini_path, "Labels", "NPC_Neutral_string_offset_y", $npc_neutral_string_offset_y)
	IniWrite($ini_path, "Labels", "NPC_Aggresive_string_size", $npc_aggresive_string_size)
	IniWrite($ini_path, "Labels", "NPC_Aggresive_string_offset_x", $npc_aggresive_string_offset_x)
	IniWrite($ini_path, "Labels", "NPC_Aggresive_string_offset_y", $npc_aggresive_string_offset_y)
	IniWrite($ini_path, "Labels", "Gather_string_size", $gather_string_size)
	IniWrite($ini_path, "Labels", "Gather_string_offset_x", $gather_string_offset_x)
	IniWrite($ini_path, "Labels", "Gather_string_offset_y", $gather_string_offset_y)
EndFunc

Func get_uuid()
	Local $pid
	Local $sread = ""
	$pid = Run(@ComSpec & " /c wmic csproduct get UUID", @SystemDir, @SW_HIDE, 2)
	While 1
		$sread &= StdoutRead($pid)
		If @error Then ExitLoop
	WEnd
	$sread = StringReplace($sread, @CR, "")
	$sread = StringReplace($sread, @LF, "")
	$sread = StringTrimLeft($sread, 4)
	$sread = StringStripWS($sread, 8)
	Return $sread
EndFunc

Func setup_gdi()
	_gdiplus_startup()
	$gra_map = _gdiplus_graphicscreatefromhwnd($frm_radar)
	_gdiplus_graphicsclear($gra_map, 0)
	$backbuffer_bitmap = _gdiplus_bitmapcreatefromgraphics($width, $height, $gra_map)
	$backbuffer = _gdiplus_imagegetgraphicscontext($backbuffer_bitmap)
	$screendc = _winapi_getdc($frm_radar)
	$gdibitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($backbuffer_bitmap)
	$dc = _winapi_createcompatibledc($screendc)
	_winapi_selectobject($dc, $gdibitmap)
	$tsize = DllStructCreate($tagsize)
	$psize = DllStructGetPtr($tsize)
	DllStructSetData($tsize, "X", $width)
	DllStructSetData($tsize, "Y", $height)
	$tsource = DllStructCreate($tagpoint)
	$psource = DllStructGetPtr($tsource)
	$tblend = DllStructCreate($tagblendfunction)
	$pblend = DllStructGetPtr($tblend)
	DllStructSetData($tblend, "Alpha", $alpha)
	DllStructSetData($tblend, "Format", 1)
	$tpoint = DllStructCreate($tagpoint)
	$ppoint = DllStructGetPtr($tpoint)
	DllStructSetData($tpoint, "X", 0)
	DllStructSetData($tpoint, "Y", 0)
	$hbrush = _gdiplus_brushcreatesolid()
	$hformat = _gdiplus_stringformatcreate()
	$hfamily = _gdiplus_fontfamilycreate("Arial")
	$hfont = _gdiplus_fontcreate($hfamily, 22, 0)
EndFunc

Func draw_player()
	$player_data[0] = player_get_name()
	$player_data[1] = player_get_pos_x()
	$player_data[2] = player_get_pos_y()
	$player_data[3] = player_get_pos_z()
	$player_data[4] = target_get_guid()
	_gdiplus_brushsetsolidcolor($hbrush, $color_bg_trans + $color_bg)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 0, 2 * $player_position, 2 * $player_position, $hbrush)
	_gdiplus_graphicsdrawellipse($backbuffer, 0, 0, 2 * $player_position, 2 * $player_position)
	If NOT $showplayer Then Return
	_gdiplus_brushsetsolidcolor($hbrush, $color_player)
	_gdiplus_graphicsfillellipse($backbuffer, $player_position - $player_icon_offset, $player_position - $player_icon_offset, $player_icon_size, $player_icon_size, $hbrush)
	If $playerlabel Then _gdiplus_graphicsdrawstring($backbuffer, $player_data[0], $player_position + $player_string_offset_x, $player_position + $player_string_offset_y, "Arial", $player_string_size)
EndFunc

Func draw_player_heading()
	Local $alpha = player_get_pos_rotation()
	Local $beta
	Local $a
	Local $b
	Local $arrow_len = 30
	If NOT $draw_player_heading Then Return
	Select
		Case $alpha > 0 AND $alpha < 90
			$beta = 180 - ($alpha + 90)
			$a = Sin($alpha * 0.0174532925) * $arrow_len
			$b = Sin($beta * 0.0174532925) * $arrow_len
			_gdiplus_graphicsdrawline($backbuffer, $player_position, $player_position, $player_position - $b, $player_position + $a)
		Case $alpha > 90 AND $alpha < 180
			$alpha -= 90
			$beta = 180 - ($alpha + 90)
			$a = Sin($alpha * 0.0174532925) * $arrow_len
			$b = Sin($beta * 0.0174532925) * $arrow_len
			_gdiplus_graphicsdrawline($backbuffer, $player_position, $player_position, $player_position + $a, $player_position + $b)
		Case $alpha < 0 AND $alpha > -90
			$beta = 180 - (Abs($alpha) + 90)
			$a = Sin($alpha * 0.0174532925) * $arrow_len
			$b = Sin($beta * 0.0174532925) * $arrow_len
			_gdiplus_graphicsdrawline($backbuffer, $player_position, $player_position, $player_position - $b, $player_position + $a)
		Case $alpha < -90 AND $alpha > -180
			$alpha += 90
			$beta = 180 - (Abs($alpha) + 90)
			$a = Sin($alpha * 0.0174532925) * $arrow_len
			$b = Sin($beta * 0.0174532925) * $arrow_len
			_gdiplus_graphicsdrawline($backbuffer, $player_position, $player_position, $player_position - $a, $player_position - $b)
	EndSelect
EndFunc

Func draw_entity(ByRef Const $entity_type, ByRef Const $entity_data, ByRef Const $player_data)
	If $filter_enabled Then
		If NOT entity_on_namefilter($entity_data) Then Return
	EndIf
	Switch $entity_type
		Case "user"
			draw_user($entity_data, $player_data)
		Case "NPC"
			draw_npc($entity_data, $player_data)
		Case "Gather"
			draw_gather($entity_data, $player_data)
	EndSwitch
EndFunc

Func entity_on_namefilter($entity_data)
	If $filter_partial_enabled Then
		If StringInStr($entity_data[0], $filter_name[0]) Then Return True
		If StringInStr($entity_data[0], $filter_name[1]) Then Return True
		If StringInStr($entity_data[0], $filter_name[2]) Then Return True
	Else
		If $entity_data[0] = $filter_name[0] Then Return True
		If $entity_data[0] = $filter_name[1] Then Return True
		If $entity_data[0] = $filter_name[2] Then Return True
	EndIf
	Return False
EndFunc

Func draw_user(ByRef Const $entity_data, ByRef Const $player_data)
	If $entity_data[4] = 38 Then
		$count[0] += 1
		If NOT $showuser_friendly Then Return
		_gdiplus_brushsetsolidcolor($hbrush, $color_user_friendly)
		_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $user_friendly_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $user_friendly_icon_offset, $user_friendly_icon_size, $user_friendly_icon_size, $hbrush)
		If $userlabels_friendly Then
			Local $string
			$string = $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m" & @CRLF & "lvl " & $user_data[1] & " - " & "HP: " & $user_data[2] & "%"
			_gdiplus_graphicsdrawstring($backbuffer, $string, $player_position + $scale * ($entity_data[2] - $player_data[2]) + $user_friendly_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $user_friendly_string_offset_y, "Arial", $user_friendly_string_size)
		EndIf
	ElseIf $entity_data[4] <> 38 Then
		$count[1] += 1
		If NOT $showuser_enemy Then Return
		_gdiplus_brushsetsolidcolor($hbrush, $color_user_enemy)
		_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $user_enemy_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $user_enemy_icon_offset, $user_enemy_icon_size, $user_enemy_icon_size, $hbrush)
		If $userlabels_enemy Then
			Local $string
			$string = $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m" & @CRLF & "lvl " & $user_data[1] & " - " & "HP: " & $user_data[2] & "%"
			_gdiplus_graphicsdrawstring($backbuffer, $string, $player_position + $scale * ($entity_data[2] - $player_data[2]) + $user_enemy_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $user_enemy_string_offset_y, "Arial", $user_enemy_string_size)
		EndIf
	EndIf
	If $entity_data[5] = $player_data[4] Then
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 3, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 3, 7, 7)
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 5, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 5, 11, 11)
	EndIf
EndFunc

Func draw_npc(ByRef Const $entity_data, ByRef Const $player_data)
	If $entity_data[4] = 0 Then
		$count[3] += 1
		If NOT $shownpc_neutral Then Return
		_gdiplus_brushsetsolidcolor($hbrush, $color_npc_neutral)
		_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $npc_neutral_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $npc_neutral_icon_offset, $npc_neutral_icon_size, $npc_neutral_icon_size, $hbrush)
		If $npclabels_neutral Then _gdiplus_graphicsdrawstring($backbuffer, $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m", $player_position + $scale * ($entity_data[2] - $player_data[2]) + $npc_friendly_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $npc_friendly_string_offset_y, "Arial", $npc_neutral_string_size)
	ElseIf $entity_data[4] = 8 Then
		$count[4] += 1
		If NOT $shownpc_aggresive Then Return
		_gdiplus_brushsetsolidcolor($hbrush, $color_npc_aggresive)
		_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $npc_aggresive_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $npc_aggresive_icon_offset, $npc_aggresive_icon_size, $npc_aggresive_icon_size, $hbrush)
		If $npclabels_aggresive Then _gdiplus_graphicsdrawstring($backbuffer, $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m", $player_position + $scale * ($entity_data[2] - $player_data[2]) + $npc_aggresive_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $npc_aggresive_string_offset_y, "Arial", $npc_aggresive_string_size)
	ElseIf $entity_data[4] = 38 Then
		$count[2] += 1
		If NOT $shownpc_friendly Then Return
		_gdiplus_brushsetsolidcolor($hbrush, $color_npc_friendly)
		_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $npc_friendly_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $npc_friendly_icon_offset, $npc_friendly_icon_size, $npc_friendly_icon_size, $hbrush)
		If $npclabels_friendly Then _gdiplus_graphicsdrawstring($backbuffer, $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m", $player_position + $scale * ($entity_data[2] - $player_data[2]) + $npc_friendly_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $npc_friendly_string_offset_y, "Arial", $npc_friendly_string_size)
	EndIf
	If $entity_data[5] = $player_data[4] Then
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 3, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 3, 7, 7)
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 5, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 5, 11, 11)
	EndIf
EndFunc

Func draw_gather(ByRef Const $entity_data, ByRef Const $player_data)
	$count[5] += 1
	If NOT $showgather Then Return
	_gdiplus_brushsetsolidcolor($hbrush, $color_gather)
	_gdiplus_graphicsfillellipse($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - $gather_icon_offset, $player_position + $scale * ($entity_data[1] - $player_data[1]) - $gather_icon_offset, $gather_icon_size, $gather_icon_size, $hbrush)
	If $gatherlabels Then _gdiplus_graphicsdrawstring($backbuffer, $entity_data[0] & " - " & get_entity_player_distance($entity_data, $player_data) & "m", $player_position + $scale * ($entity_data[2] - $player_data[2]) + $gather_string_offset_x, $player_position + $scale * ($entity_data[1] - $player_data[1]) + $gather_string_offset_y, "Arial", $gather_string_size)
	If $entity_data[5] = $player_data[4] Then
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 3, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 3, 7, 7)
		_gdiplus_graphicsdrawrect($backbuffer, $player_position + $scale * ($entity_data[2] - $player_data[2]) - 5, $player_position + $scale * ($entity_data[1] - $player_data[1]) - 5, 11, 11)
	EndIf
EndFunc

Func draw_sig()
	_gdiplus_graphicsdrawstring($backbuffer, "140%Radar", 0, 0, "Arial", 13)
EndFunc

Func draw_counts()
	_gdiplus_brushsetsolidcolor($hbrush, $color_user_friendly)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 35, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[0], 10, 30, "Arial", 10)
	_gdiplus_brushsetsolidcolor($hbrush, $color_user_enemy)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 50, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[1], 10, 45, "Arial", 10)
	_gdiplus_brushsetsolidcolor($hbrush, $color_npc_friendly)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 70, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[2], 10, 65, "Arial", 10)
	_gdiplus_brushsetsolidcolor($hbrush, $color_npc_neutral)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 85, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[3], 10, 80, "Arial", 10)
	_gdiplus_brushsetsolidcolor($hbrush, $color_npc_aggresive)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 100, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[4], 10, 95, "Arial", 10)
	_gdiplus_brushsetsolidcolor($hbrush, $color_gather)
	_gdiplus_graphicsfillellipse($backbuffer, 0, 120, 7, 7, $hbrush)
	_gdiplus_graphicsdrawstring($backbuffer, $count[5], 10, 115, "Arial", 10)
EndFunc

Func draw_fps($param1)
	Local $fps
	$fps = Round(1000 / $param1)
	_gdiplus_graphicsdrawstring($backbuffer, "fps: " & $fps, 80, 30, "Arial", 9)
EndFunc

Func draw_debug()
EndFunc

Func draw_on_screen()
		$gdibitmap = _gdiplus_bitmapcreatehbitmapfrombitmap($backbuffer_bitmap)
		_winapi_selectobject($dc, $gdibitmap)
		_winapi_updatelayeredwindow($frm_radar, $screendc, 0, $psize, $dc, $psource, 0, $pblend, 2)
		_winapi_deleteobject($gdibitmap)
		_gdiplus_graphicsclear($backbuffer, 0)
EndFunc

Func gdi_update_size()
	_gdiplus_bitmapdispose($backbuffer_bitmap)
	$backbuffer_bitmap = _gdiplus_bitmapcreatefromgraphics($width, $height, $gra_map)
	_gdiplus_graphicsdispose($backbuffer)
	$backbuffer = _gdiplus_imagegetgraphicscontext($backbuffer_bitmap)
	DllStructSetData($tsize, "X", $width)
	DllStructSetData($tsize, "Y", $height)
EndFunc

Func gdi_cleanup()
	_gdiplus_graphicsdispose($gra_map)
	_gdiplus_bitmapdispose($backbuffer_bitmap)
	_gdiplus_graphicsdispose($backbuffer)
	_winapi_deleteobject($gdibitmap)
	_winapi_deletedc($dc)
	_winapi_releasedc($frm_radar, $screendc)
	_gdiplus_brushdispose($hbrush)
	_gdiplus_stringformatdispose($hformat)
	_gdiplus_fontfamilydispose($hfamily)
	_gdiplus_fontdispose($hfont)
EndFunc

Func traverse_entitychain()
	Local $first_node
	Local $next_node
	Local $entity_pointer
	Local $entity_type
	$nodelists_start_address = get_nodelists_start_address()
	$first_node = "0x" & Hex(_memoryread($nodelists_start_address, $client_memory_hndl, "uint"), 8)
	$entity_pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($first_node) + 12, 8), $client_memory_hndl, "uint"), 8)
	$next_node = $first_node
	$entity_dictionary.removeall()
	While True
		If $entity_pointer <> "0x00000000" AND $entity_pointer <> "0xCDCDCDCD" Then
			$entity_type = entity_get_type($entity_pointer)
		Else
			Return
		EndIf
		If $entity_type = "User" OR $entity_type = "NPC" OR $entity_type = "Gather" Then
			If $entity_dictionary.exists($entity_pointer) Then Return
			$entity_dictionary.add($entity_pointer, $entity_type)
			$entity_data[0] = entity_get_name($entity_pointer)
			$entity_data[1] = entity_get_pos_x($entity_pointer)
			$entity_data[2] = entity_get_pos_y($entity_pointer)
			$entity_data[3] = entity_get_pos_z($entity_pointer)
			$entity_data[4] = entity_get_attitude($entity_pointer)
			$entity_data[5] = entity_get_guid($entity_pointer)
			If $entity_type = "User" Then
				$user_data[1] = entity_get_level($entity_pointer)
				$user_data[2] = entity_get_hppercent($entity_pointer)
			EndIf
			draw_entity($entity_type, $entity_data, $player_data)
		EndIf
		$next_node = "0x" & Hex(_memoryread("0x" & Hex(Int($next_node) + 0, 8), $client_memory_hndl, "uint"), 8)
		$entity_pointer = "0x" & Hex(_memoryread("0x" & Hex(Int($next_node) + 12, 8), $client_memory_hndl, "uint"), 8)
	WEnd
EndFunc

Func get_entity_player_distance(ByRef Const $entity_data, ByRef Const $player_data)
	Local $xd = $player_data[1] - $entity_data[1]
	Local $yd = $player_data[2] - $entity_data[2]
	Local $zd = $player_data[3] - $entity_data[3]
	Local $distance = Round(Sqrt($xd * $xd + $yd * $yd + $zd * $zd), 1)
	Return $distance
EndFunc

Func togglepause()
	Local $previousgui
	$radar_paused = NOT $radar_paused
	If $radar_paused Then
		$previousgui = GUISwitch($frm_radar)
		$pause_label = GUICtrlCreateLabel("Paused", 0, ($height / 2) - 45, $width, 90, 1)
		GUICtrlSetFont($pause_label, 50, 800, 0, "MS Reference Sans Serif")
		GUICtrlSetBkColor($pause_label, $gui_bkcolor_transparent)
		GUISwitch($previousgui)
		While True
			Sleep(100)
			If NOT $radar_paused Then Return
		WEnd
	Else
		$previousgui = GUISwitch($frm_radar)
		$pause_label = GUICtrlDelete($pause_label)
		GUISwitch($previousgui)
	EndIf
EndFunc

Func gui_exit()
	saveconfig()
	gdi_cleanup()
	_gdiplus_shutdown()
	_memoryclose($client_pid)
	Exit
EndFunc

Local $timer_hndl
loadconfig()
setup_gui()
While True
	$timer_hndl = TimerInit()
	For $i = 0 To (UBound($count) - 1)
		$count[$i] = 0
	Next
	draw_player()
	traverse_entitychain()
	draw_player_heading()
	draw_sig()
	draw_counts()
	draw_fps(TimerDiff($timer_hndl))
	draw_on_screen()
WEnd
